+++++++++++
Python News
+++++++++++

What's New in Python 3.7.7 final?
=================================

*Release date: 2020-03-10*

Library
-------

- bpo-13487: Avoid a possible *"RuntimeError: dictionary changed size during
  iteration"* from :func:`inspect.getmodule` when it tried to loop through
  :attr:`sys.modules`.

Documentation
-------------

- bpo-17422: The language reference no longer restricts default class
  namespaces to dicts only.


What's New in Python 3.7.7 release candidate 1?
===============================================

*Release date: 2020-03-04*

Security
--------

- bpo-39401: Avoid unsafe load of ``api-ms-win-core-path-l1-1-0.dll`` at
  startup on Windows 7.

Core and Builtins
-----------------

- bpo-39776: Fix race condition where threads created by PyGILState_Ensure()
  could get a duplicate id.

  This affects consumers of tstate->id like the contextvar caching
  machinery, which could return invalid cached objects under heavy thread
  load (observed in embedded scenarios).

- bpo-39778: Fixed a crash due to incorrect handling of weak references in
  ``collections.OrderedDict`` classes. Patch by Pablo Galindo.

- bpo-39382: Fix a use-after-free in the single inheritance path of
  ``issubclass()``, when the ``__bases__`` of an object has a single
  reference, and so does its first item. Patch by Yonatan Goldschmidt.

- bpo-39606: Fix regression caused by fix for bpo-39386, that prevented
  calling ``aclose`` on an async generator that had already been closed or
  exhausted.

- bpo-39510: Fix segfault in ``readinto()`` method on closed BufferedReader.

- bpo-39453: Fixed a possible crash in :meth:`list.__contains__` when a list
  is changed during comparing items. Patch by Dong-hee Na.

- bpo-39427: Document all possibilities for the ``-X`` options in the
  command line help section. Patch by Pablo Galindo.

- bpo-39421: Fix possible crashes when operating with the functions in the
  :mod:`heapq` module and custom comparison operators.

- bpo-39386: Prevent double awaiting of async iterator.

- bpo-38588: Fix possible crashes in dict and list when calling
  :c:func:`PyObject_RichCompareBool`.

- bpo-39031: When parsing an "elif" node, lineno and col_offset of the node
  now point to the "elif" keyword and not to its condition, making it
  consistent with the "if" node. Patch by Lysandros Nikolaou.

- bpo-38610: Fix possible crashes in several list methods by holding strong
  references to list elements when calling
  :c:func:`PyObject_RichCompareBool`.

Library
-------

- bpo-39794: Add --without-decimal-contextvar build option.  This enables a
  thread-local rather than a coroutine local context.

- bpo-39769: The :func:`compileall.compile_dir` function's *ddir* parameter
  and the compileall command line flag `-d` no longer write the wrong
  pathname to the generated pyc file for submodules beneath the root of the
  directory tree being compiled.  This fixes a regression introduced with
  Python 3.5.

- bpo-30566: Fix :exc:`IndexError` when trying to decode an invalid string
  with punycode codec.

- bpo-39649: Remove obsolete check for `__args__` in
  bdb.Bdb.format_stack_entry.

- bpo-27657: The original fix for bpo-27657, "Fix urlparse() with numeric
  paths" (GH-16839) included in 3.7.6, inadvertently introduced a behavior
  change that broke several third-party packages relying on the original
  undefined parsing behavior. The change is reverted in 3.7.7, restoring the
  behavior of 3.7.5 and earlier releases.

- bpo-21016: The :mod:`pydoc` and :mod:`trace` modules now use the
  :mod:`sysconfig` module to get the path to the Python standard library, to
  support uncommon installation path like ``/usr/lib64/python3.9/`` on
  Fedora. Patch by Jan Matějek.

- bpo-39548: Fix handling of header in
  :class:`urllib.request.AbstractDigestAuthHandler` when the optional
  ``qop`` parameter is not present.

- bpo-39450: Striped whitespace from docstring before returning it from
  :func:`unittest.case.shortDescription`.

- bpo-39493: Mark ``typing.IO.closed`` as a property

- bpo-39485: Fix a bug in :func:`unittest.mock.create_autospec` that would
  complain about the wrong number of arguments for custom descriptors
  defined in an extension module returning functions.

- bpo-39430: Fixed race condition in lazy imports in :mod:`tarfile`.

- bpo-39389: Write accurate compression level metadata in :mod:`gzip`
  archives, rather than always signaling maximum compression.

- bpo-39274: ``bool(fraction.Fraction)`` now returns a boolean even if
  (numerator != 0) does not return a boolean (ex: numpy number).

- bpo-39242: Updated the Gmane domain from news.gmane.org to news.gmane.io
  which is used for examples of :class:`~nntplib.NNTP` news reader server
  and nntplib tests.

- bpo-39152: Fix ttk.Scale.configure([name]) to return configuration tuple
  for name or all options.  Giovanni Lombardo contributed part of the patch.

- bpo-39198: If an exception were to be thrown in `Logger.isEnabledFor`
  (say, by asyncio timeouts or stopit) , the `logging` global lock may not
  be released appropriately, resulting in deadlock.  This change wraps that
  block of code with `try...finally` to ensure the lock is released.

- bpo-39191: Perform a check for running loop before starting a new task in
  ``loop.run_until_complete()`` to fail fast; it prevents the side effect of
  new task spawning before exception raising.

- bpo-38871: Correctly parenthesize filter-based statements that contain
  lambda expressions in mod:`lib2to3`. Patch by Dong-hee Na.

- bpo-39142: A change was made to logging.config.dictConfig to avoid
  converting instances of named tuples to ConvertingTuple. It's assumed that
  named tuples are too specialised to be treated like ordinary tuples; if a
  user of named tuples requires ConvertingTuple functionality, they will
  have to implement that themselves in their named tuple class.

- bpo-38971: Open issue in the BPO indicated a desire to make the
  implementation of codecs.open() at parity with io.open(), which implements
  a try/except to assure file stream gets closed before an exception is
  raised.

- bpo-39057: :func:`urllib.request.proxy_bypass_environment` now ignores
  leading dots and no longer ignores a trailing newline.

- bpo-39056: Fixed handling invalid warning category in the -W option.  No
  longer import the re module if it is not needed.

- bpo-39055: :func:`base64.b64decode` with ``validate=True`` raises now a
  binascii.Error if the input ends with a single ``\n``.

- bpo-38878: Fixed __subclasshook__ of :class:`os.PathLike` to return a
  correct result upon inheritence. Patch by Bar Harel.

- bpo-35182: Fixed :func:`Popen.communicate` subsequent call crash when the
  child process has already closed any piped standard stream, but still
  continues to be running. Patch by Andriy Maletsky.

- bpo-38473: Use signature from inner mock for autospecced methods attached
  with :func:`unittest.mock.attach_mock`. Patch by Karthikeyan Singaravelan.

- bpo-38293: Add :func:`copy.copy` and :func:`copy.deepcopy` support to
  :func:`property` objects.

- bpo-37953: In :mod:`typing`, improved the ``__hash__`` and ``__eq__``
  methods for :class:`ForwardReferences`.

- bpo-36406: Handle namespace packages in :mod:`doctest`. Patch by
  Karthikeyan Singaravelan.

Documentation
-------------

- bpo-13790: Change 'string' to 'specification' in format doc.

- bpo-39530: Fix misleading documentation about mixed-type numeric
  comparisons.

- bpo-17422: The language reference now specifies restrictions on class
  namespaces. Adapted from a patch by Ethan Furman.

- bpo-39654: In pyclbr doc, update 'class' to 'module' where appropriate and
  add readmodule comment. Patch by Hakan Çelik.

- bpo-39392: Explain that when filling with turtle, overlap regions may be
  left unfilled.

- bpo-39381: Mention in docs that :func:`asyncio.get_event_loop` implicitly
  creates new event loop only if called from the main thread.

- bpo-38918: Add an entry for ``__module__`` in the "function" & "method"
  sections of the `inspect docs types and members table
  <https://docs.python.org/3/library/inspect.html#types-and-members>`_

- bpo-3530: In the :mod:`ast` module documentation, fix a misleading
  ``NodeTransformer`` example and add advice on when to use the
  ``fix_missing_locations`` function.

Tests
-----

- bpo-38546: Fix test_ressources_gced_in_workers() of
  test_concurrent_futures: explicitly stop the manager to prevent leaking a
  child process running in the background after the test completes.

Build
-----

- bpo-39144: The ctags and etags build targets both include Modules/_ctypes
  and Python standard library source files.

Windows
-------

- bpo-38597: :mod:`distutils` will no longer statically link
  :file:`vcruntime140.dll` when a redistributable version is unavailable.
  All future releases of CPython will include a copy of this DLL to ensure
  distributed extensions can continue to load.

- bpo-38380: Update Windows builds to use SQLite 3.31.1

- bpo-39439: Reduce overhead when using multiprocessing in a Windows virtual
  environment

- bpo-39185: The build.bat script has additional options for very-quiet
  output (-q) and very-verbose output (-vv)

macOS
-----

- bpo-38380: Update macOS builds to use SQLite 3.31.1

IDLE
----

- bpo-39781: Selecting code context lines no longer causes a jump.

- bpo-39663: Add tests for pyparse find_good_parse_start().

- bpo-39600: In the font configuration window, remove duplicated font names.

- bpo-30780: Add remaining configdialog tests for buttons and highlights and
  keys tabs.

- bpo-39388: IDLE Settings Cancel button now cancels pending changes

- bpo-39050: Make IDLE Settings dialog Help button work again.

- bpo-34118: Tag memoryview, range, and tuple as classes, the same as list,
  etcetera, in the library manual built-in functions list.

- bpo-38792: Close an IDLE shell calltip if a :exc:`KeyboardInterrupt` or
  shell restart occurs.  Patch by Zackery Spytz.

- bpo-32989: Add tests for editor newline_and_indent_event method. Remove
  dead code from pyparse find_good_parse_start method.


What's New in Python 3.7.6 final?
=================================

*Release date: 2019-12-18*

macOS
-----

- bpo-38295: Prevent failure of test_relative_path in test_py_compile on
  macOS Catalina.


What's New in Python 3.7.6 release candidate 1?
===============================================

*Release date: 2019-12-11*

Security
--------

- bpo-38945: Newline characters have been escaped when performing uu
  encoding to prevent them from overflowing into to content section of the
  encoded file. This prevents malicious or accidental modification of data
  during the decoding process.

- bpo-37228: Due to significant security concerns, the *reuse_address*
  parameter of :meth:`asyncio.loop.create_datagram_endpoint` is no longer
  supported. This is because of the behavior of ``SO_REUSEADDR`` in UDP. For
  more details, see the documentation for
  ``loop.create_datagram_endpoint()``. (Contributed by Kyle Stanley, Antoine
  Pitrou, and Yury Selivanov in :issue:`37228`.)

- bpo-38804: Fixes a ReDoS vulnerability in :mod:`http.cookiejar`. Patch by
  Ben Caller.

Core and Builtins
-----------------

- bpo-38673: In REPL mode, don't switch to PS2 if the line starts with
  comment or whitespace. Based on work by Batuhan Taşkaya.

- bpo-38535: Fixed line numbers and column offsets for AST nodes for calls
  without arguments in decorators.

- bpo-38379: When cyclic garbage collection (gc) runs finalizers that
  resurrect unreachable objects, the current gc run ends, without collecting
  any cyclic trash.  However, the statistics reported by ``collect()`` and
  ``get_stats()`` claimed that all cyclic trash found was collected, and
  that the resurrected objects were collected.   Changed the stats to report
  that none were collected.

- bpo-35409: Ignore GeneratorExit exceptions when throwing an exception into
  the aclose coroutine of an asynchronous generator.

Library
-------

- bpo-39006: Fix asyncio when the ssl module is missing: only check for
  ssl.SSLSocket instance if the ssl module is available.

- bpo-38979: Return class from ``ContextVar.__class_getitem__`` to simplify
  subclassing.

- bpo-38986: Make repr of C accelerated TaskWakeupMethWrapper the same as of
  pure Python version.

- bpo-33684: Fix ``json.tool`` failed to read a JSON file with non-ASCII
  characters when locale encoding is not UTF-8.

- bpo-26730: Fix ``SpooledTemporaryFile.rollover()`` might corrupt the file
  when it is in text mode. Patch by Serhiy Storchaka.

- bpo-37838: :meth:`typing.get_type_hints` properly handles functions
  decorated with :meth:`functools.wraps`.

- bpo-38821: Fix unhandled exceptions in :mod:`argparse` when
  internationalizing error messages for arguments with ``nargs`` set to
  special (non-integer) values. Patch by Federico Bond.

- bpo-38820: Make Python compatible with OpenSSL 3.0.0.
  :func:`ssl.SSLSocket.getpeercert` no longer returns IPv6 addresses with a
  trailing new line.

- bpo-38785: Prevent asyncio from crashing if parent ``__init__`` is not
  called from a constructor of object derived from ``asyncio.Future``.

- bpo-27805: Allow opening pipes and other non-seekable files in append mode
  with :func:`open`.

- bpo-38686: Added support for multiple ``qop`` values in
  :class:`urllib.request.AbstractDigestAuthHandler`.

- bpo-38334: Fixed seeking backward on an encrypted
  :class:`zipfile.ZipExtFile`.

- bpo-31202: The case the result of :func:`pathlib.WindowsPath.glob` matches
  now the case of the pattern for literal parts.

- bpo-38109: Add missing :data:`stat.S_IFDOOR`, :data:`stat.S_IFPORT`,
  :data:`stat.S_IFWHT`, :func:`stat.S_ISDOOR`, :func:`stat.S_ISPORT`, and
  :func:`stat.S_ISWHT` values to the Python implementation of :mod:`stat`.

- bpo-38422: Clarify docstrings of pathlib suffix(es)

- bpo-38405: Nested subclasses of :class:`typing.NamedTuple` are now
  pickleable.

- bpo-38332: Prevent :exc:`KeyError` thrown by :func:`_encoded_words.decode`
  when given an encoded-word with invalid content-type encoding from
  propagating all the way to :func:`email.message.get`.

- bpo-38341: Add :exc:`smtplib.SMTPNotSupportedError` to the :mod:`smtplib`
  exported names.

- bpo-13153: OS native encoding is now used for converting between Python
  strings and Tcl objects.  This allows to display, copy and paste to
  clipboard emoji and other non-BMP characters.  Converting strings from Tcl
  to Python and back now never fails (except MemoryError).

- bpo-36993: Improve error reporting for corrupt zip files with bad zip64
  extra data. Patch by Daniel Hillier.

- bpo-36952: Starting with Python 3.3, importing ABCs from
  :mod:`collections` is deprecated, and import should be done from
  :mod:`collections.abc`. Still being able to import from :mod:`collections`
  was marked for removal in 3.8, but has been delayed to 3.9; documentation
  and ``DeprecationWarning`` clarified.

- bpo-36820: Break cycle generated when saving an exception in socket.py,
  codeop.py and dyld.py as they keep alive not only the exception but user
  objects through the ``__traceback__`` attribute. Patch by Mario Corchero.

- bpo-34776: Fix dataclasses to support forward references in type
  annotations

- bpo-33348: lib2to3 now recognizes expressions after ``*`` and `**` like in
  ``f(*[] or [])``.

- bpo-27657: Fix urllib.parse.urlparse() with numeric paths. A string like
  "path:80" is no longer parsed as a path but as a scheme ("path") and a
  path ("80").

Documentation
-------------

- bpo-38351: Modernize :mod:`email` examples from %-formatting to f-strings.

- bpo-38592: Add Brazilian Portuguese to the language switcher at Python
  Documentation website.

- bpo-38294: Add list of no-longer-escaped chars to re.escape documentation

Tests
-----

- bpo-38547: Fix test_pty: if the process is the session leader, closing the
  master file descriptor raises a SIGHUP signal: simply ignore SIGHUP when
  running the tests.

- bpo-38965: Fix test_faulthandler on GCC 10. Use the "volatile" keyword in
  ``faulthandler._stack_overflow()`` to prevent tail call optimization on
  any compiler, rather than relying on compiler specific pragma.

- bpo-38669: Raise :exc:`TypeError` when passing target as a string with
  :meth:`unittest.mock.patch.object`.

- bpo-35998: Fix a race condition in test_asyncio.test_start_tls_server_1().
  Previously, there was a race condition between the test main() function
  which replaces the protocol and the test ServerProto protocol which sends
  ANSWER once it gets HELLO. Now, only the test main() function is
  responsible to send data, ServerProto no longer sends data.

- bpo-37531: On timeout, regrtest no longer attempts to call
  ``popen.communicate()`` again: it can hang until all child processes using
  stdout and stderr pipes completes. Kill the worker process and ignores its
  output. Change also the faulthandler timeout of the main process from 1
  minute to 5 minutes, for Python slowest buildbots.

Build
-----

- bpo-37404: :mod:`asyncio` now raises :exc:`TyperError` when calling
  incompatible methods with an :class:`ssl.SSLSocket` socket.  Patch by Ido
  Michael.

- bpo-38809: On Windows, build scripts will now recognize and use python.exe
  from an active virtual env.

- bpo-37415: Fix stdatomic.h header check for ICC compiler: the ICC
  implementation lacks atomic_uintptr_t type which is needed by Python.

Windows
-------

- bpo-38589: Fixes HTML Help shortcut when Windows is not installed to C
  drive

IDLE
----

- bpo-38944: Excape key now closes IDLE completion windows.  Patch by Johnny
  Najera.

- bpo-38943: Fix IDLE autocomplete windows not always appearing on some
  systems. Patch by Johnny Najera.

- bpo-38862: 'Strip Trailing Whitespace' on the Format menu removes extra
  newlines at the end of non-shell files.

- bpo-26353: Stop adding newline when saving an IDLE shell window.

- bpo-38636: Fix IDLE Format menu tab toggle and file indent width. These
  functions (default shortcuts Alt-T and Alt-U) were mistakenly disabled in
  3.7.5 and 3.8.0.

- bpo-4630: Add an option to toggle IDLE's cursor blink for shell, editor,
  and output windows.  See Settings, General, Window Preferences, Cursor
  Blink. Patch by Zachary Spytz.

- bpo-38598: Do not try to compile IDLE shell or output windows

- bpo-36698: IDLE no longer fails when write non-encodable characters to
  stderr.  It now escapes them with a backslash, as the regular Python
  interpreter. Added the ``errors`` field to the standard streams.

Tools/Demos
-----------

- bpo-38118: Update Valgrind suppression file to ignore a false alarm in
  :c:func:`PyUnicode_Decode` when using GCC builtin strcmp().

- bpo-38347: pathfix.py: Assume all files that end on '.py' are Python
  scripts when working recursively.

C API
-----

- bpo-38540: Fixed possible leak in :c:func:`PyArg_Parse` and similar
  functions for format units ``"es#"`` and ``"et#"`` when the macro
  :c:macro:`PY_SSIZE_T_CLEAN` is not defined.

- bpo-38395: Fix a crash in :class:`weakref.proxy` objects due to incorrect
  lifetime management when calling some associated methods that may delete
  the last reference to object being referenced by the proxy. Patch by Pablo
  Galindo.


What's New in Python 3.7.5 final?
=================================

*Release date: 2019-10-14*

Library
-------

- bpo-38368: Prevent ctypes crash when handling arrays in structs/unions.

- bpo-38449: Revert GH-15522, which introduces a regression in
  :meth:`mimetypes.guess_type` due to improper handling of filenames as
  urls.

Windows
-------

- bpo-38344: Fix syntax in activate.bat.


What's New in Python 3.7.5 release candidate 1?
===============================================

*Release date: 2019-10-01*

Security
--------

- bpo-38243: Escape the server title of
  :class:`xmlrpc.server.DocXMLRPCServer` when rendering the document page as
  HTML. (Contributed by Dong-hee Na in :issue:`38243`.)

- bpo-38174: Update vendorized expat library version to 2.2.8, which
  resolves CVE-2019-15903.

- bpo-37764: Fixes email._header_value_parser.get_unstructured going into an
  infinite loop for a specific case in which the email header does not have
  trailing whitespace, and the case in which it contains an invalid encoded
  word. Patch by Ashwin Ramaswami.

- bpo-37461: Fix an infinite loop when parsing specially crafted email
  headers. Patch by Abhilash Raj.

- bpo-34155: Fix parsing of invalid email addresses with more than one ``@``
  (e.g. a@b@c.com.) to not return the part before 2nd ``@`` as valid email
  address. Patch by maxking & jpic.

Core and Builtins
-----------------

- bpo-36871: Improve error handling for the assert_has_calls method of
  mocks. Fixed a bug where any errors encountered while binding the expected
  calls to the mock's spec were silently swallowed, leading to misleading
  error output.

- bpo-38013: Allow to call ``async_generator_athrow().throw(...)`` even for
  non-started async generator helper. It fixes annoying warning at the end
  of :func:`asyncio.run` call.

- bpo-38124: Fix an off-by-one error in PyState_AddModule that could cause
  out-of-bounds memory access.

- bpo-36946: Fix possible signed integer overflow when handling slices.
  Patch by hongweipeng.

- bpo-37409: Ensure explicit relative imports from interactive sessions and
  scripts (having no parent package) always raise ImportError, rather than
  treating the current module as the package. Patch by Ben Lewis.

- bpo-36311: Decoding bytes objects larger than 2GiB is faster and no longer
  fails when a multibyte characters spans a chunk boundary.

- bpo-37467: Fix :func:`sys.excepthook` and :c:func:`PyErr_Display` if a
  filename is a bytes string. For example, for a SyntaxError exception where
  the filename attribute is a bytes string.

- bpo-37417: :meth:`bytearray.extend` now correctly handles errors that
  arise during iteration. Patch by Brandt Bucher.

- bpo-20523: ``pdb.Pdb`` supports ~/.pdbrc in Windows 7. Patch by Tim Hopper
  and Dan Lidral-Porter.

Library
-------

- bpo-38019: Correctly handle pause/resume reading of closed asyncio unix
  pipe.

- bpo-38216: Allow the rare code that wants to send invalid http requests
  from the `http.client` library a way to do so.  The fixes for bpo-30458
  led to breakage for some projects that were relying on this ability to
  test their own behavior in the face of bad requests.

- bpo-38191: Constructor of :class:`~typing.NamedTuple` type now accepts
  arbitrary keyword argument names, including "cls", "self", "typename" and
  "fields".

- bpo-38185: Fixed case-insensitive string comparison in
  :class:`sqlite3.Row` indexing.

- bpo-38175: Fix a memory leak in comparison of :class:`sqlite3.Row`
  objects.

- bpo-33936: _hashlib no longer calls obsolete OpenSSL initialization
  function with OpenSSL 1.1.0+.

- bpo-34706: Preserve subclassing in inspect.Signature.from_callable.

- bpo-38059: inspect.py now uses sys.exit() instead of exit()

- bpo-38006: weakref.WeakValueDictionary defines a local remove() function
  used as callback for weak references. This function was created with a
  closure. Modify the implementation to avoid the closure.

- bpo-34410: Fixed a crash in the :func:`tee` iterator when re-enter it.
  RuntimeError is now raised in this case.

- bpo-37965: Fix C compiler warning caused by
  distutils.ccompiler.CCompiler.has_function.

- bpo-36205: Fix the rusage implementation of time.process_time() to
  correctly report the sum of the system and user CPU time.

- bpo-22347: Update mimetypes.guess_type to allow proper parsing of URLs
  with only a host name. Patch by Dong-hee Na.

- bpo-37950: Fix :func:`ast.dump` when call with incompletely initialized
  node.

- bpo-37915: Fix a segmentation fault that appeared when comparing instances
  of ``datetime.timezone`` and ``datetime.tzinfo`` objects. Patch by Pablo
  Galindo.

- bpo-37885: venv: Don't generate unset variable warning on deactivate.

- bpo-37868: Fix dataclasses.is_dataclass when given an instance that never
  raises AttributeError in __getattr__.  That is, an object that returns
  something for __dataclass_fields__ even if it's not a dataclass.

- bpo-37811: Fix ``socket`` module's ``socket.connect(address)`` function
  being unable to establish connection in case of interrupted system call.
  The problem was observed on all OSes which ``poll(2)`` system call can
  take only non-negative integers and -1 as a timeout value.

- bpo-21131: Fix ``faulthandler.register(chain=True)`` stack. faulthandler
  now allocates a dedicated stack of ``SIGSTKSZ*2`` bytes, instead of just
  ``SIGSTKSZ`` bytes. Calling the previous signal handler in faulthandler
  signal handler uses more than ``SIGSTKSZ`` bytes of stack memory on some
  platforms.

- bpo-34621: Fixed unpickle-ability in older Python versions (<3.7) of UUID
  objects with ``is_safe`` set to ``SafeUUID.unknown``.

- bpo-37738: Fix the implementation of curses ``addch(str, color_pair)``:
  pass the color pair to ``setcchar()``, instead of always passing 0 as the
  color pair.

- bpo-37723: Fix performance regression on regular expression parsing with
  huge character sets. Patch by Yann Vaginay.

- bpo-32178: Fix IndexError in :mod:`email` package when trying to parse
  invalid address fields starting with ``:``.

- bpo-37685: Fixed comparisons of :class:`datetime.timedelta` and
  :class:`datetime.timezone`.

- bpo-37695: Correct :func:`curses.unget_wch` error message.  Patch by
  Anthony Sottile.

- bpo-29553: Fixed :meth:`argparse.ArgumentParser.format_usage` for mutually
  exclusive groups. Patch by Andrew Nester.

- bpo-37664: Update wheels bundled with ensurepip (pip 19.2.3 and setuptools
  41.2.0)

- bpo-37642: Allowed the pure Python implementation of
  :class:`datetime.timezone` to represent sub-minute offsets close to
  minimum and maximum boundaries, specifically in the ranges (23:59, 24:00)
  and (-23:59, 24:00). Patch by Ngalim Siregar

- bpo-37491: Fix ``IndexError`` when parsing email headers with unexpectedly
  ending bare-quoted string value. Patch by Abhilash Raj.

- bpo-18378: Recognize "UTF-8" as a valid value for LC_CTYPE in
  locale._parse_localename.

- bpo-37579: Return :exc:`NotImplemented` in Python implementation of
  ``__eq__`` for :class:`~datetime.timedelta` and :class:`~datetime.time`
  when the other object being compared is not of the same type to match C
  implementation. Patch by Karthikeyan Singaravelan.

- bpo-21478: Record calls to parent when autospecced object is attached to a
  mock using :func:`unittest.mock.attach_mock`. Patch by Karthikeyan
  Singaravelan.

- bpo-37531: "python3 -m test -jN --timeout=TIMEOUT" now kills a worker
  process if it runs longer than *TIMEOUT* seconds.

- bpo-37482: Fix serialization of display name in originator or destination
  address fields with both encoded words and special chars.

- bpo-37424: Fixes a possible hang when using a timeout on
  `subprocess.run()` while capturing output.  If the child process spawned
  its own children or otherwise connected its stdout or stderr handles with
  another process, we could hang after the timeout was reached and our child
  was killed when attempting to read final output from the pipes.

- bpo-37421: Fix :func:`multiprocessing.util.get_temp_dir` finalizer: clear
  also the 'tempdir' configuration of the current process, so next call to
  ``get_temp_dir()`` will create a new temporary directory, rather than
  reusing the removed temporary directory.

- bpo-37420: :func:`os.sched_setaffinity` now correctly handles errors that
  arise during iteration over its ``mask`` argument. Patch by Brandt Bucher.

- bpo-29412: Fix IndexError in parsing a header value ending unexpectedly.
  Patch by Abhilash Raj.

- bpo-37372: Fix error unpickling datetime.time objects from Python 2 with
  seconds>=24. Patch by Justin Blanchard.

- bpo-27860: Fix ``IPv4Interface`` and ``IPv6Interface`` didn't accept
  string mask when the argument is tuple.

- bpo-33972: Email with single part but content-type set to ``multipart/*``
  doesn't raise AttributeError anymore.

- bpo-21872: Fix :mod:`lzma`: module decompresses data incompletely. When
  decompressing a FORMAT_ALONE format file, and it doesn't have the end
  marker, sometimes the last one to dozens bytes can't be output. Patch by
  Ma Lin.

- bpo-12144: Ensure cookies with ``expires`` attribute are handled in
  :meth:`CookieJar.make_cookies`.

- bpo-37163: :func:`dataclasses.replace` now supports the field named "obj".

- bpo-36871: Ensure method signature is used instead of constructor
  signature of a class while asserting mock object against method calls.
  Patch by Karthikeyan Singaravelan.

- bpo-36564: Fix infinite loop in email header folding logic that would be
  triggered when an email policy's max_line_length is not long enough to
  include the required markup and any values in the message. Patch by Paul
  Ganssle

- bpo-35168: :attr:`shlex.shlex.punctuation_chars` is now a read-only
  property.

- bpo-20504: Fixes a bug in :mod:`cgi` module when a multipart/form-data
  request has no `Content-Length` header.

- bpo-4963: Fixed non-deterministic behavior related to mimetypes extension
  mapping and module reinitialization.

Documentation
-------------

- bpo-26868: Fix example usage of :c:func:`PyModule_AddObject` to properly
  handle errors.

- bpo-37979: Added a link to dateutil.parser.isoparse in the
  datetime.fromisoformat documentation. Patch by Paul Ganssle

- bpo-37937: Mention ``frame.f_trace`` in :func:`sys.settrace` docs.

- bpo-37726: Stop recommending getopt in the tutorial for command line
  argument parsing and promote argparse.

- bpo-32910: Remove implementation-specific behaviour of how venv's
  Deactivate works.

- bpo-37256: Fix wording of arguments for :class:`Request` in
  :mod:`urllib.request`

- bpo-37284: Add a brief note to indicate that any new
  ``sys.implementation`` required attributes must go through the PEP
  process.

- bpo-30088: Documented that :class:`mailbox.Maildir` constructor doesn't
  attempt to verify the maildir folder layout correctness. Patch by
  Sviatoslav Sydorenko.

- bpo-37487: Fix PyList_GetItem index description to include 0.

- bpo-37478: Added possible exceptions to the description of os.chdir().

- bpo-37004: In the documentation for difflib, a note was added explicitly
  warning that the results of SequenceMatcher's ratio method may depend on
  the order of the input strings.

- bpo-35803: Document and test that ``tempfile`` functions may accept a
  :term:`path-like object` for the ``dir`` argument.  Patch by Anthony
  Sottile.

- bpo-34293: Fix the Doc/Makefile regarding PAPER environment variable and
  PDF builds

Tests
-----

- bpo-38239: Fix test_gdb for Link Time Optimization (LTO) builds.

- bpo-38275: test_ssl now handles disabled TLS/SSL versions better.
  OpenSSL's crypto policy and run-time settings are recognized and tests for
  disabled versions are skipped. Tests also accept more TLS minimum_versions
  for platforms that override OpenSSL's default with strict settings.

- bpo-38271: The private keys for test_ssl were encrypted with 3DES in
  traditional PKCS#5 format. 3DES and the digest algorithm of PKCS#5 are
  blocked by some strict crypto policies. Use PKCS#8 format with AES256
  encryption instead.

- bpo-37123: Multiprocessing test test_mymanager() now also expects
  -SIGTERM, not only exitcode 0. BaseManager._finalize_manager() sends
  SIGTERM to the manager process if it takes longer than 1 second to stop,
  which happens on slow buildbots.

- bpo-38212: Multiprocessing tests: increase
  test_queue_feeder_donot_stop_onexc() timeout from 1 to 60 seconds.

- bpo-38117: Test with OpenSSL 1.1.1d

- bpo-37805: Add tests for json.dump(..., skipkeys=True). Patch by Dong-hee
  Na.

- bpo-37531: Enhance regrtest multiprocess timeout: write a message when
  killing a worker process, catch popen.kill() and popen.wait() exceptions,
  put a timeout on the second call to popen.communicate().

- bpo-37335: Improve locale coercion tests by using codec lookup instead of
  more fragile replace().

- bpo-37411: Fix test_wsgiref.testEnviron() to no longer depend on the
  environment variables (don't fail if "X" variable is set).

- bpo-37400: Fix test_os.test_chown(): use os.getgroups() rather than
  grp.getgrall() to get groups. Rename also the test to test_chown_gid().

- bpo-37359: Add --cleanup option to python3 -m test to remove
  ``test_python_*`` directories of previous failed jobs. Add "make
  cleantest" to run ``python3 -m test --cleanup``.

- bpo-37362: test_gdb no longer fails if it gets an "unexpected" message on
  stderr: it now ignores stderr. The purpose of test_gdb is to test that
  python-gdb.py commands work as expected, not to test gdb.

- bpo-36919: Make ``test_source_encoding.test_issue2301`` implementation
  independent. The test will work now for both CPython and IronPython.

- bpo-34720: Assert m_state != NULL to mimic GC traversal functions that do
  not correctly handle module creation when the module state has not been
  created.

- bpo-34347: Fix ``test_utf8_mode.test_cmd_line`` for AIX.  Patch by M. Felt

Build
-----

- bpo-38301: In Solaris family, we must be sure to use ``-D_REENTRANT``.
  Patch by Jesús Cea Avión.

- bpo-36002: Locate ``llvm-profdata`` and ``llvm-ar`` binaries using
  ``AC_PATH_TOOL`` rather than ``AC_PATH_TARGET_TOOL``.

- bpo-37936: The :file:`.gitignore` file no longer applies to any files that
  are in fact tracked in the Git repository.  Patch by Greg Price.

Windows
-------

- bpo-38117: Update bundled OpenSSL to 1.1.1d

- bpo-36634: venv activate.bat now works when the existing variables contain
  double quote characters.

- bpo-38087: Fix case sensitivity in test_pathlib and test_ntpath.

- bpo-38088: Fixes distutils not finding vcruntime140.dll with only the v142
  toolset installed.

- bpo-37283: Ensure command-line and unattend.xml setting override
  previously detected states in Windows installer.

- bpo-37705: Improve the implementation of ``winerror_to_errno()``.

- bpo-37549: :func:`os.dup` no longer fails for standard streams on Windows
  7.

- bpo-37702: Fix memory leak on Windows in creating an SSLContext object or
  running urllib.request.urlopen('https://...').

- bpo-10945: Officially drop support for creating bdist_wininst installers
  on non-Windows systems.

- bpo-37445: Include the ``FORMAT_MESSAGE_IGNORE_INSERTS`` flag in
  ``FormatMessageW()`` calls.

- bpo-37380: Don't collect unfinished processes with ``subprocess._active``
  on Windows to cleanup later. Patch by Ruslan Kuprieiev.

- bpo-32587: Make :data:`winreg.REG_MULTI_SZ` support zero-length strings.

macOS
-----

- bpo-38117: Updated OpenSSL to 1.1.1d in macOS installer.

- bpo-38089: Move Azure Pipelines to latest VM versions and make macOS tests
  optional

IDLE
----

- bpo-35379: When exiting IDLE, catch any AttributeError.  One happens when
  EditorWindow.close is called twice.  Printing a traceback, when IDLE is
  run from a terminal, is useless and annoying.

- bpo-38183: To avoid problems, test_idle ignores the user config directory.
  It no longer tries to create or access .idlerc or any files within. Users
  must run IDLE to discover problems with saving settings.

- bpo-38077: IDLE no longer adds 'argv' to the user namespace when
  initializing it.  This bug only affected 3.7.4 and 3.8.0b2 to 3.8.0b4.

- bpo-38041: Shell restart lines now fill the window width, always start
  with '=', and avoid wrapping unnecessarily. The line will still wrap if
  the included file name is long relative to the width.

- bpo-35771: To avoid occasional spurious test_idle failures on slower
  machines, increase the ``hover_delay`` in test_tooltip.

- bpo-37824: Properly handle user input warnings in IDLE shell. Cease
  turning SyntaxWarnings into SyntaxErrors.

- bpo-37929: IDLE Settings dialog now closes properly when there is no shell
  window.

- bpo-37902: Add mousewheel scrolling for IDLE module, path, and stack
  browsers. Patch by George Zhang.

- bpo-37849: Fixed completions list appearing too high or low when shown
  above the current line.

- bpo-36419: Refactor IDLE autocomplete and improve testing.

- bpo-37748: Reorder the Run menu.  Put the most common choice, Run Module,
  at the top.

- bpo-37692: Improve highlight config sample with example shell interaction
  and better labels for shell elements.

- bpo-37628: Settings dialog no longer expands with font size.

- bpo-37627: Initialize the Customize Run dialog with the command line
  arguments most recently entered before.  The user can optionally edit
  before submitting them.

- bpo-33610: Fix code context not showing the correct context when first
  toggled on.

- bpo-37530: Optimize code context to reduce unneeded background activity.
  Font and highlight changes now occur along with text changes instead of
  after a random delay.

- bpo-27452: Cleanup ``config.py`` by inlining ``RemoveFile`` and
  simplifying the handling of ``file`` in ``CreateConfigHandlers``.

- bpo-37325: Fix tab focus traversal order for help source and custom run
  dialogs.

- bpo-17535: Add optional line numbers for IDLE editor windows.  Windows
  open without line numbers unless set otherwise in the General tab of the
  configuration dialog.

- bpo-26806: To compensate for stack frames added by IDLE and avoid possible
  problems with low recursion limits, add 30 to limits in the user code
  execution process.  Subtract 30 when reporting recursion limits to make
  this addition mostly transparent.

- bpo-36390: Gather Format menu functions into format.py.  Combine
  paragraph.py, rstrip.py, and format methods from editor.py.

Tools/Demos
-----------

- bpo-37803: pdb's ``--help`` and ``--version`` long options now work.

- bpo-37675: 2to3 now works when run from a zipped standard library.


What's New in Python 3.7.4 final?
=================================

*Release date: 2019-07-08*

Core and Builtins
-----------------

- bpo-37500: Due to unintended side effects, revert the change introduced by
  :issue:`1875` in 3.7.4rc1 to check for syntax errors in dead conditional
  code blocks.

Documentation
-------------

- bpo-37149: Replace the dead link to the Tkinter 8.5 reference by John
  Shipman, New Mexico Tech, with a link to the archive.org copy.


What's New in Python 3.7.4 release candidate 2?
===============================================

*Release date: 2019-07-02*

Security
--------

- bpo-37463: ssl.match_hostname() no longer accepts IPv4 addresses with
  additional text after the address and only quad-dotted notation without
  trailing whitespaces. Some inet_aton() implementations ignore whitespace
  and all data after whitespace, e.g. '127.0.0.1 whatever'.

Core and Builtins
-----------------

- bpo-24214: Improved support of the surrogatepass error handler in the
  UTF-8 and UTF-16 incremental decoders.

Library
-------

- bpo-37440: http.client now enables TLS 1.3 post-handshake authentication
  for default context or if a cert_file is passed to HTTPSConnection.

- bpo-37437: Update vendorized expat version to 2.2.7.

- bpo-37428: SSLContext.post_handshake_auth = True no longer sets
  SSL_VERIFY_POST_HANDSHAKE verify flag for client connections. Although the
  option is documented as ignored for clients, OpenSSL implicitly enables
  cert chain validation when the flag is set.

- bpo-32627: Fix compile error when ``_uuid`` headers conflicting included.

Windows
-------

- bpo-37369: Fixes path for :data:`sys.executable` when running from the
  Microsoft Store.

- bpo-35360: Update Windows builds to use SQLite 3.28.0.

macOS
-----

- bpo-34602: Avoid test suite failures on macOS by no longer calling
  resource.setrlimit to increase the process stack size limit at runtime.
  The runtime change is no longer needed since the interpreter is being
  built with a larger default stack size.


What's New in Python 3.7.4 release candidate 1?
===============================================

*Release date: 2019-06-18*

Security
--------

- bpo-35907: CVE-2019-9948: Avoid file reading by disallowing
  ``local-file://`` and ``local_file://`` URL schemes in
  ``URLopener().open()`` and ``URLopener().retrieve()`` of
  :mod:`urllib.request`.

- bpo-36742: Fixes mishandling of pre-normalization characters in
  urlsplit().

- bpo-30458: Address CVE-2019-9740 by disallowing URL paths with embedded
  whitespace or control characters through into the underlying http client
  request.  Such potentially malicious header injection URLs now cause an
  http.client.InvalidURL exception to be raised.

- bpo-33529: Prevent fold function used in email header encoding from
  entering infinite loop when there are too many non-ASCII characters in a
  header.

- bpo-35755: :func:`shutil.which` now uses ``os.confstr("CS_PATH")`` if
  available and if the :envvar:`PATH` environment variable is not set.
  Remove also the current directory from :data:`posixpath.defpath`. On Unix,
  :func:`shutil.which` and the :mod:`subprocess` module no longer search the
  executable in the current directory if the :envvar:`PATH` environment
  variable is not set.

Core and Builtins
-----------------

- bpo-37269: Fix a bug in the peephole optimizer that was not treating
  correctly constant conditions with binary operators. Patch by Pablo
  Galindo.

- bpo-37219: Remove errorneous optimization for empty set differences.

- bpo-26423: Fix possible overflow in ``wrap_lenfunc()`` when ``sizeof(long)
  < sizeof(Py_ssize_t)`` (e.g., 64-bit Windows).

- bpo-36829: :c:func:`PyErr_WriteUnraisable` now displays the exception even
  if displaying the traceback failed. Moreover, hold a strong reference to
  :data:`sys.stderr` while using it. Document that an exception must be set
  when calling :c:func:`PyErr_WriteUnraisable`.

- bpo-36907: Fix a crash when calling a C function with a keyword dict
  (``f(**kwargs)``) and changing the dict ``kwargs`` while that function is
  running.

- bpo-36946: Fix possible signed integer overflow when handling slices.

- bpo-27987: ``PyGC_Head`` structure is aligned to ``long double``.  This is
  needed to ensure GC-ed objects are aligned properly.  Patch by Inada
  Naoki.

- bpo-1875: A :exc:`SyntaxError` is now raised if a code blocks that will be
  optimized away (e.g. if conditions that are always false) contains syntax
  errors. Patch by Pablo Galindo. (Reverted in 3.7.4 final by
  :issue:`37500`.)

- bpo-28866: Avoid caching attributes of classes which type defines mro() to
  avoid a hard cache invalidation problem.

- bpo-27639: Correct return type for UserList slicing operations. Patch by
  Michael Blahay, Erick Cervantes, and vaultah

- bpo-32849: Fix Python Initialization code on FreeBSD to detect properly
  when stdin file descriptor (fd 0) is invalid.

- bpo-27987: pymalloc returns memory blocks aligned by 16 bytes, instead of
  8 bytes, on 64-bit platforms to conform x86-64 ABI. Recent compilers
  assume this alignment more often. Patch by Inada Naoki.

- bpo-36504: Fix signed integer overflow in _ctypes.c's
  ``PyCArrayType_new()``.

- bpo-20844: Fix running script with encoding cookie and LF line ending may
  fail on Windows.

- bpo-24214: Fixed support of the surrogatepass error handler in the UTF-8
  incremental decoder.

- bpo-36459: Fix a possible double ``PyMem_FREE()`` due to tokenizer.c's
  ``tok_nextc()``.

- bpo-36433: Fixed TypeError message in classmethoddescr_call.

- bpo-36430: Fix a possible reference leak in :func:`itertools.count`.

- bpo-36440: Include node names in ``ParserError`` messages, instead of
  numeric IDs. Patch by A. Skrobov.

- bpo-36421: Fix a possible double decref in _ctypes.c's
  ``PyCArrayType_new()``.

- bpo-36256: Fix bug in parsermodule when parsing a state in a DFA that has
  two or more arcs with labels of the same type. Patch by Pablo Galindo.

- bpo-36236: At Python initialization, the current directory is no longer
  prepended to :data:`sys.path` if it has been removed.

- bpo-36262: Fix an unlikely memory leak on conversion from string to float
  in the function ``_Py_dg_strtod()`` used by ``float(str)``,
  ``complex(str)``, :func:`pickle.load`, :func:`marshal.load`, etc.

- bpo-36218: Fix a segfault occuring when sorting a list of heterogeneous
  values. Patch contributed by Rémi Lapeyre and Elliot Gorokhovsky.

- bpo-36035: Added fix for broken symlinks in combination with pathlib

- bpo-18372: Add missing :c:func:`PyObject_GC_Track` calls in the
  :mod:`pickle` module. Patch by Zackery Spytz.

- bpo-34408: Prevent a null pointer dereference and resource leakage in
  ``PyInterpreterState_New()``.

Library
-------

- bpo-37280: Use threadpool for reading from file for sendfile fallback
  mode.

- bpo-37279: Fix asyncio sendfile support when sendfile sends extra data in
  fallback mode.

- bpo-19865: :func:`ctypes.create_unicode_buffer()` now also supports
  non-BMP characters on platforms with 16-bit :c:type:`wchar_t` (for
  example, Windows and AIX).

- bpo-35922: Fix :meth:`RobotFileParser.crawl_delay` and
  :meth:`RobotFileParser.request_rate` to return ``None`` rather than raise
  :exc:`AttributeError` when no relevant rule is defined in the robots.txt
  file.  Patch by Rémi Lapeyre.

- bpo-36607: Eliminate :exc:`RuntimeError` raised by
  :func:`asyncio.all_tasks()` if internal tasks weak set is changed by
  another thread during iteration.

- bpo-36402: Fix a race condition at Python shutdown when waiting for
  threads. Wait until the Python thread state of all non-daemon threads get
  deleted (join all non-daemon threads), rather than just wait until
  non-daemon Python threads complete.

- bpo-34886: Fix an unintended ValueError from :func:`subprocess.run` when
  checking for conflicting `input` and `stdin` or `capture_output` and
  `stdout` or `stderr` args when they were explicitly provided but with
  `None` values within a passed in `**kwargs` dict rather than as passed
  directly by name. Patch contributed by Rémi Lapeyre.

- bpo-37173: The exception message for ``inspect.getfile()`` now correctly
  reports the passed class rather than the builtins module.

- bpo-12639: :meth:`msilib.Directory.start_component()` no longer fails if
  *keyfile* is not ``None``.

- bpo-36520: Lengthy email headers with UTF-8 characters are now properly
  encoded when they are folded. Patch by Jeffrey Kintscher.

- bpo-37054: Fix destructor :class:`_pyio.BytesIO` and
  :class:`_pyio.TextIOWrapper`: initialize their ``_buffer`` attribute as
  soon as possible (in the class body), because it's used by ``__del__()``
  which calls ``close()``.

- bpo-30835: Fixed a bug in email parsing where a message with invalid bytes
  in content-transfer-encoding of a multipart message can cause an
  AttributeError. Patch by Andrew Donnellan.

- bpo-37035: Don't log OSError based exceptions if a fatal error has
  occurred in asyncio transport. Peer can generate almost any OSError, user
  cannot avoid these exceptions by fixing own code. Errors are still
  propagated to user code, it's just logging them is pointless and pollute
  asyncio logs.

- bpo-37008: Add support for calling :func:`next` with the mock resulting
  from :func:`unittest.mock.mock_open`

- bpo-27737: Allow whitespace only header encoding in ``email.header`` - by
  Batuhan Taskaya

- bpo-36969: PDB command `args` now  display keyword only arguments. Patch
  contributed by Rémi Lapeyre.

- bpo-36983: Add missing names to ``typing.__all__``: ``ChainMap``,
  ``ForwardRef``, ``OrderedDict`` - by Anthony Sottile.

- bpo-21315: Email headers containing RFC2047 encoded words are parsed
  despite the missing whitespace, and a defect registered. Also missing
  trailing whitespace after encoded words is now registered as a defect.

- bpo-33524: Fix the folding of email header when the max_line_length is 0
  or None and the header contains non-ascii characters.  Contributed by
  Licht Takeuchi (@Licht-T).

- bpo-24564: :func:`shutil.copystat` now ignores :const:`errno.EINVAL` on
  :func:`os.setxattr` which may occur when copying files on filesystems
  without extended attributes support.

  Original patch by Giampaolo Rodola, updated by Ying Wang.

- bpo-36845: Added validation of integer prefixes to the construction of IP
  networks and interfaces in the ipaddress module.

- bpo-35545: Fix asyncio discarding IPv6 scopes when ensuring hostname
  resolutions internally

- bpo-35070: posix.getgrouplist() now works correctly when the user belongs
  to NGROUPS_MAX supplemental groups. Patch by Jeffrey Kintscher.

- bpo-24538: In `shutil.copystat()`, first copy extended file attributes and
  then file permissions, since extended attributes can only be set on the
  destination while it is still writeable.

- bpo-33110: Handle exceptions raised by functions added by
  concurrent.futures add_done_callback correctly when the Future has already
  completed.

- bpo-26903: Limit `max_workers` in `ProcessPoolExecutor` to 61 to work
  around a WaitForMultipleObjects limitation.

- bpo-36813: Fix :class:`~logging.handlers.QueueListener` to call
  ``queue.task_done()`` upon stopping. Patch by Bar Harel.

- bpo-36734: Fix compilation of ``faulthandler.c`` on HP-UX. Initialize
  ``stack_t current_stack`` to zero using ``memset()``.

- bpo-29183: Fix double exceptions in :class:`wsgiref.handlers.BaseHandler`
  by calling its :meth:`~wsgiref.handlers.BaseHandler.close` method only
  when no exception is raised.

- bpo-36650: The C version of functools.lru_cache() was treating calls with
  an empty ``**kwargs`` dictionary as being distinct from calls with no
  keywords at all. This did not result in an incorrect answer, but it did
  trigger an unexpected cache miss.

- bpo-28552: Fix :mod:`distutils.sysconfig` if :data:`sys.executable` is
  ``None`` or an empty string: use :func:`os.getcwd` to initialize
  ``project_base``.  Fix also the distutils build command: don't use
  :data:`sys.executable` if it is ``None`` or an empty string.

- bpo-35755: :func:`shutil.which` and
  :func:`distutils.spawn.find_executable` now use ``os.confstr("CS_PATH")``
  if available instead of :data:`os.defpath`, if the ``PATH`` environment
  variable is not set. Moreover, don't use ``os.confstr("CS_PATH")`` nor
  :data:`os.defpath` if the ``PATH`` environment variable is set to an empty
  string.

- bpo-36613: Fix :mod:`asyncio` wait() not removing callback if exception

- bpo-36598: Fix ``isinstance`` check for Mock objects with spec when the
  code is executed under tracing. Patch by Karthikeyan Singaravelan.

- bpo-36533: Reinitialize logging.Handler locks in forked child processes
  instead of attempting to acquire them all in the parent before forking
  only to be released in the child process.  The acquire/release pattern was
  leading to deadlocks in code that has implemented any form of chained
  logging handlers that depend upon one another as the lock acquision order
  cannot be guaranteed.

- bpo-36522: If *debuglevel* is set to >0 in :mod:`http.client`, print all
  values for headers with multiple values for the same header name. Patch by
  Matt Houglum.

- bpo-36492: Arbitrary keyword arguments (even with names "self" and "func")
  can now be passed to some functions which should accept arbitrary keyword
  arguments and pass them to other function (for example partialmethod(),
  TestCase.addCleanup() and Profile.runcall()) if the required arguments are
  passed as positional arguments.

- bpo-36434: Errors during writing to a ZIP file no longer prevent to
  properly close it.

- bpo-34745: Fix :mod:`asyncio` ssl memory issues caused by circular
  references

- bpo-36321: collections.namedtuple() misspelled the name of an attribute.
  To be consistent with typing.NamedTuple, the attribute name should have
  been "_field_defaults" instead of "_fields_defaults".  For backwards
  compatibility, both spellings are now created.  The misspelled version may
  be removed in the future.

- bpo-36272: :mod:`logging` does not silently ignore RecursionError anymore.
  Patch contributed by Rémi Lapeyre.

- bpo-36235: Fix ``CFLAGS`` in ``customize_compiler()`` of
  ``distutils.sysconfig``: when the ``CFLAGS`` environment variable is
  defined, don't override ``CFLAGS`` variable with the ``OPT`` variable
  anymore. Initial patch written by David Malcolm.

- bpo-35125: Asyncio: Remove inner callback on outer cancellation in shield

- bpo-35802: Clean up code which checked presence of ``os.stat`` /
  ``os.lstat`` / ``os.chmod`` which are always present.  Patch by Anthony
  Sottile.

- bpo-23078: Add support for :func:`classmethod` and :func:`staticmethod` to
  :func:`unittest.mock.create_autospec`.  Initial patch by Felipe Ochoa.

- bpo-35721: Fix :meth:`asyncio.SelectorEventLoop.subprocess_exec()` leaks
  file descriptors if ``Popen`` fails and called with
  ``stdin=subprocess.PIPE``. Patch by Niklas Fiekas.

- bpo-35726: QueueHandler.prepare() now makes a copy of the record before
  modifying and enqueueing it, to avoid affecting other handlers in the
  chain.

- bpo-31855: :func:`unittest.mock.mock_open` results now respects the
  argument of read([size]). Patch contributed by Rémi Lapeyre.

- bpo-35082: Don't return deleted attributes when calling dir on a
  :class:`unittest.mock.Mock`.

- bpo-34547: :class:`wsgiref.handlers.BaseHandler` now handles abrupt client
  connection terminations gracefully. Patch by Petter Strandmark.

- bpo-34424: Fix serialization of messages containing encoded strings when
  the policy.linesep is set to a multi-character string. Patch by Jens
  Troeger.

- bpo-33361: Fix a bug in :class:`codecs.StreamRecoder` where seeking might
  leave old data in a buffer and break subsequent read calls. Patch by Ammar
  Askar.

- bpo-31922: :meth:`asyncio.AbstractEventLoop.create_datagram_endpoint`: Do
  not connect UDP socket when broadcast is allowed. This allows to receive
  replies after a UDP broadcast.

- bpo-22102: Added support for ZIP files with disks set to 0. Such files are
  commonly created by builtin tools on Windows when use ZIP64 extension.
  Patch by Francisco Facioni.

- bpo-27141: Added a ``__copy__()`` to ``collections.UserList`` and
  ``collections.UserDict`` in order to correctly implement shallow copying
  of the objects. Patch by Bar Harel.

- bpo-31829: ``\r``, ``\0`` and ``\x1a`` (end-of-file on Windows) are now
  escaped in protocol 0 pickles of Unicode strings. This allows to load them
  without loss from files open in text mode in Python 2.

- bpo-31292: Fix ``setup.py check --restructuredtext`` for files containing
  ``include`` directives.

- bpo-23395: ``_thread.interrupt_main()`` now avoids setting the Python
  error status if the ``SIGINT`` signal is ignored or not handled by Python.

Documentation
-------------

- bpo-34903: Documented that in :meth:`datetime.datetime.strptime()`, the
  leading zero in some two-digit formats is optional. Patch by Mike Gleen.

- bpo-36984: Improve version added references in ``typing`` module - by
  Anthony Sottile.

- bpo-36868: What's new now mentions SSLContext.hostname_checks_common_name
  instead of SSLContext.host_flags.

- bpo-36783: Added C API Documentation for Time_FromTimeAndFold and
  PyDateTime_FromDateAndTimeAndFold as per PEP 495. Patch by Edison
  Abahurire.

- bpo-30840: Document relative imports

- bpo-36523: Add docstring for io.IOBase.writelines().

- bpo-36425: New documentation translation: `Simplified Chinese
  <https://docs.python.org/zh-cn/>`_.

- bpo-36157: Added Documention for  PyInterpreterState_Main().

- bpo-36138: Improve documentation about converting datetime.timedelta to
  scalars.

- bpo-22865: Add detail to the documentation on the `pty.spawn` function.

- bpo-35581: @typing.type_check_only now allows type stubs to mark functions
  and classes not available during runtime.

- bpo-35564: Explicitly set master_doc variable in conf.py for compliance
  with Sphinx 2.0

- bpo-10536: Enhance the gettext docs. Patch by Éric Araujo

- bpo-32995: Added the context variable in glossary.

- bpo-33832: Add glossary entry for 'magic method'.

- bpo-33482: Make `codecs.StreamRecoder.writelines` take a list of bytes.

- bpo-25735: Added documentation for func factorial to indicate that returns
  integer values

Tests
-----

- bpo-35998: Avoid TimeoutError in test_asyncio: test_start_tls_server_1()

- bpo-37153: ``test_venv.test_mutiprocessing()`` now explicitly calls
  ``pool.terminate()`` to wait until the pool completes.

- bpo-37081: Test with OpenSSL 1.1.1c

- bpo-36915: The main regrtest process now always removes all temporary
  directories of worker processes even if they crash or if they are killed
  on KeyboardInterrupt (CTRL+c).

- bpo-36719: "python3 -m test -jN ..." now continues the execution of next
  tests when a worker process crash (CHILD_ERROR state). Previously, the
  test suite stopped immediately. Use --failfast to stop at the first error.

- bpo-36816: Update Lib/test/selfsigned_pythontestdotnet.pem to match
  self-signed.pythontest.net's new TLS certificate.

- bpo-35925: Skip httplib and nntplib networking tests when they would
  otherwise fail due to a modern OS or distro with a default OpenSSL policy
  of rejecting connections to servers with weak certificates.

- bpo-36719: regrtest now always detects uncollectable objects. Previously,
  the check was only enabled by ``--findleaks``. The check now also works
  with ``-jN/--multiprocess N``. ``--findleaks`` becomes a deprecated alias
  to ``--fail-env-changed``.

- bpo-36725: When using mulitprocessing mode (-jN), regrtest now better
  reports errors if a worker process fails, and it exits immediately on a
  worker thread failure or when interrupted.

- bpo-36454: Change test_time.test_monotonic() to test only the lower bound
  of elapsed time after a sleep command rather than the upper bound. This
  prevents unnecessary test failures on slow buildbots. Patch by Victor
  Stinner.

- bpo-36629: Fix ``test_imap4_host_default_value()`` of ``test_imaplib``:
  catch also :data:`errno.ENETUNREACH` error.

- bpo-36611: Fix ``test_sys.test_getallocatedblocks()`` when
  :mod:`tracemalloc` is enabled.

- bpo-36560: Fix reference leak hunting in regrtest: compute also deltas (of
  reference count, allocated memory blocks, file descriptor count) during
  warmup, to ensure that everything is initialized before starting to hunt
  reference leaks.

- bpo-36565: Fix reference hunting (``python3 -m test -R 3:3``) when Python
  has no built-in abc module.

- bpo-36436: Fix ``_testcapi.pymem_buffer_overflow()``: handle memory
  allocation failure.

Build
-----

- bpo-36605: ``make tags`` and ``make TAGS`` now also parse
  ``Modules/_io/*.c`` and ``Modules/_io/*.h``.

- bpo-36508: ``python-config --ldflags`` no longer includes flags of the
  ``LINKFORSHARED`` variable. The ``LINKFORSHARED`` variable must only be
  used to build executables.

Windows
-------

- bpo-34631: Updated OpenSSL to 1.1.1c in Windows installer

- bpo-37267: On Windows, :func:`os.dup` no longer creates an inheritable fd
  when handling a character file.

- bpo-36779: Ensure ``time.tzname`` is correct on Windows when the active
  code page is set to CP_UTF7 or CP_UTF8.

- bpo-36965: include of STATUS_CONTROL_C_EXIT without depending on MSC
  compiler

- bpo-36649: Remove trailing spaces for registry keys when installed via the
  Store.

- bpo-34144: Fixed activate.bat to correctly update codepage when chcp.com
  returns dots in output. Patch by Lorenz Mende.

- bpo-35941: enum_certificates function of the ssl module now returns
  certificates from all available certificate stores inside windows in a
  query instead of returning only certificates from the system wide
  certificate store. This includes certificates from these certificate
  stores: local machine, local machine enterprise, local machine group
  policy, current user, current user group policy, services, users.
  ssl.enum_crls() function is changed in the same way to return all
  certificate revocation lists inside the windows certificate revocation
  list stores.

- bpo-36441: Fixes creating a venv when debug binaries are installed.

- bpo-36312: Fixed decoders for the following code pages: 50220, 50221,
  50222, 50225, 50227, 50229, 57002 through 57011, 65000 and 42.

- bpo-36010: Add the venv standard library module to the nuget distribution
  for Windows.

- bpo-34060: Report system load when running test suite on Windows. Patch by
  Ammar Askar. Based on prior work by Jeremy Kloth.

macOS
-----

- bpo-35360: Update macOS installer to use SQLite 3.28.0.

- bpo-34631: Updated OpenSSL to 1.1.1c in macOS installer.

- bpo-36231: Support building Python on macOS without /usr/include
  installed. As of macOS 10.14, system header files are only available
  within an SDK provided by either the Command Line Tools or the Xcode app.

- bpo-34602: Avoid failures setting macOS stack resource limit with
  resource.setrlimit. This reverts an earlier fix for bpo-18075 which forced
  a non-default stack size when building the interpreter executable on
  macOS.

IDLE
----

- bpo-37321: Both subprocess connection error messages now refer to the
  'Startup failure' section of the IDLE doc.

- bpo-37177: Properly 'attach' search dialogs to their main window so that
  they behave like other dialogs and do not get hidden behind their main
  window.

- bpo-37039: Adjust "Zoom Height" to individual screens by momemtarily
  maximizing the window on first use with a particular screen.  Changing
  screen settings may invalidate the saved height.  While a window is
  maximized, "Zoom Height" has no effect.

- bpo-35763: Make calltip reminder about '/' meaning positional-only less
  obtrusive by only adding it when there is room on the first line.

- bpo-5680: Add 'Run... Customized' to the Run menu to run a module with
  customized settings.  Any 'command line arguments' entered are added to
  sys.argv. One can suppress the normal Shell main module restart.

- bpo-35610: Replace now redundant .context_use_ps1 with .prompt_last_line.
  This finishes change started in bpo-31858.

- bpo-37038: Make idlelib.run runnable; add test clause.

- bpo-36958: Print any argument other than None or int passed to SystemExit
  or sys.exit().

- bpo-13102: When saving a file, call os.fsync() so bits are flushed to e.g.
  USB drive.

- bpo-36429: Fix starting IDLE with pyshell. Add idlelib.pyshell alias at
  top; remove pyshell alias at bottom. Remove obsolete __name__=='__main__'
  command.

- bpo-36405: Use dict unpacking in idlelib.

- bpo-36396: Remove fgBg param of idlelib.config.GetHighlight(). This param
  was only used twice and changed the return type.

- bpo-23205: For the grep module, add tests for findfiles, refactor
  findfiles to be a module-level function, and refactor findfiles to use
  os.walk.

- bpo-23216: Add docstrings to IDLE search modules.

- bpo-30348: Increase test coverage of idlelib.autocomplete by 30%.

- bpo-32411: In browser.py, remove extraneous sorting by line number since
  dictionary was created in line number order.

Tools/Demos
-----------

- bpo-14546: Fix the argument handling in Tools/scripts/lll.py.

- bpo-32217: Fix freeze script on Windows.

C API
-----

- bpo-28805: The :const:`METH_FASTCALL` calling convention has been
  documented.

- bpo-37170: Fix the cast on error in
  :c:func:`PyLong_AsUnsignedLongLongMask()`.

- bpo-36389: Change the value of ``CLEANBYTE``, ``DEADDYTE`` and
  ``FORBIDDENBYTE`` internal constants used by debug hooks on Python memory
  allocators (:c:func:`PyMem_SetupDebugHooks` function). Byte patterns
  ``0xCB``, ``0xDB`` and ``0xFB`` have been replaced with ``0xCD``, ``0xDD``
  and ``0xFD`` to use the same values than Windows CRT debug ``malloc()``
  and ``free()``.


What's New in Python 3.7.3 final?
=================================

*Release date: 2019-03-25*

There were no new changes in version 3.7.3.



What's New in Python 3.7.3 release candidate 1?
===============================================

*Release date: 2019-03-12*

Security
--------

- bpo-36216: Changes urlsplit() to raise ValueError when the URL contains
  characters that decompose under IDNA encoding (NFKC-normalization) into
  characters that affect how the URL is parsed.

- bpo-35746: [CVE-2019-5010] Fix a NULL pointer deref in ssl module. The
  cert parser did not handle CRL distribution points with empty DP or URI
  correctly. A malicious or buggy certificate can result into segfault.
  Vulnerability (TALOS-2018-0758) reported by Colin Read and Nicolas Edet of
  Cisco.

- bpo-35121: Don't send cookies of domain A without Domain attribute to
  domain B when domain A is a suffix match of domain B while using a
  cookiejar with :class:`http.cookiejar.DefaultCookiePolicy` policy. Patch
  by Karthikeyan Singaravelan.

Core and Builtins
-----------------

- bpo-35942: The error message emitted when returning invalid types from
  ``__fspath__`` in interfaces that allow passing :class:`~os.PathLike`
  objects has been improved and now it does explain the origin of the error.

- bpo-35992: Fix ``__class_getitem__()`` not being called on a class with a
  custom non-subscriptable metaclass.

- bpo-35991: Fix a potential double free in Modules/_randommodule.c.

- bpo-35961: Fix a crash in slice_richcompare(): use strong references
  rather than stolen references for the two temporary internal tuples.

- bpo-31506: Clarify the errors reported when ``object.__new__`` and
  ``object.__init__`` receive more than one argument. Contributed by Sanyam
  Khurana.

- bpo-35720: Fixed a minor memory leak in pymain_parse_cmdline_impl function
  in Modules/main.c

- bpo-35623: Fix a crash when sorting very long lists. Patch by Stephan
  Hohe.

- bpo-35214: clang Memory Sanitizer build instrumentation was added to work
  around false positives from posix, socket, time, test_io, and
  test_faulthandler.

- bpo-35560: Fix an assertion error in :func:`format` in debug build for
  floating point formatting with "n" format, zero padding and small width.
  Release build is not impacted. Patch by Karthikeyan Singaravelan.

- bpo-35552: Format characters ``%s`` and ``%V`` in
  :c:func:`PyUnicode_FromFormat` and ``%s`` in :c:func:`PyBytes_FromFormat`
  no longer read memory past the limit if *precision* is specified.

- bpo-35504: Fix segfaults and :exc:`SystemError`\ s when deleting certain
  attributes. Patch by Zackery Spytz.

- bpo-33989: Fix a possible crash in :meth:`list.sort` when sorting objects
  with ``ob_type->tp_richcompare == NULL``.  Patch by Zackery Spytz.

Library
-------

- bpo-35931: The :mod:`pdb` ``debug`` command now gracefully handles all
  exceptions.

- bpo-36251: Fix format strings used for stderrprinter and re.Match reprs.
  Patch by Stephan Hohe.

- bpo-35807: Update ensurepip to install pip 19.0.3 and setuptools 40.8.0.

- bpo-36179: Fix two unlikely reference leaks in _hashopenssl. The leaks
  only occur in out-of-memory cases.

- bpo-35178: Ensure custom :func:`warnings.formatwarning` function can
  receive `line` as positional argument. Based on patch by Tashrif Billah.

- bpo-36106: Resolve potential name clash with libm's sinpi(). Patch by
  Dmitrii Pasechnik.

- bpo-35512: :func:`unittest.mock.patch.dict` used as a decorator with
  string target resolves the target during function call instead of during
  decorator construction. Patch by Karthikeyan Singaravelan.

- bpo-36091: Clean up reference to async generator in Lib/types. Patch by
  Henry Chen.

- bpo-35899: Enum has been fixed to correctly handle empty strings and
  strings with non-Latin characters (ie. 'α', 'א') without crashing.
  Original patch contributed by Maxwell. Assisted by Stéphane Wirtel.

- bpo-35918: Removed broken ``has_key`` method from
  multiprocessing.managers.SyncManager.dict. Contributed by Rémi Lapeyre.

- bpo-35960: Fix :func:`dataclasses.field` throwing away empty mapping
  objects passed as metadata.

- bpo-35847: RISC-V needed the CTYPES_PASS_BY_REF_HACK.  Fixes ctypes
  Structure test_pass_by_value.

- bpo-35780: Fix lru_cache() errors arising in recursive, reentrant, or
  multi-threaded code. These errors could result in orphan links and in the
  cache being trapped in a state with fewer than the specified maximum
  number of links. Fix handling of negative maxsize which should have been
  treated as zero. Fix errors in toggling the "full" status flag. Fix
  misordering of links when errors are encountered.  Sync-up the C code and
  pure Python code for the space saving path in functions with a single
  positional argument. In this common case, the space overhead of an lru
  cache entry is reduced by almost half.  Fix counting of cache misses. In
  error cases, the miss count was out of sync with the actual number of
  times the underlying user function was called.

- bpo-23846: :class:`asyncio.ProactorEventLoop` now catches and logs send
  errors when the self-pipe is full.

- bpo-34323: :mod:`asyncio`: Enhance ``IocpProactor.close()`` log: wait 1
  second before the first log, then log every second. Log also the number of
  seconds since ``close()`` was called.

- bpo-34294: re module, fix wrong capturing groups in rare cases.
  :func:`re.search`, :func:`re.findall`, :func:`re.sub` and other functions
  that scan through string looking for a match, should reset capturing
  groups between two match attempts. Patch by Ma Lin.

- bpo-35717: Fix KeyError exception raised when using enums and compile.
  Patch contributed by Rémi Lapeyre.

- bpo-35699: Fixed detection of Visual Studio Build Tools 2017 in distutils

- bpo-32710: Fix memory leaks in asyncio ProactorEventLoop on overlapped
  operation failure.

- bpo-32710: Fix a memory leak in asyncio in the ProactorEventLoop when
  ``ReadFile()`` or ``WSASend()`` overlapped operation fail immediately:
  release the internal buffer.

- bpo-35682: Fix ``asyncio.ProactorEventLoop.sendfile()``: don't attempt to
  set the result of an internal future if it's already done.

- bpo-35283: Add a pending deprecated warning for the
  :meth:`threading.Thread.isAlive` method. Patch by Dong-hee Na.

- bpo-35643: Fixed a SyntaxWarning: invalid escape sequence in
  Modules/_sha3/cleanup.py. Patch by Mickaël Schoentgen.

- bpo-35615: :mod:`weakref`: Fix a RuntimeError when copying a
  WeakKeyDictionary or a WeakValueDictionary, due to some keys or values
  disappearing while iterating.

- bpo-28503: The `crypt` module now internally uses the `crypt_r()` library
  function instead of `crypt()` when available.

- bpo-35121: Don't set cookie for a request when the request path is a
  prefix match of the cookie's path attribute but doesn't end with "/".
  Patch by Karthikeyan Singaravelan.

- bpo-35585: Speed-up building enums by value, e.g. http.HTTPStatus(200).

- bpo-21478: Calls to a child function created with
  :func:`unittest.mock.create_autospec` should propagate to the parent.
  Patch by Karthikeyan Singaravelan.

- bpo-35513: :class:`~unittest.runner.TextTestRunner` of
  :mod:`unittest.runner` now uses :func:`time.perf_counter` rather than
  :func:`time.time` to measure the execution time of a test:
  :func:`time.time` can go backwards, whereas :func:`time.perf_counter` is
  monotonic.

- bpo-35502: Fixed reference leaks in
  :class:`xml.etree.ElementTree.TreeBuilder` in case of unfinished building
  of the tree (in particular when an error was raised during parsing XML).

- bpo-31446: Copy command line that was passed to CreateProcessW since this
  function can change the content of the input buffer.

- bpo-20239: Allow repeated assignment deletion of
  :class:`unittest.mock.Mock` attributes. Patch by Pablo Galindo.

- bpo-17185: Set ``__signature__`` on mock for :mod:`inspect` to get
  signature. Patch by Karthikeyan Singaravelan.

- bpo-10496: :func:`~distutils.utils.check_environ` of
  :mod:`distutils.utils` now catches :exc:`KeyError` on calling
  :func:`pwd.getpwuid`: don't create the ``HOME`` environment variable in
  this case.

- bpo-35066: Previously, calling the strftime() method on a datetime object
  with a trailing '%' in the format string would result in an exception.
  However, this only occured when the datetime C module was being used; the
  python implementation did not match this behavior. Datetime is now PEP-399
  compliant, and will not throw an exception on a trailing '%'.

- bpo-24746: Avoid stripping trailing whitespace in doctest fancy diff.
  Orignial patch by R. David Murray & Jairo Trad. Enhanced by Sanyam
  Khurana.

- bpo-35198: Fix C++ extension compilation on AIX

- bpo-28441: On Cygwin and MinGW, ensure that ``sys.executable`` always
  includes the full filename in the path, including the ``.exe`` suffix
  (unless it is a symbolic link).

- bpo-34572: Fix C implementation of pickle.loads to use importlib's locking
  mechanisms, and thereby avoid using partially-loaded modules. Patch by Tim
  Burgess.

- bpo-33687: Fix the call to ``os.chmod()`` for ``uu.decode()`` if a mode is
  given or decoded. Patch by Timo Furrer.

- bpo-32146: Document the interaction between frozen executables and the
  spawn and forkserver start methods in multiprocessing.

Documentation
-------------

- bpo-36083: Fix formatting of --check-hash-based-pycs options in the
  manpage Synopsis.

- bpo-34764: Improve example of iter() with 2nd sentinel argument.

- bpo-21314: A new entry was added to the Core Language Section of the
  Programming FAQ, which explaines the usage of slash(/) in the signature of
  a function. Patch by Lysandros Nikolaou

- bpo-22062: Update documentation and docstrings for pathlib. Original patch
  by Mike Short.

Tests
-----

- bpo-36234: test_posix.PosixUidGidTests: add tests for invalid uid/gid type
  (str). Initial patch written by David Malcolm.

- bpo-29571: Fix ``test_re.test_locale_flag()``:  use
  ``locale.getpreferredencoding()`` rather than ``locale.getlocale()`` to
  get the locale encoding. With some locales, ``locale.getlocale()`` returns
  the wrong encoding. On Windows, set temporarily the ``LC_CTYPE`` locale to
  the user preferred encoding to ensure that it uses the ANSI code page, to
  be consistent with ``locale.getpreferredencoding()``.

- bpo-36123: Fix race condition in test_socket.

- bpo-27313: Avoid test_ttk_guionly ComboboxTest failure with macOS Cocoa
  Tk.

- bpo-36019: Add test.support.TEST_HTTP_URL and replace references of
  http://www.example.com by this new constant. Contributed by Stéphane
  Wirtel.

- bpo-36037: Fix test_ssl for strict OpenSSL configuration like RHEL8 strict
  crypto policy. Use older TLS version for minimum TLS version of the server
  SSL context if needed, to test TLS version older than default minimum TLS
  version.

- bpo-35505: Make test_imap4_host_default_value independent on whether the
  local IMAP server is running.

- bpo-35917: multiprocessing: provide unit tests for SyncManager and
  SharedMemoryManager classes + all the shareable types which are supposed
  to be supported by them.  (patch by Giampaolo Rodola)

- bpo-35772: Fix sparse file tests of test_tarfile on ppc64 with the tmpfs
  filesystem. Fix the function testing if the filesystem supports sparse
  files: create a file which contains data and "holes", instead of creating
  a file which contains no data. tmpfs effective block size is a page size
  (tmpfs lives in the page cache). RHEL uses 64 KiB pages on aarch64, ppc64,
  ppc64le, only s390x and x86_64 use 4 KiB pages, whereas the test punch
  holes of 4 KiB.

- bpo-35045: Make ssl tests less strict and also accept TLSv1 as system
  default. The changes unbreaks test_min_max_version on Fedora 29.

- bpo-31731: Fix a race condition in ``check_interrupted_write()`` of
  test_io: create directly the thread with SIGALRM signal blocked, rather
  than blocking the signal later from the thread. Previously, it was
  possible that the thread gets the signal before the signal is blocked.

- bpo-35424: Fix test_multiprocessing_main_handling: use
  :class:`multiprocessing.Pool` with a context manager and then explicitly
  join the pool.

- bpo-35519: Rename :mod:`test.bisect` module to :mod:`test.bisect_cmd` to
  avoid conflict with :mod:`bisect` module when running directly a test like
  ``./python Lib/test/test_xmlrpc.py``.

- bpo-35513: Replace :func:`time.time` with :func:`time.monotonic` in tests
  to measure time delta.

- bpo-34279: :func:`test.support.run_unittest` no longer raise
  :exc:`TestDidNotRun` if the test result contains skipped tests. The
  exception is now only raised if no test have been run and no test have
  been skipped.

- bpo-35412: Add testcase to ``test_future4``: check unicode literal.

- bpo-26704: Added test demonstrating double-patching of an instance method.
  Patch by Anthony Sottile.

Build
-----

- bpo-34691: The _contextvars module is now built into the core Python
  library on Windows.

- bpo-35683: Improved Azure Pipelines build steps and now verifying layouts
  correctly

- bpo-35642: Remove asynciomodule.c from pythoncore.vcxproj

- bpo-35550: Fix incorrect Solaris #ifdef checks to look for __sun && __SVR4
  instead of sun when compiling.

Windows
-------

- bpo-24643: Fix name collisions due to ``#define timezone _timezone`` in
  PC/pyconfig.h.

- bpo-35692: ``pathlib`` no longer raises when checking file and directory
  existence on drives that are not ready

- bpo-35872: Uses the base Python executable when invoking venv in a virtual
  environment

- bpo-35873: Prevents venv paths being inherited by child processes

- bpo-35299: Fix sysconfig detection of the source directory and distutils
  handling of pyconfig.h during PGO profiling

- bpo-32560: The ``py`` launcher now forwards its ``STARTUPINFO`` structure
  to child processes.

- bpo-35854: Fix EnvBuilder and --symlinks in venv on Windows

- bpo-35811: Avoid propagating venv settings when launching via py.exe

- bpo-35797: Fix default executable used by the multiprocessing module

- bpo-29734: Fix handle leaks in os.stat on Windows.

- bpo-35596: Use unchecked PYCs for the embeddable distro to avoid zipimport
  restrictions.

- bpo-35596: Fix vcruntime140.dll being added to embeddable distro multiple
  times.

- bpo-35402: Update Windows build to use Tcl and Tk 8.6.9

- bpo-33316: PyThread_release_lock always fails

- bpo-1104: Correctly handle string length in
  ``msilib.SummaryInfo.GetProperty()`` to prevent it from truncating the
  last character.

IDLE
----

- bpo-36176: Fix IDLE autocomplete & calltip popup colors. Prevent conflicts
  with Linux dark themes (and slightly darken calltip background).

- bpo-36152: Remove colorizer.ColorDelegator.close_when_done and the
  corresponding argument of .close().  In IDLE, both have always been None
  or False since 2007.

- bpo-32129: Avoid blurry IDLE application icon on macOS with Tk 8.6. Patch
  by Kevin Walzer.

- bpo-24310: IDLE -- Document settings dialog font tab sample.

- bpo-36096: Refactor class variables to instance variables in colorizer.

- bpo-35833: Revise IDLE doc for control codes sent to Shell. Add a code
  example block.

- bpo-35770: IDLE macosx deletes Options => Configure IDLE. It previously
  deleted Window => Zoom Height by mistake. (Zoom Height is now on the
  Options menu).  On Mac, the settings dialog is accessed via Preferences on
  the IDLE menu.

- bpo-35769: Change IDLE's new file name from 'Untitled' to 'untitled'

- bpo-35689: Add docstrings and unittests for colorizer.py.

- bpo-35660: Fix imports in idlelib.window.

- bpo-35641: Proper format `calltip` when the function has no docstring.

- bpo-33987: Use ttk Frame for ttk widgets.

- bpo-34055: Fix erroneous 'smart' indents and newlines in IDLE Shell.

- bpo-35591: Find Selection now works when selection not found.

- bpo-35196: Speed up squeezer line counting.

- bpo-35598: Update config_key: use PEP 8 names and ttk widgets, make some
  objects global, and add tests.

- bpo-28097: Add Previous/Next History entries to Shell menu.

- bpo-35208: Squeezer now properly counts wrapped lines before newlines.

- bpo-35555: Gray out Code Context menu entry when it's not applicable.

- bpo-35521: Document the IDLE editor code context feature. Add some
  internal references within the IDLE doc.

- bpo-22703: The Code Context menu label now toggles between Show/Hide Code
  Context. The Zoom Height menu now toggles between Zoom/Restore Height.
  Zoom Height has moved from the Window menu to the Options menu.

Tools/Demos
-----------

- bpo-35132: Fix py-list and py-bt commands of python-gdb.py on gdb7.

C API
-----

- bpo-33817: Fixed :c:func:`_PyBytes_Resize` for empty bytes objects.


What's New in Python 3.7.2 final?
=================================

*Release date: 2018-12-23*

Library
-------

- bpo-31715: Associate ``.mjs`` file extension with
  ``application/javascript`` MIME Type.

Build
-----

- bpo-35499: ``make profile-opt`` no longer replaces ``CFLAGS_NODIST`` with
  ``CFLAGS``. It now adds profile-guided optimization (PGO) flags to
  ``CFLAGS_NODIST``: existing ``CFLAGS_NODIST`` flags are kept.

- bpo-35257: Avoid leaking the linker flags from Link Time Optimizations
  (LTO) into distutils when compiling C extensions.

C API
-----

- bpo-35259: Conditionally declare :c:func:`Py_FinalizeEx()` (new in 3.6)
  based on Py_LIMITED_API. Patch by Arthur Neufeld.


What's New in Python 3.7.2 release candidate 1?
===============================================

*Release date: 2018-12-11*

Security
--------

- bpo-34812: The :option:`-I` command line option (run Python in isolated
  mode) is now also copied by the :mod:`multiprocessing` and
  :mod:`distutils` modules when spawning child processes. Previously, only
  :option:`-E` and :option:`-s` options (enabled by :option:`-I`) were
  copied.

- bpo-34791: The xml.sax and xml.dom.domreg no longer use environment
  variables to override parser implementations when
  sys.flags.ignore_environment is set by -E or -I arguments.

Core and Builtins
-----------------

- bpo-35444: Fixed error handling in pickling methods when fail to look up
  builtin "getattr".

- bpo-35436: Fix various issues with memory allocation error handling.
  Patch by Zackery Spytz.

- bpo-35357: Internal attributes' names of unittest.mock._Call and
  unittest.mock.MagicProxy (name, parent & from_kall) are now prefixed with
  _mock_ in order to prevent clashes with widely used object attributes.
  Fixed minor typo in test function name.

- bpo-35372: Fixed the code page decoder for input longer than 2 GiB
  containing undecodable bytes.

- bpo-35336: Fix PYTHONCOERCECLOCALE=1 environment variable: only coerce the
  C locale if the LC_CTYPE locale is "C".

- bpo-33954: For :meth:`str.format`, :meth:`float.__format__` and
  :meth:`complex.__format__` methods for non-ASCII decimal point when using
  the "n" formatter.

- bpo-35269: Fix a possible segfault involving a newly-created coroutine.
  Patch by Zackery Spytz.

- bpo-35214: Fixed an out of bounds memory access when parsing a truncated
  unicode escape sequence at the end of a string such as ``'\N'``.  It would
  read one byte beyond the end of the memory allocation.

- bpo-35214: The interpreter and extension modules have had annotations
  added so that they work properly under clang's Memory Sanitizer.  A new
  configure flag --with-memory-sanitizer has been added to make test builds
  of this nature easier to perform.

- bpo-35193: Fix an off by one error in the bytecode peephole optimizer
  where it could read bytes beyond the end of bounds of an array when
  removing unreachable code. This bug was present in every release of Python
  3.6 and 3.7 until now.

- bpo-29341: Clarify in the docstrings of :mod:`os` methods that path-like
  objects are also accepted as input parameters.

- bpo-35050: :mod:`socket`: Fix off-by-one bug in length check for
  ``AF_ALG`` name and type.

- bpo-34974: :class:`bytes` and :class:`bytearray` constructors no longer
  convert unexpected exceptions (e.g. :exc:`MemoryError` and
  :exc:`KeyboardInterrupt`) to :exc:`TypeError`.

- bpo-34973: Fixed crash in :func:`bytes` when the :class:`list` argument is
  mutated while it is iterated.

- bpo-34824: Fix a possible null pointer dereference in Modules/_ssl.c.
  Patch by Zackery Spytz.

- bpo-1621: Do not assume signed integer overflow behavior (C undefined
  behavior) when performing set hash table resizing.

Library
-------

- bpo-35052: Fix xml.dom.minidom cloneNode() on a document with an entity:
  pass the correct arguments to the user data handler of an entity.

- bpo-35330: When a :class:`Mock` instance was used to wrap an object, if
  `side_effect` is used in one of the mocks of it methods, don't call the
  original implementation and return the result of using the side effect the
  same way that it is done with return_value.

- bpo-34172: Revert the fix for this issue previously released in 3.7.1
  pending further investigation: Fix a reference issue inside
  multiprocessing.Pool that caused the pool to remain alive if it was
  deleted without being closed or terminated explicitly.

- bpo-10496: :func:`posixpath.expanduser` now returns the input *path*
  unchanged if the ``HOME`` environment variable is not set and the current
  user has no home directory (if the current user identifier doesn't exist
  in the password database). This change fix the :mod:`site` module if the
  current user doesn't exist in the password database (if the user has no
  home directory).

- bpo-35310: Fix a bug in :func:`select.select` where, in some cases, the
  file descriptor sequences were returned unmodified after a signal
  interruption, even though the file descriptors might not be ready yet.
  :func:`select.select` will now always return empty lists if a timeout has
  occurred.  Patch by Oran Avraham.

- bpo-35380: Enable TCP_NODELAY on Windows for proactor asyncio event loop.

- bpo-35341: Add generic version of ``collections.OrderedDict`` to the
  ``typing`` module. Patch by Ismo Toijala.

- bpo-35371: Fixed possible crash in ``os.utime()`` on Windows when pass
  incorrect arguments.

- bpo-27903: Fix ``ResourceWarning`` in :func:`platform.dist` on SuSE and
  Caldera OpenLinux. Patch by Ville Skyttä.

- bpo-35308: Fix regression in ``webbrowser`` where default browsers may be
  preferred over browsers in the ``BROWSER`` environment variable.

- bpo-28604: :func:`locale.localeconv` now sets temporarily the ``LC_CTYPE``
  locale to the ``LC_MONETARY`` locale if the two locales are different and
  monetary strings are non-ASCII. This temporary change affects other
  threads.

- bpo-35277: Update ensurepip to install pip 18.1 and setuptools 40.6.2.

- bpo-35226: Recursively check arguments when testing for equality of
  :class:`unittest.mock.call` objects and add note that tracking of
  parameters used to create ancestors of mocks in ``mock_calls`` is not
  possible.

- bpo-29564: The warnings module now suggests to enable tracemalloc if the
  source is specified, the tracemalloc module is available, but tracemalloc
  is not tracing memory allocations.

- bpo-35189: Modify the following fnctl function to retry if interrupted by
  a signal (EINTR): flock, lockf, fnctl

- bpo-35062: Fix incorrect parsing of
  :class:`_io.IncrementalNewlineDecoder`'s *translate* argument.

- bpo-35079: Improve difflib.SequenceManager.get_matching_blocks doc by
  adding 'non-overlapping' and changing '!=' to '<'.

- bpo-35017: :meth:`socketserver.BaseServer.serve_forever` now exits
  immediately if it's :meth:`~socketserver.BaseServer.shutdown` method is
  called while it is polling for new events.

- bpo-31047: Fix ``ntpath.abspath`` regression where it didn't remove a
  trailing separator on Windows. Patch by Tim Graham.

- bpo-34794: Fixed a leak in Tkinter when pass the Python wrapper around
  Tcl_Obj back to Tcl/Tk.

- bpo-35008: Fixed references leaks when call the ``__setstate__()`` method
  of :class:`xml.etree.ElementTree.Element` in the C implementation for
  already initialized element.

- bpo-23420: Verify the value for the parameter '-s' of the cProfile CLI.
  Patch by Robert Kuska

- bpo-33947: dataclasses now handle recursive reprs without raising
  RecursionError.

- bpo-16965: The :term:`2to3` :2to3fixer:`execfile` fixer now opens the file
  with mode ``'rb'``.  Patch by Zackery Spytz.

- bpo-34966: :mod:`pydoc` now supports aliases not only to methods defined
  in the end class, but also to inherited methods.  The docstring is not
  duplicated for aliases.

- bpo-34941: Methods ``find()``, ``findtext()`` and ``findall()`` of the
  ``Element`` class in the :mod:`xml.etree.ElementTree` module are now able
  to find children which are instances of ``Element`` subclasses.

- bpo-34936: Fix ``TclError`` in ``tkinter.Spinbox.selection_element()``.
  Patch by Juliette Monsel.

- bpo-34866: Adding ``max_num_fields`` to ``cgi.FieldStorage`` to make DOS
  attacks harder by limiting the number of ``MiniFieldStorage`` objects
  created by ``FieldStorage``.

- bpo-34022: The :envvar:`SOURCE_DATE_EPOCH` environment variable no longer
  overrides the value of the *invalidation_mode* argument to
  :func:`py_compile.compile`, and determines its default value instead.

- bpo-34738: ZIP files created by :mod:`distutils` will now include entries
  for directories.

- bpo-31177: Fix bug that prevented using :meth:`reset_mock
  <unittest.mock.Mock.reset_mock>` on mock instances with deleted attributes

- bpo-34536: `Enum._missing_`:  raise `ValueError` if None returned and
  `TypeError` if non-member is returned.

- bpo-34604: Fix possible mojibake in the error message of `pwd.getpwnam`
  and `grp.getgrnam` using string representation because of invisible
  characters or trailing whitespaces. Patch by William Grzybowski.

- bpo-34574: OrderedDict iterators are not exhausted during pickling
  anymore. Patch by Sergey Fedoseev.

- bpo-34052: :meth:`sqlite3.Connection.create_aggregate`,
  :meth:`sqlite3.Connection.create_function`,
  :meth:`sqlite3.Connection.set_authorizer`,
  :meth:`sqlite3.Connection.set_progress_handler` methods raises TypeError
  when unhashable objects are passed as callable. These methods now don't
  pass such objects to SQLite API. Previous behavior could lead to
  segfaults. Patch by Sergey Fedoseev.

- bpo-29877: compileall: import ProcessPoolExecutor only when needed,
  preventing hangs on low resource platforms

- bpo-22005: Implemented unpickling instances of
  :class:`~datetime.datetime`, :class:`~datetime.date` and
  :class:`~datetime.time` pickled by Python 2. ``encoding='latin1'`` should
  be used for successful decoding.

Documentation
-------------

- bpo-35089: Remove mention of ``typing.io`` and ``typing.re``. Their types
  should be imported from ``typing`` directly.

- bpo-35038: Fix the documentation about an unexisting `f_restricted`
  attribute in the frame object. Patch by Stéphane Wirtel

- bpo-35044: Fix the documentation with the role ``exc`` for the
  appropriated exception. Patch by Stéphane Wirtel

- bpo-35035: Rename documentation for :mod:`email.utils` to
  ``email.utils.rst``.

- bpo-34967: Use app.add_object_type() instead of the deprecated Sphinx
  function app.description_unit()

- bpo-11233: Create availability directive for documentation.  Original
  patch by Georg Brandl.

- bpo-33594: Document ``getargspec``, ``from_function`` and ``from_builtin``
  as deprecated in their respective docstring, and include version since
  deprecation in DeprecationWarning message.

- bpo-32613: Update the faq/windows.html to use the py command from PEP 397
  instead of python.

Tests
-----

- bpo-33725: test_multiprocessing_fork may crash on recent versions of
  macOS.  Until the issue is resolved, skip the test on macOS.

- bpo-35352: Modify test_asyncio to use the certificate set from the test
  directory.

- bpo-35317: Fix ``mktime()`` overflow error in ``test_email``: run
  ``test_localtime_daylight_true_dst_true()`` and
  ``test_localtime_daylight_false_dst_true()`` with a specific timezone.

- bpo-21263: After several reports that test_gdb does not work properly on
  macOS and since gdb is not shipped by default anymore, test_gdb is now
  skipped on macOS when LLVM Clang has been used to compile Python. Patch by
  Lysandros Nikolaou

- bpo-34279: regrtest issue a warning when no tests have been executed in a
  particular test file. Also, a new final result state is issued if no test
  have been executed across all test files. Patch by Pablo Galindo.

Build
-----

- bpo-35296: The Windows installer (MSI) now also install internal header
  files (``Include/internal/`` subdirectory).

- bpo-35351: When building Python with clang and LTO, LTO flags are no
  longer passed into CFLAGS to build third-party C extensions through
  distutils.

- bpo-35139: Fix a compiler error when statically linking `pyexpat` in
  `Modules/Setup`.

- bpo-35011: Restores the use of pyexpatns.h to isolate our embedded copy of
  the expat C library so that its symbols do not conflict at link or dynamic
  loading time with an embedding application or other extension modules with
  their own version of libexpat.

- bpo-28015: Have --with-lto works correctly with clang.

- bpo-33015: Fix an undefined behaviour in the pthread implementation of
  :c:func:`PyThread_start_new_thread`: add a function wrapper to always
  return ``NULL``.

Windows
-------

- bpo-35401: Updates Windows build to OpenSSL 1.1.0j

- bpo-34977: venv on Windows will now use a python.exe redirector rather
  than copying the actual binaries from the base environment.

- bpo-34977: Adds support for building a Windows App Store package

- bpo-35067: Remove _distutils_findvs module and use vswhere.exe instead.

- bpo-34532: Fixes exit code of list version arguments for py.exe.

- bpo-32890: Fix usage of GetLastError() instead of errno in os.execve() and
  os.truncate().

macOS
-----

- bpo-35402: Update macOS installer to use Tcl/Tk 8.6.9.1.  [NOTE: This
  change was reverted for the released python.org 3.7.2 macOS installers due
  to regressions found in Tk 8.6.9.1.  For now, the installers provide
  Tcl/Tk 8.6.8.]

- bpo-35401: Update macOS installer to use OpenSSL 1.1.0j.

- bpo-35025: Properly guard the use of the ``CLOCK_GETTIME`` et al. macros
  in ``timemodule`` on macOS.

- bpo-24658: On macOS, fix reading from and writing into a file with a size
  larger than 2 GiB.

IDLE
----

- bpo-35213: Where appropriate, use 'macOS' in idlelib.

- bpo-34864: On macOS, warn if the system preference "Prefer tabs when
  opening documents" is set to "Always".

- bpo-34864: Document two IDLE on MacOS issues. The System Preferences Dock
  "prefer tabs always" setting disables some IDLE features.  Menus are a bit
  different than as described for Windows and Linux.

- bpo-35202: Remove unused imports from lib/idlelib

- bpo-33000: Document that IDLE's shell has no line limit. A program that
  runs indefinitely can overfill memory.

- bpo-23220: Explain how IDLE's Shell displays output.

- bpo-35099: Improve the doc about IDLE running user code.   The section is
  renamed from "IDLE -- console differences" is renamed "Running user code".
  It mostly covers the implications of using custom sys.stdxxx objects.

- bpo-35097: Add IDLE doc subsection explaining editor windows. Topics
  include opening, title and status bar, .py* extension, and running.

- bpo-35093: Document the IDLE document viewer in the IDLE doc. Add a
  paragraph in "Help and preferences", "Help sources" subsection.

- bpo-35088: Update idlelib.help.copy_string docstring. We now use git and
  backporting instead of hg and forward merging.

- bpo-35087: Update idlelib help files for the current doc build. The main
  change is the elimination of chapter-section numbers.

Tools/Demos
-----------

- bpo-34989: python-gdb.py now handles errors on computing the line number
  of a Python frame.

C API
-----

- bpo-35322: Fix memory leak in :c:func:`PyUnicode_EncodeLocale` and
  :c:func:`PyUnicode_EncodeFSDefault` on error handling.

- bpo-35296: ``make install`` now also installs the internal API:
  ``Include/internal/*.h`` header files.

- bpo-34725: Adds _Py_SetProgramFullPath so embedders may override
  sys.executable


What's New in Python 3.7.1 final?
=================================

*Release date: 2018-10-20*

Library
-------

- bpo-34970: Protect tasks weak set manipulation in ``asyncio.all_tasks()``


What's New in Python 3.7.1 release candidate 2?
===============================================

*Release date: 2018-10-13*

Core and Builtins
-----------------

- bpo-34879: Fix a possible null pointer dereference in bytesobject.c.
  Patch by Zackery Spytz.

- bpo-34854: Fixed a crash in compiling string annotations containing a
  lambda with a keyword-only argument that doesn't have a default value.

- bpo-34320: Fix ``dict(od)`` didn't copy iteration order of OrderedDict.

Library
-------

- bpo-34769: Fix for async generators not finalizing when event loop is in
  debug mode and garbage collector runs in another thread.

- bpo-34922: Fixed integer overflow in the :meth:`~hashlib.shake.digest()`
  and :meth:`~hashlib.shake.hexdigest()` methods for the SHAKE algorithm in
  the :mod:`hashlib` module.

- bpo-34909: Enum: fix grandchildren subclassing when parent mixed with
  concrete data types.

- bpo-34900: Fixed :meth:`unittest.TestCase.debug` when used to call test
  methods with subtests.  Patch by Bruno Oliveira.

- bpo-34871: Fix inspect module polluted ``sys.modules`` when parsing
  ``__text_signature__`` of callable.

- bpo-34872: Fix self-cancellation in C implementation of asyncio.Task

- bpo-34819: Use a monotonic clock to compute timeouts in
  :meth:`Executor.map` and :func:`as_completed`, in order to prevent
  timeouts from deviating when the system clock is adjusted.

- bpo-34521: Use :func:`socket.CMSG_SPACE` to calculate ancillary data size
  instead of :func:`socket.CMSG_LEN` in
  :func:`multiprocessing.reduction.recvfds` as :rfc:`3542` requires the use
  of the former for portable applications.

- bpo-34334: In :class:`QueueHandler`, clear `exc_text` from
  :class:`LogRecord` to prevent traceback from being written twice.

- bpo-6721: Acquire the logging module's commonly used internal locks while
  fork()ing to avoid deadlocks in the child process.

- bpo-34172: Fix a reference issue inside multiprocessing.Pool that caused
  the pool to remain alive if it was deleted without being closed or
  terminated explicitly.

Documentation
-------------

- bpo-32174: chm document displays non-ASCII charaters properly on some MBCS
  Windows systems.

Tests
-----

- bpo-32962: Fixed test_gdb when Python is compiled with flags -mcet
  -fcf-protection -O0.

macOS
-----

- bpo-34370: Revert to using the released Tk 8.6.8 with macOS installers
  instead of the Tk 8.6.x development snapshot used with 3.7.1rc1 and
  3.6.7rc1. The snapshot introduced at least one significant regression
  (bpo-34927).

C API
-----

- bpo-34910: Ensure that :c:func:`PyObject_Print` always returns ``-1`` on
  error.  Patch by Zackery Spytz.


What's New in Python 3.7.1 release candidate 1?
===============================================

*Release date: 2018-09-26*

Security
--------

- bpo-17239: The xml.sax and xml.dom.minidom parsers no longer processes
  external entities by default. External DTD and ENTITY declarations no
  longer load files or create network connections.

- bpo-34623: CVE-2018-14647: The C accelerated _elementtree module now
  initializes hash randomization salt from _Py_HashSecret instead of
  libexpat's default CSPRNG.

- bpo-34405: Updated to OpenSSL 1.1.0i for Windows builds.

- bpo-33871: Fixed sending the part of the file in :func:`os.sendfile` on
  macOS.  Using the *trailers* argument could cause sending more bytes from
  the input file than was specified.

- bpo-32533: Fixed thread-safety of error handling in _ssl.

Core and Builtins
-----------------

- bpo-34783: Fix a crash with musl libc (on Alpine Linux) when the script
  filename specified on the command line doesn't exist.

- bpo-34762: Fix contextvars C API to use PyObject* pointer types.

- bpo-34735: Fix a memory leak in Modules/timemodule.c.  Patch by Zackery
  Spytz.

- bpo-34588: Fix an off-by-one in the recursive call pruning feature of
  traceback formatting.

- bpo-34485: Standard streams like sys.stdout now use the "surrogateescape"
  error handler, instead of "strict", on the POSIX locale (when the C locale
  is not coerced and the UTF-8 Mode is disabled).

- bpo-34485: Fix the error handler of standard streams like sys.stdout:
  PYTHONIOENCODING=":" is now ignored instead of setting the error handler
  to "strict".

- bpo-34527: On FreeBSD, Py_DecodeLocale() and Py_EncodeLocale() now also
  forces the ASCII encoding if the LC_CTYPE locale is "POSIX", not only if
  the LC_CTYPE locale is "C".

- bpo-34527: The UTF-8 Mode is now also enabled by the "POSIX" locale, not
  only by the "C" locale.

- bpo-34400: Fix undefined behavior in parsetok.c.  Patch by Zackery Spytz.

- bpo-34377: Update valgrind suppression list to use
  ``_PyObject_Free``/``_PyObject_Realloc`` instead of
  ``PyObject_Free``/``PyObject_Realloc``.

- bpo-34170: -X dev: it is now possible to override the memory allocator
  using PYTHONMALLOC even if the developer mode is enabled.

- bpo-34126: Fix crashes when profiling certain invalid calls of unbound
  methods. Patch by Jeroen Demeyer.

- bpo-24618: Fixed reading invalid memory when create the code object with
  too small varnames tuple or too large argument counts.

- bpo-34068: In :meth:`io.IOBase.close`, ensure that the
  :attr:`~io.IOBase.closed` attribute is not set with a live exception.
  Patch by Zackery Spytz and Serhiy Storchaka.

- bpo-34087: Fix buffer overflow while converting unicode to numeric values.

- bpo-34080: Fixed a memory leak in the compiler when it raised some
  uncommon errors during tokenizing.

- bpo-34066: Disabled interruption by Ctrl-C between calling ``open()`` and
  entering a **with** block in ``with open()``.

- bpo-34042: Fix dict.copy() to maintain correct total refcount (as reported
  by sys.gettotalrefcount()).

- bpo-33985: Implement contextvars.ContextVar.name attribute.

- bpo-33956: Update vendored Expat library copy to version 2.2.5.

- bpo-24596: Decref the module object in :c:func:`PyRun_SimpleFileExFlags`
  before calling :c:func:`PyErr_Print()`.  Patch by Zackery Spytz.

- bpo-33451: Close directly executed pyc files before calling
  ``PyEval_EvalCode()``.

- bpo-33824: Fix "LC_ALL=C python3.7 -V": reset properly the command line
  parser when the encoding changes after reading the Python configuration.

- bpo-25750: Fix rare Python crash due to bad refcounting in
  ``type_getattro()`` if a descriptor deletes itself from the class. Patch
  by Jeroen Demeyer.

- bpo-31902: Fix the ``col_offset`` attribute for ast nodes
  ``ast.AsyncFor``, ``ast.AsyncFunctionDef``, and ``ast.AsyncWith``.
  Previously, ``col_offset`` pointed to the keyword after ``async``.

- bpo-25862: Fix assertion failures in the ``tell()`` method of
  ``io.TextIOWrapper``. Patch by Zackery Spytz.

- bpo-31577: Fix a crash in `os.utime()` in case of a bad ns argument. Patch
  by Oren Milman.

Library
-------

- bpo-29577: Support multiple mixin classes when creating Enums.

- bpo-34670: Add SSLContext.post_handshake_auth and
  SSLSocket.verify_client_post_handshake for TLS 1.3's post handshake
  authentication feature.

- bpo-34658: Fix a rare interpreter unhandled exception state SystemError
  only seen when using subprocess with a preexec_fn while an after_parent
  handler has been registered with os.register_at_fork and the fork system
  call fails.

- bpo-34652: Ensure :func:`os.lchmod` is never defined on Linux.

- bpo-34363: dataclasses.asdict() and .astuple() now handle namedtuples
  correctly.

- bpo-34625: Update vendorized expat library version to 2.2.6.

- bpo-34621: Fix un/pickling compatbility of uuid.UUID objects with older
  versions of Python (<3.7).

- bpo-32270: The subprocess module no longer mistakenly closes redirected
  fds even when they were in pass_fds when outside of the default {0, 1, 2}
  set.

- bpo-34610: Fixed iterator of :class:`multiprocessing.managers.DictProxy`.

- bpo-34421: Fix distutils logging for non-ASCII strings.  This caused
  installation issues on Windows.

- bpo-34604: Fix possible mojibake in the error message of `pwd.getpwnam`
  and `grp.getgrnam`. Patch by William Grzybowski.

- bpo-34530: ``distutils.spawn.find_executable()`` now falls back on
  :data:`os.defpath` if the ``PATH`` environment variable is not set.

- bpo-34282: Fix enum members getting shadowed by parent attributes.

- bpo-34563: On Windows, fix multiprocessing.Connection for very large read:
  fix _winapi.PeekNamedPipe() and _winapi.ReadFile() for read larger than
  INT_MAX (usually 2^31-1).

- bpo-34558: Correct typo in Lib/ctypes/_aix.py

- bpo-34515: Fix parsing non-ASCII identifiers in
  :mod:`lib2to3.pgen2.tokenize` (PEP 3131).

- bpo-13312: Avoids a possible integer underflow (undefined behavior) in the
  time module's year handling code when passed a very low negative year
  value.

- bpo-34472: Improved compatibility for streamed files in :mod:`zipfile`.
  Previously an optional signature was not being written and certain ZIP
  applications were not supported. Patch by Silas Sewell.

- bpo-34454: Fix the .fromisoformat() methods of datetime types crashing
  when given unicode with non-UTF-8-encodable code points.  Specifically,
  datetime.fromisoformat() now accepts surrogate unicode code points used as
  the separator. Report and tests by Alexey Izbyshev, patch by Paul Ganssle.

- bpo-6700: Fix inspect.getsourcelines for module level frames/tracebacks.
  Patch by Vladimir Matveev.

- bpo-34171: Running the :mod:`trace` module no longer creates the
  ``trace.cover`` file.

- bpo-34441: Fix crash when an ``ABC``-derived class with invalid
  ``__subclasses__`` is passed as the second argument to
  :func:`issubclass()`. Patch by Alexey Izbyshev.

- bpo-34341: Appending to the ZIP archive with the ZIP64 extension no longer
  grows the size of extra fields of existing entries.

- bpo-34333: Fix %-formatting in :meth:`pathlib.PurePath.with_suffix` when
  formatting an error message.

- bpo-18540: The :class:`imaplib.IMAP4` and :class:`imaplib.IMAP4_SSL`
  classes now resolve to the local host IP correctly when the default value
  of *host* parameter (``''``) is used.

- bpo-34246: :meth:`smtplib.SMTP.send_message` no longer modifies the
  content of the *mail_options* argument. Patch by Pablo S. Blum de Aguiar.

- bpo-31047: Fix ``ntpath.abspath`` for invalid paths on windows. Patch by
  Franz Woellert.

- bpo-34263: asyncio's event loop will not pass timeouts longer than one day
  to epoll/select etc.

- bpo-34035: Fix several AttributeError in zipfile seek() methods. Patch by
  Mickaël Schoentgen.

- bpo-32215: Fix performance regression in :mod:`sqlite3` when a DML
  statement appeared in a different line than the rest of the SQL query.

- bpo-34251: Restore ``msilib.Win64`` to preserve backwards compatibility
  since it's already used by :mod:`distutils`' ``bdist_msi`` command.

- bpo-19891: Ignore errors caused by missing / non-writable homedir while
  writing history during exit of an interactive session.  Patch by Anthony
  Sottile.

- bpo-34213: Allow frozen dataclasses to have a field named "object".
  Previously this conflicted with an internal use of "object".

- bpo-21446: The :2to3fixer:`reload` fixer now uses :func:`importlib.reload`
  instead of deprecated :func:`imp.reload`.

- bpo-940286: pydoc's ``Helper.showtopic()`` method now prints the cross
  references of a topic correctly.

- bpo-34164: :func:`base64.b32decode` could raise UnboundLocalError or
  OverflowError for incorrect padding.  Now it always raises
  :exc:`base64.Error` in these cases.

- bpo-33729: Fixed issues with arguments parsing in :mod:`hashlib`.

- bpo-34108: Remove extraneous CR in 2to3 refactor.

- bpo-27494: Reverted :issue:`27494`. 2to3 rejects now a trailing comma in
  generator expressions.

- bpo-33967: functools.singledispatch now raises TypeError instead of
  IndexError when no positional arguments are passed.

- bpo-34056: Ensure the loader shim created by ``imp.load_module`` always
  returns bytes from its ``get_data()`` function. This fixes using
  ``imp.load_module`` with :pep:`552` hash-based pycs.

- bpo-34054: The multiprocessing module now uses the monotonic clock
  :func:`time.monotonic` instead of the system clock :func:`time.time` to
  implement timeout.

- bpo-34044: ``subprocess.Popen`` now copies the *startupinfo* argument to
  leave it unchanged: it will modify the copy, so that the same
  ``STARTUPINFO`` object can be used multiple times.

- bpo-34010: Fixed a performance regression for reading streams with
  tarfile. The buffered read should use a list, instead of appending to a
  bytes object.

- bpo-34019: webbrowser: Correct the arguments passed to Opera Browser when
  opening a new URL using the ``webbrowser`` module. Patch by Bumsik Kim.

- bpo-33978: Closed existing logging handlers before reconfiguration via
  fileConfig and dictConfig. Patch by Karthikeyan Singaravelan.

- bpo-14117: Make minor tweaks to turtledemo. The 'wikipedia' example is now
  'rosette', decribing what it draws.  The 'penrose' print output is
  reduced. The'1024' output of 'tree' is eliminated.

- bpo-33974: Fixed passing lists and tuples of strings containing special
  characters ``"``, ``\``, ``{``, ``}`` and ``\n`` as options to
  :mod:`~tkinter.ttk` widgets.

- bpo-27500: Fix getaddrinfo to resolve IPv6 addresses correctly.

- bpo-24567: Improve random.choices() to handle subnormal input weights that
  could occasionally trigger an IndexError.

- bpo-33871: Fixed integer overflow in :func:`os.readv`, :func:`os.writev`,
  :func:`os.preadv` and :func:`os.pwritev` and in :func:`os.sendfile` with
  *headers* or *trailers* arguments (on BSD-based OSes and macOS).

- bpo-33899: Tokenize module now implicitly emits a NEWLINE when provided
  with input that does not have a trailing new line.  This behavior now
  matches what the C tokenizer does internally.  Contributed by Ammar Askar.

- bpo-33916: bz2 and lzma: When Decompressor.__init__() is called twice,
  free the old lock to not leak memory.

- bpo-32568: Make select.epoll() and its documentation consistent regarding
  *sizehint* and *flags*.

- bpo-33833: Fixed bug in asyncio where ProactorSocketTransport logs
  AssertionError if force closed during write.

- bpo-33663: Convert content length to string before putting to header.

- bpo-26544: Fixed implementation of :func:`platform.libc_ver`. It almost
  always returned version '2.9' for glibc.

- bpo-33805: Improve error message of dataclasses.replace() when an InitVar
  is not specified

- bpo-27397: Make email module properly handle invalid-length base64
  strings.

- bpo-33476: Fix _header_value_parser.py when address group is missing final
  ';'. Contributed by Enrique Perez-Terron

- bpo-31014: Fixed creating a controller for :mod:`webbrowser` when a user
  specifies a path to an entry in the BROWSER environment variable.  Based
  on patch by John Still.

- bpo-33365: Print the header values besides the header keys instead just
  the header keys if *debuglevel* is set to >0 in :mod:`http.client`. Patch
  by Marco Strigl.

- bpo-32933: :func:`unittest.mock.mock_open` now supports iteration over the
  file contents. Patch by Tony Flury.

- bpo-33336: ``imaplib`` now allows ``MOVE`` command in ``IMAP4.uid()`` (RFC
  6851: IMAP MOVE Extension) and potentially as a name of supported method
  of ``IMAP4`` object.

- bpo-31608: Raise a ``TypeError`` instead of crashing if a
  ``collections.deque`` subclass returns a non-deque from ``__new__``. Patch
  by Oren Milman.

- bpo-29456: Fix bugs in hangul normalization: u1176, u11a7 and u11c3

Documentation
-------------

- bpo-34790: Document how passing coroutines to asyncio.wait() can be
  confusing.

- bpo-28617: Fixed info in the stdtypes docs concerning the types that
  support membership tests.

- bpo-34065: Fix wrongly written basicConfig documentation markup syntax

- bpo-33460: replaced ellipsis with correct error codes in tutorial chapter
  3.

- bpo-33847: Add '@' operator entry to index.

- bpo-25041: Document ``AF_PACKET`` in the :mod:`socket` module.

Tests
-----

- bpo-34537: Fix ``test_gdb.test_strings()`` when ``LC_ALL=C`` and GDB was
  compiled with Python 3.6 or earlier.

- bpo-34587: test_socket: Remove RDSTest.testCongestion(). The test tries to
  fill the receiver's socket buffer and expects an error. But the RDS
  protocol doesn't require that. Moreover, the Linux implementation of RDS
  expects that the producer of the messages reduces its rate, it's not the
  role of the receiver to trigger an error. The test fails on Fedora 28 by
  design, so just remove it.

- bpo-34661: Fix test_shutil if unzip doesn't support -t.

- bpo-34200: Fixed non-deterministic flakiness of test_pkg by not using the
  scary test.support.module_cleanup() logic to save and restore sys.modules
  contents between test cases.

- bpo-34594: Fix usage of hardcoded ``errno`` values in the tests.

- bpo-34542: Use 3072 RSA keys and SHA-256 signature for test certs and
  keys.

- bpo-11193: Remove special condition for AIX in
  `test_subprocess.test_undecodable_env`

- bpo-34490: On AIX with AF_UNIX family sockets getsockname() does not
  provide 'sockname', so skip calls to transport.get_extra_info('sockname')

- bpo-34391: Fix ftplib test for TLS 1.3 by reading from data socket.

- bpo-34399: Update all RSA keys and DH params to use at least 2048 bits.

- bpo-33746: Fix test_unittest when run in verbose mode.

- bpo-33901: Fix test_dbm_gnu on macOS with gdbm 1.15: add a larger value to
  make sure that the file size changes.

- bpo-33873: Fix a bug in ``regrtest`` that caused an extra test to run if
  --huntrleaks/-R was used. Exit with error in case that invalid parameters
  are specified to --huntrleaks/-R (at least one warmup run and one
  repetition must be used).

- bpo-32663: Making sure the `SMTPUTF8SimTests` class of tests gets run in
  test_smtplib.py.

Build
-----

- bpo-34710: Fixed SSL module build with OpenSSL & pedantic CFLAGS.

- bpo-34582: Add JUnit XML output for regression tests and update Azure
  DevOps builds.

- bpo-34555: Fix for case where it was not possible to have both
  ``HAVE_LINUX_VM_SOCKETS_H`` and ``HAVE_SOCKADDR_ALG`` be undefined.

- bpo-34121: Fix detection of C11 atomic support on clang.

- bpo-30345: Add -g to LDFLAGS when compiling with LTO to get debug symbols.

- bpo-33648: The --with-c-locale-warning configuration flag has been
  removed. It has had no effect for about a year.

Windows
-------

- bpo-34770: Fix a possible null pointer dereference in pyshellext.cpp.

- bpo-34603: Fix returning structs from functions produced by MSVC

- bpo-34581: Guard MSVC-specific code in socketmodule.c with ``#ifdef
  _MSC_VER``.

- bpo-34062: Fixed the '--list' and '--list-paths' arguments for the py.exe
  launcher

- bpo-34225: Ensure INCLUDE and LIB directories do not end with a backslash.

- bpo-34006: Revert line length limit for Windows help docs. The line-length
  limit is not needed because the pages appear in a separate app rather than
  on a browser tab.  It can also interact badly with the DPI setting.

- bpo-31546: Restore running PyOS_InputHook while waiting for user input at
  the prompt. The restores integration of interactive GUI windows (such as
  Matplotlib figures) with the prompt on Windows.

- bpo-30237: Output error when ReadConsole is canceled by
  CancelSynchronousIo instead of crashing.

- bpo-29097: Fix bug where :meth:`datetime.fromtimestamp` erronously throws
  an :exc:`OSError` on Windows for values between 0 and 86400. Patch by
  Ammar Askar.

macOS
-----

- bpo-34370: Have macOS 10.9+ installer builds for 3.7.1rc and 3.6.7rc use a
  development snapshot of Tk 8.6 (post-8.6.8) to mitigate certain scroller
  issues seen with IDLE and tkinter apps.

- bpo-34405: Update to OpenSSL 1.1.0i for macOS installer builds.

- bpo-33635: In macOS stat on some file descriptors (/dev/fd/3 f.e) will
  result in bad file descriptor OSError. Guard against this exception was
  added in is_dir, is_file and similar methods. DirEntry.is_dir can also
  throw this exception so _RecursiveWildcardSelector._iterate_directories
  was also extended with the same error ignoring pattern.

- bpo-31903: In :mod:`_scproxy`, drop the GIL when calling into
  ``SystemConfiguration`` to avoid deadlocks.

IDLE
----

- bpo-34548: Use configured color theme for read-only text views.

- bpo-1529353: Enable "squeezing" of long outputs in the shell, to avoid
  performance degradation and to clean up the history without losing it.
  Squeezed outputs may be copied, viewed in a separate window, and
  "unsqueezed".

- bpo-34047: Fixed mousewheel scrolling direction on macOS.

- bpo-34275: Make IDLE calltips always visible on Mac. Some MacOS-tk
  combinations need .update_idletasks(). Patch by Kevin Walzer.

- bpo-34120: Fix unresponsiveness after closing certain windows and dialogs.

- bpo-33975: Avoid small type when running htests. Since part of the purpose
  of human-viewed tests is to determine that widgets look right, it is
  important that they look the same for testing as when running IDLE.

- bpo-33905: Add test for idlelib.stackview.StackBrowser.

- bpo-33924: Change mainmenu.menudefs key 'windows' to 'window'. Every other
  menudef key is lowercase version of main menu entry.

- bpo-33906: Rename idlelib.windows as window Match Window on the main menu
  and remove last plural module name.

- bpo-33917: Fix and document idlelib/idle_test/template.py. The revised
  file compiles, runs, and tests OK.  idle_test/README.txt explains how to
  use it to create new IDLE test files.

- bpo-33904: IDLE: In rstrip, rename class RstripExtension as Rstrip

- bpo-33907: For consistency and clarity, rename an IDLE module and classes.
  Module calltips and its class CallTips are now calltip and Calltip. In
  module calltip_w, class CallTip is now CalltipWindow.

- bpo-33856: Add "help" in the welcome message of IDLE

- bpo-33839: IDLE: refactor ToolTip and CallTip and add documentation and
  tests

- bpo-33855: Minimally test all IDLE modules. Add missing files, import
  module, instantiate classes, and check coverage. Check existing files.

Tools/Demos
-----------

- bpo-32962: python-gdb now catches ``UnicodeDecodeError`` exceptions when
  calling ``string()``.

- bpo-32962: python-gdb now catches ValueError on read_var(): when Python
  has no debug symbols for example.

C API
-----

- bpo-34247: Fix Py_Initialize() regression introduced in 3.7.0: read
  environment variables like PYTHONOPTIMIZE.

- bpo-23927: Fixed :exc:`SystemError` in
  :c:func:`PyArg_ParseTupleAndKeywords` when the ``w*`` format unit is used
  for optional parameter.

- bpo-34008: Py_Main() can again be called after Py_Initialize(), as in
  Python 3.6.


What's New in Python 3.7.0 final?
=================================

*Release date: 2018-06-27*

Library
-------

- bpo-33851: Fix :func:`ast.get_docstring` for a node that lacks a
  docstring.

C API
-----

- bpo-33932: Calling Py_Initialize() twice does nothing, instead of failing
  with a fatal error: restore the Python 3.6 behaviour.


What's New in Python 3.7.0 release candidate 1?
===============================================

*Release date: 2018-06-12*

Core and Builtins
-----------------

- bpo-33803: Fix a crash in hamt.c caused by enabling GC tracking for an
  object that hadn't all of its fields set to NULL.

- bpo-33706: Fix a crash in Python initialization when parsing the command
  line options. Thanks Christoph Gohlke for the bug report and the fix!

- bpo-30654: Fixed reset of the SIGINT handler to SIG_DFL on interpreter
  shutdown even when there was a custom handler set previously. Patch by
  Philipp Kerling.

- bpo-31849: Fix signed/unsigned comparison warning in pyhash.c.

Library
-------

- bpo-30167: Prevent site.main() exception if PYTHONSTARTUP is set. Patch by
  Steve Weber.

- bpo-33812: Datetime instance d with non-None tzinfo, but with
  d.tzinfo.utcoffset(d) returning None is now treated as naive by the
  astimezone() method.

- bpo-30805: Avoid race condition with debug logging

- bpo-33694: asyncio: Fix a race condition causing data loss on
  pause_reading()/resume_reading() when using the ProactorEventLoop.

- bpo-32493: Correct test for ``uuid_enc_be`` availability in
  ``configure.ac``. Patch by Michael Felt.

- bpo-33792: Add asyncio.WindowsSelectorEventLoopPolicy and
  asyncio.WindowsProactorEventLoopPolicy.

- bpo-33778: Update ``unicodedata``'s database to Unicode version 11.0.0.

- bpo-33770: improve base64 exception message for encoded inputs of invalid
  length

- bpo-33769: asyncio/start_tls: Fix error message; cancel callbacks in case
  of an unhandled error; mark SSLTransport as closed if it is aborted.

- bpo-33767: The concatenation (``+``) and repetition (``*``) sequence
  operations now raise :exc:`TypeError` instead of :exc:`SystemError` when
  performed on :class:`mmap.mmap` objects.  Patch by Zackery Spytz.

- bpo-33734: asyncio/ssl: Fix AttributeError, increase default handshake
  timeout

- bpo-11874: Use a better regex when breaking usage into wrappable parts.
  Avoids bogus assertion errors from custom metavar strings.

- bpo-33582: Emit a deprecation warning for inspect.formatargspec

Documentation
-------------

- bpo-33409: Clarified the relationship between PEP 538's
  PYTHONCOERCECLOCALE and PEP 540's PYTHONUTF8 mode.

- bpo-33736: Improve the documentation of :func:`asyncio.open_connection`,
  :func:`asyncio.start_server` and their UNIX socket counterparts.

- bpo-31432: Clarify meaning of CERT_NONE, CERT_OPTIONAL, and CERT_REQUIRED
  flags for ssl.SSLContext.verify_mode.

Build
-----

- bpo-5755: Move ``-Wstrict-prototypes`` option to ``CFLAGS_NODIST`` from
  ``OPT``. This option emitted annoying warnings when building extension
  modules written in C++.

Windows
-------

- bpo-33720: Reduces maximum marshal recursion depth on release builds.

IDLE
----

- bpo-33656: On Windows, add API call saying that tk scales for DPI. On
  Windows 8.1+ or 10, with DPI compatibility properties of the Python binary
  unchanged, and a monitor resolution greater than 96 DPI, this should make
  text and lines sharper.  It should otherwise have no effect.

- bpo-33768: Clicking on a context line moves that line to the top of the
  editor window.

- bpo-33763: IDLE: Use read-only text widget for code context instead of
  label widget.

- bpo-33664: Scroll IDLE editor text by lines. Previously, the mouse wheel
  and scrollbar slider moved text by a fixed number of pixels, resulting in
  partial lines at the top of the editor box.  The change also applies to
  the shell and grep output windows, but not to read-only text views.

- bpo-33679: Enable theme-specific color configuration for Code Context. Use
  the Highlights tab to see the setting for built-in themes or add settings
  to custom themes.

- bpo-33642: Display up to maxlines non-blank lines for Code Context. If
  there is no current context, show a single blank line.


What's New in Python 3.7.0 beta 5?
==================================

*Release date: 2018-05-30*

Core and Builtins
-----------------

- bpo-33622: Fixed a leak when the garbage collector fails to add an object
  with the ``__del__`` method or referenced by it into the
  :data:`gc.garbage` list. :c:func:`PyGC_Collect` can now be called when an
  exception is set and preserves it.

- bpo-33509: Fix module_globals parameter of warnings.warn_explicit(): don't
  crash if module_globals is not a dict.

- bpo-20104: The new `os.posix_spawn` added in 3.7.0b1 was removed as we are
  still working on what the API should look like.  Expect this in 3.8
  instead.

- bpo-33475: Fixed miscellaneous bugs in converting annotations to strings
  and optimized parentheses in the string representation.

- bpo-33391: Fix a leak in set_symmetric_difference().

- bpo-28055: Fix unaligned accesses in siphash24(). Patch by Rolf Eike Beer.

- bpo-32911: Due to unexpected compatibility issues discovered during
  downstream beta testing, reverted :issue:`29463`. ``docstring`` field is
  removed from Module, ClassDef, FunctionDef, and AsyncFunctionDef ast nodes
  which was added in 3.7a1.  Docstring expression is restored as a first
  statement in their body. Based on patch by Inada Naoki.

- bpo-21983: Fix a crash in `ctypes.cast()` in case the type argument is a
  ctypes structured data type. Patch by Eryk Sun and Oren Milman.

Library
-------

- bpo-32751: When cancelling the task due to a timeout,
  :meth:`asyncio.wait_for` will now wait until the cancellation is complete.

- bpo-32684: Fix gather to propagate cancellation of itself even with
  return_exceptions.

- bpo-33654: Support protocol type switching in SSLTransport.set_protocol().

- bpo-33674: Pause the transport as early as possible to further reduce the
  risk of data_received() being called before connection_made().

- bpo-33674: Fix a race condition in SSLProtocol.connection_made() of
  asyncio.sslproto: start immediately the handshake instead of using
  call_soon(). Previously, data_received() could be called before the
  handshake started, causing the handshake to hang or fail.

- bpo-31647: Fixed bug where calling write_eof() on a
  _SelectorSocketTransport after it's already closed raises AttributeError.

- bpo-32610: Make asyncio.all_tasks() return only pending tasks.

- bpo-32410: Avoid blocking on file IO in sendfile fallback code

- bpo-33469: Fix RuntimeError after closing loop that used run_in_executor

- bpo-33672: Fix Task.__repr__ crash with Cython's bogus coroutines

- bpo-33654: Fix transport.set_protocol() to support switching between
  asyncio.Protocol and asyncio.BufferedProtocol.  Fix loop.start_tls() to
  work with asyncio.BufferedProtocols.

- bpo-33652: Pickles of type variables and subscripted generics are now
  future-proof and compatible with older Python versions.

- bpo-32493: Fixed :func:`uuid.uuid1` on FreeBSD.

- bpo-33618: Finalize and document preliminary and experimental TLS 1.3
  support with OpenSSL 1.1.1

- bpo-33623: Fix possible SIGSGV when asyncio.Future is created in __del__

- bpo-30877: Fixed a bug in the Python implementation of the JSON decoder
  that prevented the cache of parsed strings from clearing after finishing
  the decoding. Based on patch by c-fos.

- bpo-33570: Change TLS 1.3 cipher suite settings for compatibility with
  OpenSSL 1.1.1-pre6 and newer. OpenSSL 1.1.1 will have TLS 1.3 ciphers
  enabled by default.

- bpo-28556: Do not simplify arguments to `typing.Union`. Now
  `Union[Manager, Employee]` is not simplified to `Employee` at runtime.
  Such simplification previously caused several bugs and limited
  possibilities for introspection.

- bpo-33540: Add a new ``block_on_close`` class attribute to
  ``ForkingMixIn`` and ``ThreadingMixIn`` classes of :mod:`socketserver`.

- bpo-33548: tempfile._candidate_tempdir_list should consider common TEMP
  locations

- bpo-33109: argparse subparsers are once again not required by default,
  reverting the change in behavior introduced by bpo-26510 in 3.7.0a2.

- bpo-33536: dataclasses.make_dataclass now checks for invalid field names
  and duplicate fields. Also, added a check for invalid field
  specifications.

- bpo-33542: Prevent ``uuid.get_node`` from using a DUID instead of a MAC on
  Windows. Patch by Zvi Effron

- bpo-26819: Fix race condition with `ReadTransport.resume_reading` in
  Windows proactor event loop.

- Fix failure in `typing.get_type_hints()` when ClassVar was provided as a
  string forward reference.

- bpo-33505: Optimize asyncio.ensure_future() by reordering if checks: 1.17x
  faster.

- bpo-33497: Add errors param to cgi.parse_multipart and make an encoding in
  FieldStorage use the given errors (needed for Twisted).  Patch by Amber
  Brown.

- bpo-33495: Change dataclasses.Fields repr to use the repr of each of its
  members, instead of str.  This makes it more clear what each field
  actually represents.  This is especially true for the 'type' member.

- bpo-33453: Fix dataclasses to work if using literal string type
  annotations or if using PEP 563 "Postponed Evaluation of Annotations".
  Only specific string prefixes are detected for both ClassVar ("ClassVar"
  and "typing.ClassVar") and InitVar ("InitVar" and "dataclasses.InitVar").

- bpo-28556: Minor fixes in typing module: add annotations to
  ``NamedTuple.__new__``, pass ``*args`` and ``**kwds`` in
  ``Generic.__new__``.  Original PRs by Paulius Šarka and Chad Dombrova.

- bpo-20087: Updated alias mapping with glibc 2.27 supported locales.

- bpo-33422: Fix trailing quotation marks getting deleted when looking up
  byte/string literals on pydoc. Patch by Andrés Delfino.

- bpo-28167: The function ``platform.linux_distribution`` and
  ``platform.dist`` now trigger a ``DeprecationWarning`` and have been
  marked for removal in Python 3.8

- bpo-33197: Update error message when constructing invalid
  inspect.Parameters Patch by Dong-hee Na.

- bpo-33263: Fix FD leak in `_SelectorSocketTransport`  Patch by Vlad
  Starostin.

- bpo-32861: The urllib.robotparser's ``__str__`` representation now
  includes wildcard entries and the "Crawl-delay" and "Request-rate" fields.
  Patch by Michael Lazar.

- bpo-32257: The ssl module now contains OP_NO_RENEGOTIATION constant,
  available with OpenSSL 1.1.0h or 1.1.1.

- bpo-16865: Support arrays >=2GiB in :mod:`ctypes`.  Patch by Segev Finer.

Documentation
-------------

- bpo-23859: Document that `asyncio.wait()` does not cancel its futures on
  timeout.

- bpo-32436: Document PEP 567 changes to asyncio.

- bpo-33604: Update HMAC md5 default to a DeprecationWarning, bump removal
  to 3.8.

- bpo-33503: Fix broken pypi link

- bpo-33421: Add missing documentation for ``typing.AsyncContextManager``.

Tests
-----

- bpo-33655: Ignore test_posix_fallocate failures on BSD platforms that
  might be due to running on ZFS.

- bpo-32604: Remove the _xxsubinterpreters module (meant for testing) and
  associated helpers.  This module was originally added recently in 3.7b1.

Build
-----

- bpo-33614: Ensures module definition files for the stable ABI on Windows
  are correctly regenerated.

- bpo-33522: Enable CI builds on Visual Studio Team Services at
  https://python.visualstudio.com/cpython

- bpo-33012: Add ``-Wno-cast-function-type`` for gcc 8 for silencing
  warnings about function casts like casting to PyCFunction in method
  definition lists.

macOS
-----

- bpo-13631: The .editrc file in user's home directory is now processed
  correctly during the readline initialization through editline emulation on
  macOS.

IDLE
----

- bpo-33628: IDLE: Cleanup codecontext.py and its test.

- bpo-33564: IDLE's code context now recognizes async as a block opener.

- bpo-32831: Add docstrings and tests for codecontext.


What's New in Python 3.7.0 beta 4?
==================================

*Release date: 2018-05-02*

Core and Builtins
-----------------

- bpo-33363: Raise a SyntaxError for ``async with`` and ``async for``
  statements outside of async functions.

- bpo-33128: Fix a bug that causes PathFinder to appear twice on
  sys.meta_path. Patch by Pablo Galindo Salgado.

- bpo-33312: Fixed clang ubsan (undefined behavior sanitizer) warnings in
  dictobject.c by adjusting how the internal struct _dictkeysobject shared
  keys structure is declared.

- bpo-33231: Fix potential memory leak in ``normalizestring()``.

- bpo-33205: Change dict growth function from
  ``round_up_to_power_2(used*2+hashtable_size/2)`` to
  ``round_up_to_power_2(used*3)``.  Previously, dict is shrinked only when
  ``used == 0``. Now dict has more chance to be shrinked.

- bpo-29922: Improved error messages in 'async with' when ``__aenter__()``
  or ``__aexit__()`` return non-awaitable object.

- bpo-33199: Fix ``ma_version_tag`` in dict implementation is uninitialized
  when copying from key-sharing dict.

Library
-------

- bpo-33281: Fix ctypes.util.find_library regression on macOS.

- bpo-33383: Fixed crash in the get() method of the :mod:`dbm.ndbm` database
  object when it is called with a single argument.

- bpo-33329: Fix multiprocessing regression on newer glibcs

- bpo-991266: Fix quoting of the ``Comment`` attribute of
  :class:`http.cookies.SimpleCookie`.

- bpo-33131: Upgrade bundled version of pip to 10.0.1.

- bpo-33308: Fixed a crash in the :mod:`parser` module when converting an ST
  object to a tree of tuples or lists with ``line_info=False`` and
  ``col_info=True``.

- bpo-33266: lib2to3 now recognizes ``rf'...'`` strings.

- bpo-11594: Ensure line-endings are respected when using lib2to3.

- bpo-33254: Have :func:`importlib.resources.contents` and
  :meth:`importlib.abc.ResourceReader.contents` return an :term:`iterable`
  instead of an :term:`iterator`.

- bpo-33256: Fix display of ``<module>`` call in the html produced by
  ``cgitb.html()``. Patch by Stéphane Blondon.

- bpo-33185: Fixed regression when running pydoc with the :option:`-m`
  switch. (The regression was introduced in 3.7.0b3 by the resolution of
  :issue:`33053`)

  This fix also changed pydoc to add ``os.getcwd()`` to :data:`sys.path`
  when necessary, rather than adding ``"."``.

- bpo-33169: Delete entries of ``None`` in :data:`sys.path_importer_cache`
  when :meth:`importlib.machinery.invalidate_caches` is called.

- bpo-33217: Deprecate looking up non-Enum objects in Enum classes and Enum
  members (will raise :exc:`TypeError` in 3.8+).

- bpo-33203: ``random.Random.choice()`` now raises ``IndexError`` for empty
  sequences consistently even when called from subclasses without a
  ``getrandbits()`` implementation.

- bpo-33224: Update difflib.mdiff() for PEP 479.  Convert an uncaught
  StopIteration in a generator into a return-statement.

- bpo-33209: End framing at the end of C implementation of
  :func:`pickle.Pickler.dump`.

- bpo-20104: Improved error handling and fixed a reference leak in
  :func:`os.posix_spawn()`.

- bpo-33175: In dataclasses, Field.__set_name__ now looks up the
  __set_name__ special method on the class, not the instance, of the default
  value.

- bpo-33097: Raise RuntimeError when ``executor.submit`` is called during
  interpreter shutdown.

- bpo-31908: Fix output of cover files for ``trace`` module command-line
  tool. Previously emitted cover files only when ``--missing`` option was
  used. Patch by Michael Selik.

Documentation
-------------

- bpo-33378: Add Korean language switcher for https://docs.python.org/3/

- bpo-33276: Clarify that the ``__path__`` attribute on modules cannot be
  just any value.

- bpo-33201: Modernize documentation for writing C extension types.

- bpo-33195: Deprecate ``Py_UNICODE`` usage in ``c-api/arg`` document.
  ``Py_UNICODE`` related APIs are deprecated since Python 3.3, but it is
  missed in the document.

- bpo-8243: Add a note about curses.addch and curses.addstr exception
  behavior when writing outside a window, or pad.

- bpo-32337: Update documentation related with ``dict`` order.

Tests
-----

- bpo-33358: Fix ``test_embed.test_pre_initialization_sys_options()`` when
  the interpreter is built with ``--enable-shared``.

Build
-----

- bpo-33394: Enable the verbose build for extension modules, when GNU make
  is passed macros on the command line.

- bpo-33393: Update config.guess and config.sub files.

- bpo-33377: Add new triplets for mips r6 and riscv variants (used in
  extension suffixes).

- bpo-32232: By default, modules configured in `Modules/Setup` are no longer
  built with `-DPy_BUILD_CORE`. Instead, modules that specifically need that
  preprocessor definition include it in their individual entries.

- bpo-33182: The embedding tests can once again be built with clang 6.0

Windows
-------

- bpo-33184: Update Windows installer to use OpenSSL 1.1.0h.

macOS
-----

- bpo-33184: Update macOS installer build to use OpenSSL 1.1.0h.

IDLE
----

- bpo-21474: Update word/identifier definition from ascii to unicode. In
  text and entry boxes, this affects selection by double-click, movement
  left/right by control-left/right, and deletion left/right by
  control-BACKSPACE/DEL.

- bpo-33204: IDLE: consistently color invalid string prefixes. A 'u' string
  prefix cannot be paired with either 'r' or 'f'. Consistently color as much
  of the prefix, starting at the right, as is valid. Revise and extend
  colorizer test.

Tools/Demos
-----------

- bpo-33189: :program:`pygettext.py` now recognizes only literal strings as
  docstrings and translatable strings, and rejects bytes literals and
  f-string expressions.

- bpo-31920: Fixed handling directories as arguments in the ``pygettext``
  script. Based on patch by Oleg Krasnikov.

- bpo-29673: Fix pystackv and pystack gdbinit macros.

- bpo-31583: Fix 2to3 for using with --add-suffix option but without
  --output-dir option for relative path to files in current directory.


What's New in Python 3.7.0 beta 3?
==================================

*Release date: 2018-03-29*

Security
--------

- bpo-33136: Harden ssl module against LibreSSL CVE-2018-8970.
  X509_VERIFY_PARAM_set1_host() is called with an explicit namelen. A new
  test ensures that NULL bytes are not allowed.

- bpo-33001: Minimal fix to prevent buffer overrun in os.symlink on Windows

- bpo-32981: Regexes in difflib and poplib were vulnerable to catastrophic
  backtracking. These regexes formed potential DOS vectors (REDOS). They
  have been refactored. This resolves CVE-2018-1060 and CVE-2018-1061. Patch
  by Jamie Davis.

Core and Builtins
-----------------

- bpo-33053: When using the -m switch, sys.path[0] is now explicitly
  expanded as the *starting* working directory, rather than being left as
  the empty path (which allows imports from the current working directory at
  the time of the import)

- bpo-33018: Improve consistency of errors raised by ``issubclass()`` when
  called with a non-class and an abstract base class as the first and second
  arguments, respectively. Patch by Josh Bronson.

- bpo-33041: Fixed jumping when the function contains an ``async for`` loop.

- bpo-33026: Fixed jumping out of "with" block by setting f_lineno.

- bpo-33005: Fix a crash on fork when using a custom memory allocator (ex:
  using PYTHONMALLOC env var). _PyGILState_Reinit() and
  _PyInterpreterState_Enable() now use the default RAW memory allocator to
  allocate a new interpreters mutex on fork.

- bpo-17288: Prevent jumps from 'return' and 'exception' trace events.

- bpo-32836: Don't use temporary variables in cases of list/dict/set
  comprehensions

Library
-------

- bpo-33141: Have Field objects pass through __set_name__ to their default
  values, if they have their own __set_name__.

- bpo-33096: Allow ttk.Treeview.insert to insert iid that has a false
  boolean value. Note iid=0 and iid=False would be same. Patch by Garvit
  Khatri.

- bpo-32873: Treat type variables and special typing forms as immutable by
  copy and pickle.  This fixes several minor issues and inconsistencies, and
  improves backwards compatibility with Python 3.6.

- bpo-33134: When computing dataclass's __hash__, use the lookup table to
  contain the function which returns the __hash__ value.  This is an
  improvement over looking up a string, and then testing that string to see
  what to do.

- bpo-33127: The ssl module now compiles with LibreSSL 2.7.1.

- bpo-32505: Raise TypeError if a member variable of a dataclass is of type
  Field, but doesn't have a type annotation.

- bpo-33078: Fix the failure on OSX caused by the tests relying on
  sem_getvalue

- bpo-33116: Add 'Field' to dataclasses.__all__.

- bpo-32896: Fix an error where subclassing a dataclass with a field that
  uses a default_factory would generate an incorrect class.

- bpo-33100: Dataclasses: If a field has a default value that's a
  MemberDescriptorType, then it's from that field being in __slots__, not an
  actual default value.

- bpo-32953: If a non-dataclass inherits from a frozen dataclass, allow
  attributes to be added to the derived class.  Only attributes from the
  frozen dataclass cannot be assigned to.  Require all dataclasses in a
  hierarchy to be either all frozen or all non-frozen.

- bpo-33061: Add missing ``NoReturn`` to ``__all__`` in typing.py

- bpo-33078: Fix the size handling in multiprocessing.Queue when a pickling
  error occurs.

- bpo-33064: lib2to3 now properly supports trailing commas after ``*args``
  and ``**kwargs`` in function signatures.

- bpo-33056: FIX properly close leaking fds in
  concurrent.futures.ProcessPoolExecutor.

- bpo-33021: Release the GIL during fstat() calls, avoiding hang of all
  threads when calling mmap.mmap(), os.urandom(), and random.seed().  Patch
  by Nir Soffer.

- bpo-31804: Avoid failing in multiprocessing.Process if the standard
  streams are closed or None at exit.

- bpo-33037: Skip sending/receiving data after SSL transport closing.

- bpo-27683: Fix a regression in :mod:`ipaddress` that result of
  :meth:`hosts` is empty when the network is constructed by a tuple
  containing an integer mask and only 1 bit left for addresses.

- bpo-32999: Fix C implementation of ``ABC.__subclasscheck__(cls,
  subclass)`` crashed when ``subclass`` is not a type object.

- bpo-33009: Fix inspect.signature() for single-parameter partialmethods.

- bpo-32969: Expose several missing constants in zlib and fix corresponding
  documentation.

- bpo-32056: Improved exceptions raised for invalid number of channels and
  sample width when read an audio file in modules :mod:`aifc`, :mod:`wave`
  and :mod:`sunau`.

- bpo-32844: Fix wrong redirection of a low descriptor (0 or 1) to stderr in
  subprocess if another low descriptor is closed.

- bpo-32857: In :mod:`tkinter`, ``after_cancel(None)`` now raises a
  :exc:`ValueError` instead of canceling the first scheduled function.
  Patch by Cheryl Sabella.

- bpo-31639: http.server now exposes a ThreadedHTTPServer class and uses it
  when the module is run with ``-m`` to cope with web browsers pre-opening
  sockets.

- bpo-27645: :class:`sqlite3.Connection` now exposes a
  :class:`~sqlite3.Connection.backup` method, if the underlying SQLite
  library is at version 3.6.11 or higher.  Patch by Lele Gaifax.

Documentation
-------------

- bpo-33126: Document PyBuffer_ToContiguous().

- bpo-27212: Modify documentation for the :func:`islice` recipe to consume
  initial values up to the start index.

- bpo-28247: Update :mod:`zipapp` documentation to describe how to make
  standalone applications.

- bpo-18802: Documentation changes for ipaddress.  Patch by Jon Foster and
  Berker Peksag.

- bpo-27428: Update documentation to clarify that ``WindowsRegistryFinder``
  implements ``MetaPathFinder``. (Patch by Himanshu Lakhara)

Tests
-----

- bpo-32872: Avoid regrtest compatibility issue with namespace packages.

- bpo-32517: Fix failing ``test_asyncio`` on macOS 10.12.2+ due to transport
  of ``KqueueSelector`` loop was not being closed.

- bpo-19417: Add test_bdb.py.

Build
-----

- bpo-33163: Upgrade pip to 9.0.3 and setuptools to v39.0.1.

Windows
-------

- bpo-33016: Fix potential use of uninitialized memory in
  nt._getfinalpathname

- bpo-32903: Fix a memory leak in os.chdir() on Windows if the current
  directory is set to a UNC path.

macOS
-----

- bpo-32726: Build and link with private copy of Tcl/Tk 8.6 for the macOS
  10.6+ installer. The 10.9+ installer variant already does this.  This
  means that the Python 3.7 provided by the python.org macOS installers no
  longer need or use any external versions of Tcl/Tk, either system-provided
  or user-installed, such as ActiveTcl.

IDLE
----

- bpo-32984: Set ``__file__`` while running a startup file.  Like Python,
  IDLE optionally runs one startup file in the Shell window before
  presenting the first interactive input prompt.  For IDLE, ``-s`` runs a
  file named in environmental variable  :envvar:`IDLESTARTUP` or
  :envvar:`PYTHONSTARTUP`; ``-r file`` runs ``file``.  Python sets
  ``__file__`` to the startup file name before running the file and unsets
  it before the first prompt.  IDLE now does the same when run normally,
  without the ``-n`` option.

- bpo-32940: Simplify and rename StringTranslatePseudoMapping in pyparse.

Tools/Demos
-----------

- bpo-32885: Add an ``-n`` flag for ``Tools/scripts/pathfix.py`` to disable
  automatic backup creation (files with ``~`` suffix).

C API
-----

- bpo-33042: Embedding applications may once again call
  PySys_ResetWarnOptions, PySys_AddWarnOption, and PySys_AddXOption prior to
  calling Py_Initialize.

- bpo-32374: Document that m_traverse for multi-phase initialized modules
  can be called with m_state=NULL, and add a sanity check


What's New in Python 3.7.0 beta 2?
==================================

*Release date: 2018-02-27*

Security
--------

- bpo-28414: The ssl module now allows users to perform their own IDN
  en/decoding when using SNI.

Core and Builtins
-----------------

- bpo-32889: Update Valgrind suppression list to account for the rename of
  ``Py_ADDRESS_IN_RANG`` to ``address_in_range``.

- bpo-31356: Remove the new API added in bpo-31356 (gc.ensure_disabled()
  context manager).

- bpo-32305: For namespace packages, ensure that both ``__file__`` and
  ``__spec__.origin`` are set to None.

- bpo-32303: Make sure ``__spec__.loader`` matches ``__loader__`` for
  namespace packages.

- bpo-32711: Fix the warning messages for Python/ast_unparse.c. Patch by
  Stéphane Wirtel

- bpo-32583: Fix possible crashing in builtin Unicode decoders caused by
  write out-of-bound errors when using customized decode error handlers.

Library
-------

- bpo-32960: For dataclasses, disallow inheriting frozen from non-frozen
  classes, and also disallow inheriting non-frozen from frozen classes. This
  restriction will be relaxed at a future date.

- bpo-32713: Fixed tarfile.itn handling of out-of-bounds float values. Patch
  by Joffrey Fuhrer.

- bpo-32951: Direct instantiation of SSLSocket and SSLObject objects is now
  prohibited. The constructors were never documented, tested, or designed as
  public constructors. Users were suppose to use ssl.wrap_socket() or
  SSLContext.

- bpo-32929: Remove the tri-state parameter "hash", and add the boolean
  "unsafe_hash". If unsafe_hash is True, add a __hash__ function, but if a
  __hash__ exists, raise TypeError.  If unsafe_hash is False, add a __hash__
  based on the values of eq= and frozen=.  The unsafe_hash=False behavior is
  the same as the old hash=None behavior.  unsafe_hash=False is the default,
  just as hash=None used to be.

- bpo-32947: Add OP_ENABLE_MIDDLEBOX_COMPAT and test workaround for TLSv1.3
  for future compatibility with OpenSSL 1.1.1.

- bpo-30622: The ssl module now detects missing NPN support in LibreSSL.

- bpo-32922: dbm.open() now encodes filename with the filesystem encoding
  rather than default encoding.

- bpo-32859: In ``os.dup2``, don't check every call whether the ``dup3``
  syscall exists or not.

- bpo-32556: nt._getfinalpathname, nt._getvolumepathname and
  nt._getdiskusage now correctly convert from bytes.

- bpo-25988: Emit a :exc:`DeprecationWarning` when using or importing an ABC
  directly from :mod:`collections` rather than from :mod:`collections.abc`.

- bpo-21060: Rewrite confusing message from setup.py upload from "No dist
  file created in earlier command" to the more helpful "Must create and
  upload files in one command".

- bpo-32852: Make sure sys.argv remains as a list when running trace.

- bpo-31333: ``_abc`` module is added.  It is a speedup module with C
  implementations for various functions and methods in ``abc``.  Creating an
  ABC subclass and calling ``isinstance`` or ``issubclass`` with an ABC
  subclass are up to 1.5x faster. In addition, this makes Python start-up up
  to 10% faster.

  Note that the new implementation hides internal registry and caches,
  previously accessible via private attributes ``_abc_registry``,
  ``_abc_cache``, and ``_abc_negative_cache``.  There are three debugging
  helper methods that can be used instead ``_dump_registry``,
  ``_abc_registry_clear``, and ``_abc_caches_clear``.

- bpo-32841: Fixed `asyncio.Condition` issue which silently ignored
  cancellation after notifying and cancelling a conditional lock. Patch by
  Bar Harel.

- bpo-32819: ssl.match_hostname() has been simplified and no longer depends
  on re and ipaddress module for wildcard and IP addresses. Error reporting
  for invalid wildcards has been improved.

- bpo-32394: socket: Remove
  TCP_FASTOPEN,TCP_KEEPCNT,TCP_KEEPIDLE,TCP_KEEPINTVL flags on older version
  Windows during run-time.

- bpo-31787: Fixed refleaks of ``__init__()`` methods in various modules.
  (Contributed by Oren Milman)

- bpo-30157: Fixed guessing quote and delimiter in csv.Sniffer.sniff() when
  only the last field is quoted.  Patch by Jake Davis.

- bpo-32792: collections.ChainMap() preserves the order of the underlying
  mappings.

- bpo-32775: :func:`fnmatch.translate()` no longer produces patterns which
  contain set operations. Sets starting with '[' or containing '--', '&&',
  '~~' or '||' will be interpreted differently in regular expressions in
  future versions. Currently they emit warnings. fnmatch.translate() now
  avoids producing patterns containing such sets by accident.

- bpo-32622: Implement native fast sendfile for Windows proactor event loop.

- bpo-32777: Fix a rare but potential pre-exec child process deadlock in
  subprocess on POSIX systems when marking file descriptors inheritable on
  exec in the child process.  This bug appears to have been introduced in
  3.4.

- bpo-32647: The ctypes module used to depend on indirect linking for
  dlopen. The shared extension is now explicitly linked against libdl on
  platforms with dl.

- bpo-32741: Implement ``asyncio.TimerHandle.when()`` method.

- bpo-32691: Use mod_spec.parent when running modules with pdb

- bpo-32734: Fixed ``asyncio.Lock()`` safety issue which allowed acquiring
  and locking the same lock multiple times, without it being free. Patch by
  Bar Harel.

- bpo-32727: Do not include name field in SMTP envelope from address. Patch
  by Stéphane Wirtel

- bpo-31453: Add TLSVersion constants and SSLContext.maximum_version /
  minimum_version attributes. The new API wraps OpenSSL 1.1
  https://www.openssl.org/docs/man1.1.0/ssl/SSL_CTX_set_min_proto_version.html
  feature.

- bpo-24334: Internal implementation details of ssl module were cleaned up.
  The SSLSocket has one less layer of indirection. Owner and session
  information are now handled by the SSLSocket and SSLObject constructor.
  Channel binding implementation has been simplified.

- bpo-31848: Fix the error handling in Aifc_read.initfp() when the SSND
  chunk is not found. Patch by Zackery Spytz.

- bpo-32585: Add Ttk spinbox widget to :mod:`tkinter.ttk`.  Patch by Alan D
  Moore.

- bpo-32221: Various functions returning tuple containing IPv6 addresses now
  omit ``%scope`` part since the same information is already encoded in
  *scopeid* tuple item. Especially this speeds up :func:`socket.recvfrom`
  when it receives multicast packet since useless resolving of network
  interface name is omitted.

- bpo-30693: The TarFile class now recurses directories in a reproducible
  way.

- bpo-30693: The ZipFile class now recurses directories in a reproducible
  way.

Documentation
-------------

- bpo-28124: The ssl module function ssl.wrap_socket() has been
  de-emphasized and deprecated in favor of the more secure and efficient
  SSLContext.wrap_socket() method.

- bpo-17232: Clarify docs for -O and -OO.  Patch by Terry Reedy.

- bpo-32436: Add documentation for the contextvars module (PEP 567).

- bpo-32800: Update link to w3c doc for xml default namespaces.

- bpo-11015: Update :mod:`test.support` documentation.

- bpo-8722: Document :meth:`__getattr__` behavior when property :meth:`get`
  method raises :exc:`AttributeError`.

- bpo-32614: Modify RE examples in documentation to use raw strings to
  prevent :exc:`DeprecationWarning` and add text to REGEX HOWTO to highlight
  the deprecation.

- bpo-31972: Improve docstrings for `pathlib.PurePath` subclasses.

Tests
-----

- bpo-31809: Add tests to verify connection with secp ECDH curves.

Build
-----

- bpo-32898: Fix the python debug build when using COUNT_ALLOCS.

Windows
-------

- bpo-32901: Update Tcl and Tk versions to 8.6.8

- bpo-31966: Fixed WindowsConsoleIO.write() for writing empty data.

- bpo-32409: Ensures activate.bat can handle Unicode contents.

- bpo-32457: Improves handling of denormalized executable path when
  launching Python.

- bpo-32370: Use the correct encoding for ipconfig output in the uuid
  module. Patch by Segev Finer.

- bpo-29248: Fix :func:`os.readlink` on Windows, which was mistakenly
  treating the ``PrintNameOffset`` field of the reparse data buffer as a
  number of characters instead of bytes. Patch by Craig Holmquist and SSE4.

macOS
-----

- bpo-32901: Update macOS 10.9+ installer to Tcl/Tk 8.6.8.

IDLE
----

- bpo-32916: Change ``str`` to ``code`` in pyparse.

- bpo-32905: Remove unused code in pyparse module.

- bpo-32874: Add tests for pyparse.

- bpo-32837: Using the system and place-dependent default encoding for
  open() is a bad idea for IDLE's system and location-independent files.

- bpo-32826: Add "encoding=utf-8" to open() in IDLE's test_help_about. GUI
  test test_file_buttons() only looks at initial ascii-only lines, but
  failed on systems where open() defaults to 'ascii' because readline()
  internally reads and decodes far enough ahead to encounter a non-ascii
  character in CREDITS.txt.

- bpo-32765: Update configdialog General tab docstring to add new widgets to
  the widget list.

Tools/Demos
-----------

- bpo-32222: Fix pygettext not extracting docstrings for functions with type
  annotated arguments. Patch by Toby Harradine.


What's New in Python 3.7.0 beta 1?
==================================

*Release date: 2018-01-30*

Core and Builtins
-----------------

- bpo-32703: Fix coroutine's ResourceWarning when there's an active error
  set when it's being finalized.

- bpo-32650: Pdb and other debuggers dependent on bdb.py will correctly step
  over (next command) native coroutines. Patch by Pablo Galindo.

- bpo-28685: Optimize list.sort() and sorted() by using type specialized
  comparisons when possible.

- bpo-32685: Improve suggestion when the Python 2 form of print statement is
  either present on the same line as the header of a compound statement or
  else terminated by a semi-colon instead of a newline. Patch by Nitish
  Chandra.

- bpo-32697: Python now explicitly preserves the definition order of
  keyword-only parameters.  It's always preserved their order, but this
  behavior was never guaranteed before; this behavior is now guaranteed and
  tested.

- bpo-32690: The locals() dictionary now displays in the lexical order that
  variables were defined.  Previously, the order was reversed.

- bpo-32677: Add ``.isascii()`` method to ``str``, ``bytes`` and
  ``bytearray``. It can be used to test that string contains only ASCII
  characters.

- bpo-32670: Enforce :pep:`479` for all code.

  This means that manually raising a StopIteration exception from a
  generator is prohibited for all code, regardless of whether 'from
  __future__ import generator_stop' was used or not.

- bpo-32591: Added built-in support for tracking the origin of coroutine
  objects; see sys.set_coroutine_origin_tracking_depth and
  CoroutineType.cr_origin. This replaces the asyncio debug mode's use of
  coroutine wrapping for native coroutine objects.

- bpo-31368: Expose preadv and pwritev system calls in the os module. Patch
  by Pablo Galindo

- bpo-32544: ``hasattr(obj, name)`` and ``getattr(obj, name, default)`` are
  about 4 times faster than before when ``name`` is not found and ``obj``
  doesn't override ``__getattr__`` or ``__getattribute__``.

- bpo-26163: Improved frozenset() hash to create more distinct hash values
  when faced with datasets containing many similar values.

- bpo-32550: Remove the STORE_ANNOTATION bytecode.

- bpo-20104: Expose posix_spawn as a low level API in the os module.
  (removed before 3.7.0rc1)

- bpo-24340: Fixed estimation of the code stack size.

- bpo-32436: Implement :pep:`567` Context Variables.

- bpo-18533: ``repr()`` on a dict containing its own ``values()`` or
  ``items()`` no longer raises ``RecursionError``; OrderedDict similarly.
  Instead, use ``...``, as for other recursive structures.  Patch by Ben
  North.

- bpo-20891: Py_Initialize() now creates the GIL. The GIL is no longer
  created "on demand" to fix a race condition when PyGILState_Ensure() is
  called in a non-Python thread.

- bpo-32028: Leading whitespace is now correctly ignored when generating
  suggestions for converting Py2 print statements to Py3 builtin print
  function calls. Patch by Sanyam Khurana.

- bpo-31179: Make dict.copy() up to 5.5 times faster.

- bpo-31113: Get rid of recursion in the compiler for normal control flow.

Library
-------

- bpo-25988: Deprecate exposing the contents of collections.abc in the
  regular collections module.

- bpo-31429: The default cipher suite selection of the ssl module now uses a
  blacklist approach rather than a hard-coded whitelist. Python no longer
  re-enables ciphers that have been blocked by OpenSSL security update.
  Default cipher suite selection can be configured on compile time.

- bpo-30306: contextlib.contextmanager now releases the arguments passed to
  the underlying generator as soon as the context manager is entered.
  Previously it would keep them alive for as long as the context manager was
  alive, even when not being used as a function decorator. Patch by Martin
  Teichmann.

- bpo-21417: Added support for setting the compression level for
  zipfile.ZipFile.

- bpo-32251: Implement asyncio.BufferedProtocol (provisional API).

- bpo-32513: In dataclasses, allow easier overriding of dunder methods
  without specifying decorator parameters.

- bpo-32660: :mod:`termios` makes available ``FIONREAD``, ``FIONCLEX``,
  ``FIOCLEX``, ``FIOASYNC`` and ``FIONBIO`` also under Solaris/derivatives.

- bpo-27931: Fix email address header parsing error when the username is an
  empty quoted string. Patch by Xiang Zhang.

- bpo-32659: Under Solaris and derivatives, :class:`os.stat_result` provides
  a st_fstype attribute.

- bpo-32662: Implement Server.start_serving(), Server.serve_forever(), and
  Server.is_serving() methods.  Add 'start_serving' keyword parameter to
  loop.create_server() and loop.create_unix_server().

- bpo-32391: Implement :meth:`asyncio.StreamWriter.wait_closed` and
  :meth:`asyncio.StreamWriter.is_closing` methods

- bpo-32643: Make Task._step, Task._wakeup and Future._schedule_callbacks
  methods private.

- bpo-32630: Refactor decimal module to use contextvars to store decimal
  context.

- bpo-32622: Add :meth:`asyncio.AbstractEventLoop.sendfile` method.

- bpo-32304: distutils' upload command no longer corrupts tar files ending
  with a CR byte, and no longer tries to convert CR to CRLF in any of the
  upload text fields.

- bpo-32502: uuid.uuid1 no longer raises an exception if a 64-bit hardware
  address is encountered.

- bpo-32596: ``concurrent.futures`` imports ``ThreadPoolExecutor`` and
  ``ProcessPoolExecutor`` lazily (using :pep:`562`). It makes ``import
  asyncio`` about 15% faster because asyncio uses only
  ``ThreadPoolExecutor`` by default.

- bpo-31801: Add ``_ignore_`` to ``Enum`` so temporary variables can be used
  during class construction without being turned into members.

- bpo-32576: Use queue.SimpleQueue() in places where it can be invoked from
  a weakref callback.

- bpo-32574: Fix memory leak in asyncio.Queue, when the queue has limited
  size and it is full, the cancelation of queue.put() can cause a memory
  leak. Patch by: José Melero.

- bpo-32521: The nis module is now compatible with new libnsl and headers
  location.

- bpo-32467: collections.abc.ValuesView now inherits from
  collections.abc.Collection.

- bpo-32473: Improve ABCMeta._dump_registry() output readability

- bpo-32102: New argument ``capture_output`` for subprocess.run

- bpo-32521: glibc has removed Sun RPC. Use replacement libtirpc headers and
  library in nis module.

- bpo-32493: UUID module fixes build for FreeBSD/OpenBSD

- bpo-32503: Pickling with protocol 4 no longer creates too small frames.

- bpo-29237: Create enum for pstats sorting options

- bpo-32454: Add close(fd) function to the socket module.

- bpo-25942: The subprocess module is now more graceful when handling a
  Ctrl-C KeyboardInterrupt during subprocess.call, subprocess.run, or a
  Popen context manager.  It now waits a short amount of time for the child
  (presumed to have also gotten the SIGINT) to exit, before continuing the
  KeyboardInterrupt exception handling.  This still includes a SIGKILL in
  the call() and run() APIs, but at least the child had a chance first.

- bpo-32433: The hmac module now has hmac.digest(), which provides an
  optimized HMAC digest.

- bpo-28134: Sockets now auto-detect family, type and protocol from file
  descriptor by default.

- bpo-32404: Fix bug where :meth:`datetime.datetime.fromtimestamp` did not
  call __new__ in :class:`datetime.datetime` subclasses.

- bpo-32403: Improved speed of :class:`datetime.date` and
  :class:`datetime.datetime` alternate constructors.

- bpo-32228: Ensure that ``truncate()`` preserves the file position (as
  reported by ``tell()``) after writes longer than the buffer size.

- bpo-32410: Implement ``loop.sock_sendfile`` for asyncio event loop.

- bpo-22908: Added seek and tell to the ZipExtFile class. This only works if
  the file object used to open the zipfile is seekable.

- bpo-32373: Add socket.getblocking() method.

- bpo-32248: Add :mod:`importlib.resources` and
  :class:`importlib.abc.ResourceReader` as the unified API for reading
  resources contained within packages.  Loaders wishing to support resource
  reading must implement the :meth:`get_resource_reader()` method.
  File-based and zipimport-based loaders both implement these APIs.
  :class:`importlib.abc.ResourceLoader` is deprecated in favor of these new
  APIs.

- bpo-32320: collections.namedtuple() now supports default values.

- bpo-29302: Add contextlib.AsyncExitStack. Patch by Alexander Mohr and Ilya
  Kulakov.

- bpo-31961: *Removed in Python 3.7.0b2.* The *args* argument of
  subprocess.Popen can now be a :term:`path-like object`. If *args* is given
  as a sequence, it's first element can now be a :term:`path-like object` as
  well.

- bpo-31900: The :func:`locale.localeconv` function now sets temporarily the
  ``LC_CTYPE`` locale to the ``LC_NUMERIC`` locale to decode
  ``decimal_point`` and ``thousands_sep`` byte strings if they are non-ASCII
  or longer than 1 byte, and the ``LC_NUMERIC`` locale is different than the
  ``LC_CTYPE`` locale. This temporary change affects other threads.

  Same change for the :meth:`str.format` method when formatting a number
  (:class:`int`, :class:`float`, :class:`float` and subclasses) with the
  ``n`` type (ex: ``'{:n}'.format(1234)``).

- bpo-31853: Use super().method instead of socket.method in SSLSocket.  They
  were there most likely for legacy reasons.

- bpo-31399: The ssl module now uses OpenSSL's X509_VERIFY_PARAM_set1_host()
  and X509_VERIFY_PARAM_set1_ip() API to verify hostname and IP addresses.
  Subject common name fallback can be disabled with
  SSLContext.hostname_checks_common_name.

- bpo-14976: Add a queue.SimpleQueue class, an unbounded FIFO queue with a
  reentrant C implementation of put().

Documentation
-------------

- bpo-32724: Add references to some commands in the documentation of Pdb.
  Patch by Stéphane Wirtel

- bpo-32649: Complete the C API documentation, profiling and tracing part
  with the newly added per-opcode events.

- bpo-17799: Explain real behaviour of sys.settrace and sys.setprofile and
  their C-API counterparts regarding which type of events are received in
  each function. Patch by Pablo Galindo Salgado.

Tests
-----

- bpo-32721: Fix test_hashlib to not fail if the _md5 module is not built.

- bpo-28414: Add test cases for IDNA 2003 and 2008 host names. IDNA 2003
  internationalized host names are working since bpo-31399 has landed. IDNA
  2008 are still broken.

- bpo-32604: Add a new "_xxsubinterpreters" extension module that exposes
  the existing subinterpreter C-API and a new cross-interpreter data sharing
  mechanism. The module is primarily intended for more thorough testing of
  the existing subinterpreter support.

  Note that the _xxsubinterpreters module has been removed in 3.7.0rc1.

- bpo-32602: Add test certs and test for ECDSA cert and EC/RSA dual mode.

- bpo-32549: On Travis CI, Python now Compiles and uses a local copy of
  OpenSSL 1.1.0g for testing.

Build
-----

- bpo-32635: Fix segfault of the crypt module when libxcrypt is provided
  instead of libcrypt at the system.

- bpo-32598: Use autoconf to detect OpenSSL libs, headers and supported
  features. The ax_check_openssl M4 macro uses pkg-config to locate OpenSSL
  and falls back to manual search.

- bpo-32593: Drop support of FreeBSD 9 and older.

- bpo-29708: If the :envvar:`SOURCE_DATE_EPOCH` environment variable is set,
  :mod:`py_compile` will always create hash-based ``.pyc`` files.

Windows
-------

- bpo-32588: Create standalone _distutils_findvs module and add missing
  _queue module to installer.

- bpo-29911: Ensure separate Modify and Uninstall buttons are displayed.

- bpo-32507: Use app-local UCRT install rather than the proper update for
  old versions of Windows.

macOS
-----

- bpo-32726: Provide an additional, more modern macOS installer variant that
  supports macOS 10.9+ systems in 64-bit mode only.  Upgrade the supplied
  third-party libraries to OpenSSL 1.1.0g and to SQLite 3.22.0.  The 10.9+
  installer now links with and supplies its own copy of Tcl/Tk 8.6.

- bpo-28440: No longer add /Library/Python/3.x/site-packages to sys.path for
  macOS framework builds to avoid future conflicts.

C API
-----

- bpo-32681: Fix uninitialized variable 'res' in the C implementation of
  os.dup2. Patch by Stéphane Wirtel

- bpo-10381: Add C API access to the ``datetime.timezone`` constructor and
  ``datetime.timzone.UTC`` singleton.


What's New in Python 3.7.0 alpha 4?
===================================

*Release date: 2018-01-08*

Core and Builtins
-----------------

- bpo-31975: The default warning filter list now starts with a
  "default::DeprecationWarning:__main__" entry, so deprecation warnings are
  once again shown by default in single-file scripts and at the interactive
  prompt.

- bpo-32226: ``__class_getitem__`` is now an automatic class method.

- bpo-32399: Add AIX uuid library support for RFC4122 using uuid_create() in
  libc.a

- bpo-32390: Fix the compilation failure on AIX after the f_fsid field has
  been added to the object returned by os.statvfs() (issue #32143). Original
  patch by Michael Felt.

- bpo-32379: Make MRO computation faster when a class inherits from a single
  base.

- bpo-32259: The error message of a TypeError raised when unpack
  non-iterable is now more specific.

- bpo-27169: The ``__debug__`` constant is now optimized out at compile
  time. This fixes also bpo-22091.

- bpo-32329: The :option:`-R` option now turns on hash randomization when
  the :envvar:`PYTHONHASHSEED` environment variable is set to ``0``.
  Previously, the option was ignored. Moreover,
  ``sys.flags.hash_randomization`` is now properly set to 0 when hash
  randomization is turned off by ``PYTHONHASHSEED=0``.

- bpo-30416: The optimizer is now protected from spending much time doing
  complex calculations and consuming much memory for creating large
  constants in constant folding. Increased limits for constants that can be
  produced in constant folding.

- bpo-32282: Fix an unnecessary ifdef in the include of VersionHelpers.h in
  socketmodule on Windows.

- bpo-30579: Implement TracebackType.__new__ to allow Python-level creation
  of traceback objects, and make TracebackType.tb_next mutable.

- bpo-32260: Don't byte swap the input keys to the SipHash algorithm on
  big-endian platforms. This should ensure siphash gives consistent results
  across platforms.

- bpo-31506: Improve the error message logic for object.__new__ and
  object.__init__. Patch by Sanyam Khurana.

- bpo-20361: ``-b`` and ``-bb`` now inject ``'default::BytesWarning'`` and
  ``error::BytesWarning`` entries into ``sys.warnoptions``, ensuring that
  they take precedence over any other warning filters configured via the
  ``-W`` option or the ``PYTHONWARNINGS`` environment variable.

- bpo-32230: `-X dev` now injects a ``'default'`` entry into
  sys.warnoptions, ensuring that it behaves identically to actually passing
  ``-Wdefault`` at the command line.

- bpo-29240: Add a new UTF-8 mode: implementation of the :pep:`540`.

- bpo-32226: :pep:`560`: Add support for ``__mro_entries__`` and
  ``__class_getitem__``. Implemented by Ivan Levkivskyi.

- bpo-32225: :pep:`562`: Add support for module ``__getattr__`` and
  ``__dir__``. Implemented by Ivan Levkivskyi.

- bpo-31901: The `atexit` module now has its callback stored per
  interpreter.

- bpo-31650: Implement :pep:`552` (Deterministic pycs). Python now supports
  invalidating bytecode cache files bashed on a source content hash rather
  than source last-modified time.

- bpo-29469: Move constant folding from bytecode layer to AST layer.
  Original patch by Eugene Toder.

Library
-------

- bpo-32506: Now that dict is defined as keeping insertion order, drop
  OrderedDict and just use plain dict.

- bpo-32279: Add params to dataclasses.make_dataclasses(): init, repr, eq,
  order, hash, and frozen.  Pass them through to dataclass().

- bpo-32278: Make type information optional on dataclasses.make_dataclass().
  If omitted, the string 'typing.Any' is used.

- bpo-32499: Add dataclasses.is_dataclass(obj), which returns True if obj is
  a dataclass or an instance of one.

- bpo-32468: Improve frame repr() to mention filename, code name and current
  line number.

- bpo-23749: asyncio: Implement loop.start_tls()

- bpo-32441: Return the new file descriptor (i.e., the second argument) from
  ``os.dup2``. Previously, ``None`` was always returned.

- bpo-32422: ``functools.lru_cache`` uses less memory (3 words for each
  cached key) and takes about 1/3 time for cyclic GC.

- bpo-31721: Prevent Python crash from happening when Future._log_traceback
  is set to True manually.  Now it can only be set to False, or a ValueError
  is raised.

- bpo-32415: asyncio: Add Task.get_loop() and Future.get_loop()

- bpo-26133: Don't unsubscribe signals in asyncio UNIX event loop on
  interpreter shutdown.

- bpo-32363: Make asyncio.Task.set_exception() and set_result() raise
  NotImplementedError. Task._step() and Future.__await__() raise proper
  exceptions when they are in an invalid state, instead of raising an
  AssertionError.

- bpo-32357: Optimize asyncio.iscoroutine() and loop.create_task() for
  non-native coroutines (e.g. async/await compiled with Cython).

  'loop.create_task(python_coroutine)' used to be 20% faster than
  'loop.create_task(cython_coroutine)'.  Now, the latter is as fast.

- bpo-32356: asyncio.transport.resume_reading() and pause_reading() are now
  idempotent. New transport.is_reading() method is added.

- bpo-32355: Optimize asyncio.gather(); now up to 15% faster.

- bpo-32351: Use fastpath in asyncio.sleep if delay<0 (2x boost)

- bpo-32348: Optimize asyncio.Future schedule/add/remove callback.  The
  optimization shows 3-6% performance improvements of async/await code.

- bpo-32331: Fix socket.settimeout() and socket.setblocking() to keep
  socket.type as is. Fix socket.socket() constructor to reset any bit flags
  applied to socket's type.  This change only affects OSes that have
  SOCK_NONBLOCK and/or SOCK_CLOEXEC.

- bpo-32248: Add :class:`importlib.abc.ResourceReader` as an ABC for loaders
  to provide a unified API for reading resources contained within packages.
  Also add :mod:`importlib.resources` as the port of
  ``importlib_resources``.

- bpo-32311: Implement asyncio.create_task(coro) shortcut

- bpo-32327: Convert asyncio functions that were documented as coroutines to
  coroutines. Affected functions: loop.sock_sendall, loop.sock_recv,
  loop.sock_accept, loop.getaddrinfo, loop.getnameinfo.

- bpo-32323: :func:`urllib.parse.urlsplit()` does not convert zone-id
  (scope) to lower case for scoped IPv6 addresses in hostnames now.

- bpo-32302: Fix bdist_wininst of distutils for CRT v142: it binary
  compatible with CRT v140.

- bpo-29711: Fix ``stop_serving`` in asyncio proactor loop kill all
  listening servers

- bpo-32308: :func:`re.sub()` now replaces empty matches adjacent to a
  previous non-empty match.

- bpo-29970: Abort asyncio SSLProtocol connection if handshake not complete
  within 10s

- bpo-32314: Implement asyncio.run().

- bpo-17852: Revert incorrect fix based on misunderstanding of
  _Py_PyAtExit() semantics.

- bpo-32296: Implement asyncio._get_running_loop() and get_event_loop() in
  C. This makes them 4x faster.

- bpo-32250: Implement ``asyncio.current_task()`` and
  ``asyncio.all_tasks()``. Add helpers intended to be used by alternative
  task implementations: ``asyncio._register_task``, ``asyncio._enter_task``,
  ``asyncio._leave_task`` and ``asyncio._unregister_task``. Deprecate
  ``asyncio.Task.current_task()`` and ``asyncio.Task.all_tasks()``.

- bpo-32255: A single empty field is now always quoted when written into a
  CSV file. This allows to distinguish an empty row from a row consisting of
  a single empty field. Patch by Licht Takeuchi.

- bpo-32277: Raise ``NotImplementedError`` instead of ``SystemError`` on
  platforms where ``chmod(..., follow_symlinks=False)`` is not supported.
  Patch by Anthony Sottile.

- bpo-30050: New argument warn_on_full_buffer to signal.set_wakeup_fd lets
  you control whether Python prints a warning on stderr when the wakeup fd
  buffer overflows.

- bpo-29137: The ``fpectl`` library has been removed. It was never enabled
  by default, never worked correctly on x86-64, and it changed the Python
  ABI in ways that caused unexpected breakage of C extensions.

- bpo-32273: Move asyncio.test_utils to test.test_asyncio.

- bpo-32272: Remove asyncio.async() function.

- bpo-32269: Add asyncio.get_running_loop() function.

- bpo-32265: All class and static methods of builtin types now are correctly
  classified by inspect.classify_class_attrs() and grouped in pydoc ouput.
  Added types.ClassMethodDescriptorType for unbound class methods of builtin
  types.

- bpo-32253: Deprecate ``yield from lock``, ``await lock``, ``with (yield
  from lock)`` and ``with await lock`` for asyncio synchronization
  primitives.

- bpo-22589: Changed MIME type of .bmp from 'image/x-ms-bmp' to 'image/bmp'

- bpo-32193: Convert asyncio to use *async/await* syntax. Old styled ``yield
  from`` is still supported too.

- bpo-32206: Add support to run modules with pdb

- bpo-32227: ``functools.singledispatch`` now supports registering
  implementations using type annotations.

- bpo-15873: Added new alternate constructors
  :meth:`datetime.datetime.fromisoformat`,
  :meth:`datetime.time.fromisoformat` and
  :meth:`datetime.date.fromisoformat` as the inverse operation of each
  classes's respective ``isoformat`` methods.

- bpo-32199: The getnode() ip getter now uses 'ip link' instead of 'ip link
  list'.

- bpo-32143: os.statvfs() includes the f_fsid field from statvfs(2)

- bpo-26439: Fix ctypes.util.find_library() for AIX by implementing
  ctypes._aix.find_library() Patch by: Michael Felt

- bpo-31993: The pickler now uses less memory when serializing large bytes
  and str objects into a file.  Pickles created with protocol 4 will require
  less memory for unpickling large bytes and str objects.

- bpo-27456: Ensure TCP_NODELAY is set on Linux. Tests by Victor Stinner.

- bpo-31778: ast.literal_eval() is now more strict. Addition and subtraction
  of arbitrary numbers no longer allowed.

- bpo-31802: Importing native path module (``posixpath``, ``ntpath``) now
  works even if the ``os`` module still is not imported.

- bpo-30241: Add contextlib.AbstractAsyncContextManager. Patch by Jelle
  Zijlstra.

- bpo-31699: Fix deadlocks in
  :class:`concurrent.futures.ProcessPoolExecutor` when task arguments or
  results cause pickling or unpickling errors. This should make sure that
  calls to the :class:`ProcessPoolExecutor` API always eventually return.

- bpo-15216: ``TextIOWrapper.reconfigure()`` supports changing *encoding*,
  *errors*, and *newline*.

Documentation
-------------

- bpo-32418: Add get_loop() method to Server and AbstractServer classes.

Tests
-----

- bpo-32252: Fix faulthandler_suppress_crash_report() used to prevent core
  dump files when testing crashes. getrlimit() returns zero on success.

- bpo-32002: Adjust C locale coercion testing for the empty locale and POSIX
  locale cases to more readily adjust to platform dependent behaviour.

Windows
-------

- bpo-19764: Implement support for `subprocess.Popen(close_fds=True)` on
  Windows. Patch by Segev Finer.

Tools/Demos
-----------

- bpo-24960: 2to3 and lib2to3 can now read pickled grammar files using
  pkgutil.get_data() rather than probing the filesystem. This lets 2to3 and
  lib2to3 work when run from a zipfile.

C API
-----

- bpo-32030: Py_Initialize() doesn't reset the memory allocators to default
  if the ``PYTHONMALLOC`` environment variable is not set.

- bpo-29084: Undocumented C API for OrderedDict has been excluded from the
  limited C API. It was added by mistake and actually never worked in the
  limited C API.

- bpo-32264: Moved the pygetopt.h header into internal/, since it has no
  public APIs.

- bpo-32241: :c:func:`Py_SetProgramName` and :c:func:`Py_SetPythonHome` now
  take the ``const wchar *`` arguments instead of ``wchar *``.


What's New in Python 3.7.0 alpha 3?
===================================

*Release date: 2017-12-05*

Core and Builtins
-----------------

- bpo-32176: co_flags.CO_NOFREE is now always set correctly by the code
  object constructor based on freevars and cellvars, rather than needing to
  be set correctly by the caller. This ensures it will be cleared
  automatically when additional cell references are injected into a modified
  code object and function.

- bpo-10544: Yield expressions are now deprecated in comprehensions and
  generator expressions. They are still permitted in the definition of the
  outermost iterable, as that is evaluated directly in the enclosing scope.

- bpo-32137: The repr of deeply nested dict now raises a RecursionError
  instead of crashing due to a stack overflow.

- bpo-32096: Revert memory allocator changes in the C API: move structures
  back from _PyRuntime to Objects/obmalloc.c. The memory allocators are once
  again initialized statically, and so PyMem_RawMalloc() and
  Py_DecodeLocale() can be called before _PyRuntime_Initialize().

- bpo-32043: Add a new "developer mode": new "-X dev" command line option to
  enable debug checks at runtime.

- bpo-32023: SyntaxError is now correctly raised when a generator expression
  without parenthesis is used instead of an inheritance list in a class
  definition. The duplication of the parentheses can be omitted only on
  calls.

- bpo-32012: SyntaxError is now correctly raised when a generator expression
  without parenthesis is passed as an argument, but followed by a trailing
  comma. A generator expression always needs to be directly inside a set of
  parentheses and cannot have a comma on either side.

- bpo-28180: A new internal ``_Py_SetLocaleFromEnv(category)`` helper
  function has been added in order to improve the consistency of behaviour
  across different ``libc`` implementations (e.g. Android doesn't support
  setting the locale from the environment by default).

- bpo-31949: Fixed several issues in printing tracebacks
  (PyTraceBack_Print()).

  * Setting sys.tracebacklimit to 0 or less now suppresses printing tracebacks.
  * Setting sys.tracebacklimit to None now causes using the default limit.
  * Setting sys.tracebacklimit to an integer larger than LONG_MAX now means using
    the limit LONG_MAX rather than the default limit.
  * Fixed integer overflows in the case of more than 2**31 traceback items on
    Windows.
  * Fixed output errors handling.

- bpo-30696: Fix the interactive interpreter looping endlessly when no
  memory.

- bpo-20047: Bytearray methods partition() and rpartition() now accept only
  bytes-like objects as separator, as documented.  In particular they now
  raise TypeError rather of returning a bogus result when an integer is
  passed as a separator.

- bpo-21720: BytesWarning no longer emitted when the *fromlist* argument of
  ``__import__()`` or the ``__all__`` attribute of the module contain bytes
  instances.

- bpo-31845: Environment variables are once more read correctly at
  interpreter startup.

- bpo-28936: Ensure that lexically first syntax error involving a parameter
  and ``global`` or ``nonlocal`` is detected first at a given scope. Patch
  by Ivan Levkivskyi.

- bpo-31825: Fixed OverflowError in the 'unicode-escape' codec and in
  codecs.escape_decode() when decode an escaped non-ascii byte.

- bpo-31618: The per-frame tracing logic added in 3.7a1 has been altered so
  that ``frame->f_lineno`` is updated before either ``"line"`` or
  ``"opcode"`` events are emitted. Previously, opcode events were emitted
  first, and therefore would occasionally see stale line numbers on the
  frame. The behavior of this feature has changed slightly as a result: when
  both ``f_trace_lines`` and ``f_trace_opcodes`` are enabled, line events
  now occur first.

- bpo-28603: Print the full context/cause chain of exceptions on interpreter
  exit, even if an exception in the chain is unhashable or compares equal to
  later ones. Patch by Zane Bitter.

- bpo-31786: Fix timeout rounding in the select module to round correctly
  negative timeouts between -1.0 and 0.0. The functions now block waiting
  for events as expected. Previously, the call was incorrectly non-blocking.
  Patch by Pablo Galindo.

- bpo-31781: Prevent crashes when calling methods of an uninitialized
  ``zipimport.zipimporter`` object. Patch by Oren Milman.

- bpo-30399: Standard repr() of BaseException with a single argument no
  longer contains redundant trailing comma.

- bpo-31626: Fixed a bug in debug memory allocator.  There was a write to
  freed memory after shrinking a memory block.

- bpo-30817: `PyErr_PrintEx()` clears now the ignored exception that may be
  raised by `_PySys_SetObjectId()`, for example when no memory.

Library
-------

- bpo-28556: Two minor fixes for ``typing`` module: allow shallow copying
  instances of generic classes, improve interaction of ``__init_subclass__``
  with generics. Original PRs by Ivan Levkivskyi.

- bpo-32214: PEP 557, Data Classes. Provides a decorator which adds
  boilerplate methods to classes which use type annotations so specify
  fields.

- bpo-27240: The header folding algorithm for the new email policies has
  been rewritten, which also fixes bpo-30788, bpo-31831, and bpo-32182.  In
  particular, RFC2231 folding is now done correctly.

- bpo-32186: io.FileIO.readall() and io.FileIO.read() now release the GIL
  when getting the file size. Fixed hang of all threads with inaccessible
  NFS server. Patch by Nir Soffer.

- bpo-321010: Add :attr:`sys.flags.dev_mode` flag

- bpo-32154: The ``asyncio.windows_utils.socketpair()`` function has been
  removed: use directly :func:`socket.socketpair` which is available on all
  platforms since Python 3.5 (before, it wasn't available on Windows).
  ``asyncio.windows_utils.socketpair()`` was just an alias to
  ``socket.socketpair`` on Python 3.5 and newer.

- bpo-32089: warnings: In development (-X dev) and debug mode (pydebug
  build), use the "default" action for ResourceWarning, rather than the
  "always" action, in the default warnings filters.

- bpo-32107: ``uuid.getnode()`` now preferentially returns universally
  administered MAC addresses if available, over locally administered MAC
  addresses.  This makes a better guarantee for global uniqueness of UUIDs
  returned from ``uuid.uuid1()``.  If only locally administered MAC
  addresses are available, the first such one found is returned.

- bpo-23033: Wildcard is now supported in hostname when it is one and only
  character in the left most segment of hostname in second argument of
  :meth:`ssl.match_hostname`.  Patch by Mandeep Singh.

- bpo-12239: Make :meth:`msilib.SummaryInformation.GetProperty` return
  ``None`` when the value of property is ``VT_EMPTY``.  Initial patch by
  Mark Mc Mahon.

- bpo-28334: Use :func:`os.path.expanduser` to find the ``~/.netrc`` file in
  :class:`netrc.netrc`.  If it does not exist, :exc:`FileNotFoundError` is
  raised.  Patch by Dimitri Merejkowsky.

- bpo-32121: Made ``tracemalloc.Traceback`` behave more like the traceback
  module, sorting the frames from oldest to most recent.
  ``Traceback.format()`` now accepts negative *limit*, truncating the result
  to the ``abs(limit)`` oldest frames. To get the old behaviour, one can use
  the new *most_recent_first* argument to ``Traceback.format()``. (Patch by
  Jesse Bakker.)

- bpo-31325: Fix wrong usage of :func:`collections.namedtuple` in the
  :meth:`RobotFileParser.parse() <urllib.robotparser.RobotFileParser.parse>`
  method.

  Initial patch by Robin Wellner.

- bpo-12382: :func:`msilib.OpenDatabase` now raises a better exception
  message when it couldn't open or create an MSI file.  Initial patch by
  William Tisäter.

- bpo-19610: ``setup()`` now warns about invalid types for some fields.

  The ``distutils.dist.Distribution`` class now warns when ``classifiers``,
  ``keywords`` and ``platforms`` fields are not specified as a list or a
  string.

- bpo-32071: Added the ``-k`` command-line option to ``python -m unittest``
  to run only tests that match the given pattern(s).

- bpo-10049: Added *nullcontext* no-op context manager to contextlib. This
  provides a simpler and faster alternative to ExitStack() when handling
  optional context managers.

- bpo-28684: The new test.support.skip_unless_bind_unix_socket() decorator
  is used here to skip asyncio tests that fail because the platform lacks a
  functional bind() function for unix domain sockets (as it is the case for
  non root users on the recent Android versions that run now SELinux in
  enforcing mode).

- bpo-32110: ``codecs.StreamReader.read(n)`` now returns not more than *n*
  characters/bytes for non-negative *n*. This makes it compatible with
  ``read()`` methods of other file-like objects.

- bpo-27535: The warnings module doesn't leak memory anymore in the hidden
  warnings registry for the "ignore" action of warnings filters.
  warn_explicit() function doesn't add the warning key to the registry
  anymore for the "ignore" action.

- bpo-32088: warnings:  When Python is build is debug mode (``Py_DEBUG``),
  :exc:`DeprecationWarning`, :exc:`PendingDeprecationWarning` and
  :exc:`ImportWarning` warnings are now displayed by default.

- bpo-1647489: Fixed searching regular expression patterns that could match
  an empty string. Non-empty string can now be correctly found after
  matching an empty string.

- bpo-25054: Added support of splitting on a pattern that could match an
  empty string.

- bpo-32072: Fixed issues with binary plists:

  * Fixed saving bytearrays.
  * Identical objects will be saved only once.
  * Equal references will be load as identical objects.
  * Added support for saving and loading recursive data structures.

- bpo-32069: Drop legacy SSL transport from asyncio, ssl.MemoryBIO is always
  used anyway.

- bpo-32066: asyncio: Support pathlib.Path in create_unix_connection; sock
  arg should be optional

- bpo-32046: Updates 2to3 to convert from operator.isCallable(obj) to
  callable(obj). Patch by Dong-hee Na.

- bpo-32018: inspect.signature should follow PEP 8, if the parameter has an
  annotation and a default value. Patch by Dong-hee Na.

- bpo-32025: Add time.thread_time() and time.thread_time_ns()

- bpo-32037: Integers that fit in a signed 32-bit integer will be now
  pickled with protocol 0 using the INT opcode.  This will decrease the size
  of a pickle, speed up pickling and unpickling, and make these integers be
  unpickled as int instances in Python 2.

- bpo-32034: Make asyncio.IncompleteReadError and LimitOverrunError
  pickleable.

- bpo-32015: Fixed the looping of asyncio in the case of reconnection the
  socket during waiting async read/write from/to the socket.

- bpo-32011: Restored support of loading marshal files with the TYPE_INT64
  code. These files can be produced in Python 2.7.

- bpo-28369: Enhance add_reader/writer check that socket is not used by some
  transport. Before, only cases when add_reader/writer were called with an
  int FD were supported.  Now the check is implemented correctly for all
  file-like objects.

- bpo-31976: Fix race condition when flushing a file is slow, which can
  cause a segfault if closing the file from another thread.

- bpo-31985: Formally deprecated aifc.openfp, sunau.openfp, and wave.openfp.
  Since change 7bc817d5ba917528e8bd07ec461c635291e7b06a in 1993, openfp in
  each of the three modules had been pointing to that module's open function
  as a matter of backwards compatibility, though it had been both untested
  and undocumented.

- bpo-21862: cProfile command line now accepts `-m module_name` as an
  alternative to script path. Patch by Sanyam Khurana.

- bpo-31970: Reduce performance overhead of asyncio debug mode.

- bpo-31843: *database* argument of sqlite3.connect() now accepts a
  :term:`path-like object`, instead of just a string.

- bpo-31945: Add Configurable *blocksize* to ``HTTPConnection`` and
  ``HTTPSConnection`` for improved upload throughput.  Patch by Nir Soffer.

- bpo-31943: Add a ``cancelled()`` method to :class:`asyncio.Handle`.  Patch
  by Marat Sharafutdinov.

- bpo-9678: Fixed determining the MAC address in the uuid module:

  * Using ifconfig on NetBSD and OpenBSD.
  * Using arp on Linux, FreeBSD, NetBSD and OpenBSD.

  Based on patch by Takayuki Shimizukawa.

- bpo-30057: Fix potential missed signal in signal.signal().

- bpo-31933: Fix Blake2 params leaf_size and node_offset on big endian
  platforms. Patch by Jack O'Connor.

- bpo-21423: Add an initializer argument to {Process,Thread}PoolExecutor

- bpo-31927: Fixed compilation of the socket module on NetBSD 8.  Fixed
  assertion failure or reading arbitrary data when parse a AF_BLUETOOTH
  address on NetBSD and DragonFly BSD.

- bpo-27666: Fixed stack corruption in curses.box() and curses.ungetmouse()
  when the size of types chtype or mmask_t is less than the size of C long.
  curses.box() now accepts characters as arguments.  Based on patch by Steve
  Fink.

- bpo-31917: Add 3 new clock identifiers: :data:`time.CLOCK_BOOTTIME`,
  :data:`time.CLOCK_PROF` and :data:`time.CLOCK_UPTIME`.

- bpo-31897: plistlib now catches more errors when read binary plists and
  raises InvalidFileException instead of unexpected exceptions.

- bpo-25720: Fix the method for checking pad state of curses WINDOW. Patch
  by Masayuki Yamamoto.

- bpo-31893: Fixed the layout of the kqueue_event structure on OpenBSD and
  NetBSD. Fixed the comparison of the kqueue_event objects.

- bpo-31891: Fixed building the curses module on NetBSD.

- bpo-31884: added required constants to subprocess module for setting
  priority on windows

- bpo-28281: Remove year (1-9999) limits on the Calendar.weekday() function.

  Patch by Mark Gollahon.

- bpo-31702: crypt.mksalt() now allows to specify the number of rounds for
  SHA-256 and SHA-512 hashing.

- bpo-30639: :func:`inspect.getfile` no longer computes the repr of unknown
  objects to display in an error message, to protect against badly behaved
  custom reprs.

- bpo-30768: Fix the pthread+semaphore implementation of
  PyThread_acquire_lock_timed() when called with timeout > 0 and
  intr_flag=0: recompute the timeout if sem_timedwait() is interrupted by a
  signal (EINTR). See also the :pep:`475`.

- bpo-31854: Add ``mmap.ACCESS_DEFAULT`` constant.

- bpo-31834: Use optimized code for BLAKE2 only with SSSE3+. The pure SSE2
  implementation is slower than the pure C reference implementation.

- bpo-28292: Calendar.itermonthdates() will now consistently raise an
  exception when a date falls outside of the 0001-01-01 through 9999-12-31
  range.  To support applications that cannot tolerate such exceptions, the
  new methods itermonthdays3() and itermonthdays4() are added.  The new
  methods return tuples and are not restricted by the range supported by
  datetime.date.

- bpo-28564: The shutil.rmtree() function has been sped up to 20--40%. This
  was done using the os.scandir() function.

- bpo-28416: Instances of pickle.Pickler subclass with the persistent_id()
  method and pickle.Unpickler subclass with the persistent_load() method no
  longer create reference cycles.

- bpo-31653: Don't release the GIL if we can acquire a multiprocessing
  semaphore immediately.

- bpo-28326: Fix multiprocessing.Process when stdout and/or stderr is closed
  or None.

- bpo-20825: Add `subnet_of` and `superset_of` containment tests to
  :class:`ipaddress.IPv6Network` and :class:`ipaddress.IPv4Network`. Patch
  by Michel Albert and Cheryl Sabella.

- bpo-31827: Remove the os.stat_float_times() function. It was introduced in
  Python 2.3 for backward compatibility with Python 2.2, and was deprecated
  since Python 3.1.

- bpo-31756: Add a ``subprocess.Popen(text=False)`` keyword argument to
  `subprocess` functions to be more explicit about when the library should
  attempt to decode outputs into text. Patch by Andrew Clegg.

- bpo-31819: Add AbstractEventLoop.sock_recv_into().

- bpo-31457: If nested log adapters are used, the inner ``process()``
  methods are no longer omitted.

- bpo-31457: The ``manager`` property on LoggerAdapter objects is now
  properly settable.

- bpo-31806: Fix timeout rounding in time.sleep(), threading.Lock.acquire()
  and socket.socket.settimeout() to round correctly negative timeouts
  between -1.0 and 0.0. The functions now block waiting for events as
  expected. Previously, the call was incorrectly non-blocking. Patch by
  Pablo Galindo.

- bpo-31803: time.clock() and time.get_clock_info('clock') now emit a
  DeprecationWarning warning.

- bpo-31800: Extended support for parsing UTC offsets. strptime '%z' can now
  parse the output generated by datetime.isoformat, including seconds and
  microseconds.

- bpo-28603: traceback: Fix a TypeError that occurred during printing of
  exception tracebacks when either the current exception or an exception in
  its context/cause chain is unhashable. Patch by Zane Bitter.

- bpo-30541: Add new function to seal a mock and prevent the automatically
  creation of child mocks. Patch by Mario Corchero.

- bpo-31784: Implement the :pep:`564`, add new 6 new functions with
  nanosecond resolution to the :mod:`time` module:
  :func:`~time.clock_gettime_ns`, :func:`~time.clock_settime_ns`,
  :func:`~time.monotonic_ns`, :func:`~time.perf_counter_ns`,
  :func:`~time.process_time_ns`, :func:`~time.time_ns`.

- bpo-30143: 2to3 now generates a code that uses abstract collection classes
  from collections.abc rather than collections.

- bpo-31770: Prevent a crash when calling the ``__init__()`` method of a
  ``sqlite3.Cursor`` object more than once. Patch by Oren Milman.

- bpo-31764: Prevent a crash in ``sqlite3.Cursor.close()`` in case the
  ``Cursor`` object is uninitialized. Patch by Oren Milman.

- bpo-31752: Fix possible crash in timedelta constructor called with custom
  integers.

- bpo-31620: an empty asyncio.Queue now doesn't leak memory when queue.get
  pollers timeout

- bpo-31690: Allow the flags re.ASCII, re.LOCALE, and re.UNICODE to be used
  as group flags for regular expressions.

- bpo-30349: FutureWarning is now emitted if a regular expression contains
  character set constructs that will change semantically in the future
  (nested sets and set operations).

- bpo-31664: Added support for the Blowfish hashing in the crypt module.

- bpo-31632: Fix method set_protocol() of class _SSLProtocolTransport in
  asyncio module. This method was previously modifying a wrong reference to
  the protocol.

- bpo-15037: Added a workaround for getkey() in curses for ncurses 5.7 and
  earlier.

- bpo-31307: Allow use of bytes objects for arguments to
  :meth:`configparser.ConfigParser.read`. Patch by Vincent Michel.

- bpo-31334: Fix ``poll.poll([timeout])`` in the ``select`` module for
  arbitrary negative timeouts on all OSes where it can only be a
  non-negative integer or -1. Patch by Riccardo Coccioli.

- bpo-31310: multiprocessing's semaphore tracker should be launched again if
  crashed.

- bpo-31308: Make multiprocessing's forkserver process immune to Ctrl-C and
  other user interruptions. If it crashes, restart it when necessary.

- bpo-31245: Added support for AF_UNIX socket in asyncio
  `create_datagram_endpoint`.

- bpo-30553: Add HTTP/2 status code 421 (Misdirected Request) to
  :class:`http.HTTPStatus`. Patch by Vitor Pereira.

Documentation
-------------

- bpo-32105: Added asyncio.BaseEventLoop.connect_accepted_socket
  versionadded marker.

Tests
-----

- bpo-31380: Skip test_httpservers test_undecodable_file on macOS: fails on
  APFS.

- bpo-31705: Skip test_socket.test_sha256() on Linux kernel older than 4.5.
  The test fails with ENOKEY on kernel 3.10 (on ppc64le). A fix was merged
  into the kernel 4.5.

- bpo-32138: Skip on Android test_faulthandler tests that raise SIGSEGV and
  remove the test.support.requires_android_level decorator.

- bpo-32136: The runtime embedding tests have been split out from
  ``Lib/test/test_capi.py`` into a new ``Lib/test/test_embed.py`` file.

- bpo-28668: test.support.requires_multiprocessing_queue is removed. Skip
  tests with test.support.import_module('multiprocessing.synchronize')
  instead when the semaphore implementation is broken or missing.

- bpo-32126: Skip test_get_event_loop_new_process in
  test.test_asyncio.test_events when sem_open() is not functional.

- bpo-31174: Fix test_tools.test_unparse: DirectoryTestCase now stores the
  names sample to always test the same files. It prevents false alarms when
  hunting reference leaks.

Build
-----

- bpo-28538: Revert the previous changes, the if_nameindex structure is
  defined by Unified Headers.

- bpo-28762: Revert the last commit, the F_LOCK macro is defined by Android
  Unified Headers.

- bpo-29040: Support building Android with Unified Headers. The first NDK
  release to support Unified Headers is android-ndk-r14.

- bpo-32059: ``detect_modules()`` in ``setup.py`` now also searches the
  sysroot paths when cross-compiling.

- bpo-31957: Fixes Windows SDK version detection when building for Windows.

- bpo-31609: Fixes quotes in PCbuild/clean.bat

- bpo-31934: Abort the build when building out of a not clean source tree.

- bpo-31926: Fixed Argument Clinic sometimes causing compilation errors when
  there was more than one function and/or method in a .c file with the same
  name.

- bpo-28791: Update Windows builds to use SQLite 3.21.0.

- bpo-28791: Update OS X installer to use SQLite 3.21.0.

- bpo-28643: Record profile-opt build progress with stamp files.

- bpo-31866: Finish removing support for AtheOS.

Windows
-------

- bpo-1102: Return ``None`` when ``View.Fetch()`` returns
  ``ERROR_NO_MORE_ITEMS`` instead of raising ``MSIError``.

  Initial patch by Anthony Tuininga.

- bpo-31944: Fixes Modify button in Apps and Features dialog.

- bpo-20486: Implement the ``Database.Close()`` method to help closing MSI
  database objects.

- bpo-31857: Make the behavior of USE_STACKCHECK deterministic in a
  multi-threaded environment.

macOS
-----

- bpo-31392: Update macOS installer to use OpenSSL 1.0.2m

IDLE
----

- bpo-32207: Improve tk event exception tracebacks in IDLE. When tk event
  handling is driven by IDLE's run loop, a confusing and distracting
  queue.EMPTY traceback context is no longer added to tk event exception
  tracebacks.  The traceback is now the same as when event handling is
  driven by user code.  Patch based on a suggestion by Serhiy Storchaka.

- bpo-32164: Delete unused file idlelib/tabbedpages.py. Use of TabbedPageSet
  in configdialog was replaced by ttk.Notebook.

- bpo-32100: IDLE: Fix old and new bugs in pathbrowser; improve tests. Patch
  mostly by Cheryl Sabella.

- bpo-31858: IDLE -- Restrict shell prompt manipulation to the shell. Editor
  and output windows only see an empty last prompt line.  This simplifies
  the code and fixes a minor bug when newline is inserted. Sys.ps1, if
  present, is read on Shell start-up, but is not set or changed.

- bpo-31860: The font sample in the IDLE configuration dialog is now
  editable. Changes persist while IDLE remains open

- bpo-31836: Test_code_module now passes if run after test_idle, which sets
  ps1.

  The code module uses sys.ps1 if present or sets it to '>>> ' if not.
  Test_code_module now properly tests both behaviors.  Ditto for ps2.

- bpo-28603: Fix a TypeError that caused a shell restart when printing a
  traceback that includes an exception that is unhashable. Patch by Zane
  Bitter.

- bpo-13802: Use non-Latin characters in the IDLE's Font settings sample.
  Even if one selects a font that defines a limited subset of the unicode
  Basic Multilingual Plane, tcl/tk will use other fonts that define a
  character. The expanded example give users of non-Latin characters a
  better idea of what they might see in IDLE's shell and editors.

  To make room for the expanded sample, frames on the Font tab are
  re-arranged.  The Font/Tabs help explains a bit about the additions.

Tools/Demos
-----------

- bpo-32159: Remove CVS and Subversion tools: remove svneol.py and
  treesync.py scripts. CPython migrated from CVS to Subversion, to
  Mercurial, and then to Git. CVS and Subversion are no longer used to
  develop CPython.

- bpo-30722: Make redemo work with Python 3.6 and newer versions.

  Also, remove the ``LOCALE`` option since it doesn't work with string
  patterns in Python 3.

  Patch by Christoph Sarnowski.

C API
-----

- bpo-20891: Fix PyGILState_Ensure(). When PyGILState_Ensure() is called in
  a non-Python thread before PyEval_InitThreads(), only call
  PyEval_InitThreads() after calling PyThreadState_New() to fix a crash.

- bpo-32125: The ``Py_UseClassExceptionsFlag`` flag has been removed. It was
  deprecated and wasn't used anymore since Python 2.0.

- bpo-25612: Move the current exception state from the frame object to the
  co-routine. This simplifies the interpreter and fixes a couple of obscure
  bugs caused by having swap exception state when entering or exiting a
  generator.

- bpo-23699: Add Py_RETURN_RICHCOMPARE macro to reduce boilerplate code in
  rich comparison functions.

- bpo-30697: The `PyExc_RecursionErrorInst` singleton is removed and
  `PyErr_NormalizeException()` does not use it anymore. This singleton is
  persistent and its members being never cleared may cause a segfault during
  finalization of the interpreter. See also issue #22898.


What's New in Python 3.7.0 alpha 2?
===================================

*Release date: 2017-10-16*

Core and Builtins
-----------------

- bpo-31558: ``gc.freeze()`` is a new API that allows for moving all objects
  currently tracked by the garbage collector to a permanent generation,
  effectively removing them from future collection events. This can be used
  to protect those objects from having their PyGC_Head mutated. In effect,
  this enables great copy-on-write stability at fork().

- bpo-31642: Restored blocking "from package import module" by setting
  sys.modules["package.module"] to None.

- bpo-31708: Allow use of asynchronous generator expressions in synchronous
  functions.

- bpo-31709: Drop support of asynchronous __aiter__.

- bpo-30404: The -u option now makes the stdout and stderr streams
  unbuffered rather than line-buffered.

- bpo-31619: Fixed a ValueError when convert a string with large number of
  underscores to integer with binary base.

- bpo-31602: Fix an assertion failure in `zipimporter.get_source()` in case
  of a bad `zlib.decompress()`. Patch by Oren Milman.

- bpo-31592: Fixed an assertion failure in Python parser in case of a bad
  `unicodedata.normalize()`. Patch by Oren Milman.

- bpo-31588: Raise a `TypeError` with a helpful error message when class
  creation fails due to a metaclass with a bad ``__prepare__()`` method.
  Patch by Oren Milman.

- bpo-31574: Importlib was instrumented with two dtrace probes to profile
  import timing.

- bpo-31566: Fix an assertion failure in `_warnings.warn()` in case of a bad
  ``__name__`` global. Patch by Oren Milman.

- bpo-31506: Improved the error message logic for object.__new__ and
  object.__init__.

- bpo-31505: Fix an assertion failure in `json`, in case
  `_json.make_encoder()` received a bad `encoder()` argument. Patch by Oren
  Milman.

- bpo-31492: Fix assertion failures in case of failing to import from a
  module with a bad ``__name__`` attribute, and in case of failing to access
  an attribute of such a module. Patch by Oren Milman.

- bpo-31478: Fix an assertion failure in `_random.Random.seed()` in case the
  argument has a bad ``__abs__()`` method. Patch by Oren Milman.

- bpo-31336: Speed up class creation by 10-20% by reducing the overhead in
  the necessary special method lookups.  Patch by Stefan Behnel.

- bpo-31415: Add ``-X importtime`` option to show how long each import
  takes. It can be used to optimize application's startup time.  Support the
  :envvar:`PYTHONPROFILEIMPORTTIME` as an equivalent way to enable this.

- bpo-31410: Optimized calling wrapper and classmethod descriptors.

- bpo-31353: :pep:`553` - Add a new built-in called ``breakpoint()`` which
  calls ``sys.breakpointhook()``.  By default this imports ``pdb`` and calls
  ``pdb.set_trace()``, but users may override ``sys.breakpointhook()`` to
  call whatever debugger they want.  The original value of the hook is saved
  in ``sys.__breakpointhook__``.

- bpo-17852: Maintain a list of open buffered files, flush them before
  exiting the interpreter.  Based on a patch from Armin Rigo.

- bpo-31315: Fix an assertion failure in imp.create_dynamic(), when
  spec.name is not a string. Patch by Oren Milman.

- bpo-31311: Fix a crash in the ``__setstate__()`` method of
  `ctypes._CData`, in case of a bad ``__dict__``. Patch by Oren Milman.

- bpo-31293: Fix crashes in true division and multiplication of a timedelta
  object by a float with a bad as_integer_ratio() method. Patch by Oren
  Milman.

- bpo-31285: Fix an assertion failure in `warnings.warn_explicit`, when the
  return value of the received loader's get_source() has a bad splitlines()
  method. Patch by Oren Milman.

- bpo-30406: Make ``async`` and ``await`` proper keywords, as specified in
  PEP 492.

Library
-------

- bpo-30058: Fixed buffer overflow in select.kqueue.control().

- bpo-31672: ``idpattern`` in ``string.Template`` matched some non-ASCII
  characters. Now it uses ``-i`` regular expression local flag to avoid
  non-ASCII characters.

- bpo-31701: On Windows, faulthandler.enable() now ignores MSC and COM
  exceptions.

- bpo-31728: Prevent crashes in `_elementtree` due to unsafe cleanup of
  `Element.text` and `Element.tail`. Patch by Oren Milman.

- bpo-31671: Now ``re.compile()`` converts passed RegexFlag to normal int
  object before compiling. bm_regex_compile benchmark shows 14% performance
  improvements.

- bpo-30397: The types of compiled regular objects and match objects are now
  exposed as `re.Pattern` and `re.Match`.  This adds information in pydoc
  output for the re module.

- bpo-31675: Fixed memory leaks in Tkinter's methods splitlist() and split()
  when pass a string larger than 2 GiB.

- bpo-31673: Fixed typo in the name of Tkinter's method adderrorinfo().

- bpo-31648: Improvements to path predicates in ElementTree:

  * Allow whitespace around predicate parts, i.e. "[a = 'text']" instead of requiring the less readable "[a='text']".
  * Add support for text comparison of the current node, like "[.='text']".

  Patch by Stefan Behnel.

- bpo-30806: Fix the string representation of a netrc object.

- bpo-31638: Add optional argument ``compressed`` to
  ``zipapp.create_archive``, and add option ``--compress`` to the command
  line interface of ``zipapp``.

- bpo-25351: Avoid venv activate failures with undefined variables

- bpo-20519: Avoid ctypes use (if possible) and improve import time for
  uuid.

- bpo-28293: The regular expression cache is no longer completely dumped
  when it is full.

- bpo-31596: Added pthread_getcpuclockid() to the time module

- bpo-27494: Make 2to3 accept a trailing comma in generator expressions. For
  example, ``set(x for x in [],)`` is now allowed.

- bpo-30347: Stop crashes when concurrently iterate over itertools.groupby()
  iterators.

- bpo-30346: An iterator produced by itertools.groupby() iterator now
  becomes exhausted after advancing the groupby iterator.

- bpo-31556: Cancel asyncio.wait_for future faster if timeout <= 0

- bpo-31540: Allow passing a context object in
  :class:`concurrent.futures.ProcessPoolExecutor` constructor. Also, free
  job resources in :class:`concurrent.futures.ProcessPoolExecutor` earlier
  to improve memory usage when a worker waits for new jobs.

- bpo-31516: ``threading.current_thread()`` should not return a dummy thread
  at shutdown.

- bpo-31525: In the sqlite module, require the sqlite3_prepare_v2 API. Thus,
  the sqlite module now requires sqlite version at least 3.3.9.

- bpo-26510: argparse subparsers are now required by default.  This matches
  behaviour in Python 2. For optional subparsers, use the new parameter
  ``add_subparsers(required=False)``. Patch by Anthony Sottile. (As of
  3.7.0rc1, the default was changed to not required as had been the case
  since Python 3.3.)

- bpo-27541: Reprs of subclasses of some collection and iterator classes
  (`bytearray`, `array.array`, `collections.deque`,
  `collections.defaultdict`, `itertools.count`, `itertools.repeat`) now
  contain actual type name insteads of hardcoded name of the base class.

- bpo-31351: python -m ensurepip now exits with non-zero exit code if pip
  bootstrapping has failed.

- bpo-31389: ``pdb.set_trace()`` now takes an optional keyword-only argument
  ``header``. If given, this is printed to the console just before debugging
  begins.

Documentation
-------------

- bpo-31537: Fix incorrect usage of ``get_history_length`` in readline
  documentation example code. Patch by Brad Smith.

- bpo-30085: The operator functions without double underscores are preferred
  for clarity. The one with underscores are only kept for
  back-compatibility.

Build
-----

- bpo-31696: Improve compiler version information in :data:`sys.version`
  when Python is built with Clang.

- bpo-31625: Stop using ranlib on static libraries. Instead, we assume ar
  supports the 's' flag.

- bpo-31624: Remove support for BSD/OS.

- bpo-22140: Prevent double substitution of prefix in python-config.sh.

- bpo-31569: Correct PCBuild/ case to PCbuild/ in build scripts and
  documentation.

- bpo-31536: Avoid wholesale rebuild after `make regen-all` if nothing
  changed.

IDLE
----

- bpo-31460: Simplify the API of IDLE's Module Browser.

  Passing a widget instead of an flist with a root widget opens the option
  of creating a browser frame that is only part of a window.  Passing a full
  file name instead of pieces assumed to come from a .py file opens the
  possibility of browsing python files that do not end in .py.

- bpo-31649: IDLE - Make _htest, _utest parameters keyword only.

- bpo-31559: Remove test order dependence in idle_test.test_browser.

- bpo-31459: Rename IDLE's module browser from Class Browser to Module
  Browser. The original module-level class and method browser became a
  module browser, with the addition of module-level functions, years ago.
  Nested classes and functions were added yesterday.  For
  back-compatibility, the virtual event <<open-class-browser>>, which
  appears on the Keys tab of the Settings dialog, is not changed. Patch by
  Cheryl Sabella.

- bpo-31500: Default fonts now are scaled on HiDPI displays.

- bpo-1612262: IDLE module browser now shows nested classes and functions.
  Original patches for code and tests by Guilherme Polo and Cheryl Sabella,
  respectively.

C API
-----

- bpo-28280: Make `PyMapping_Keys()`, `PyMapping_Values()` and
  `PyMapping_Items()` always return a `list` (rather than a `list` or a
  `tuple`). Patch by Oren Milman.

- bpo-31532: Fix memory corruption due to allocator mix in getpath.c between
  Py_GetPath() and Py_SetPath()

- bpo-25658: Implement PEP 539 for Thread Specific Storage (TSS) API: it is
  a new Thread Local Storage (TLS) API to CPython which would supersede use
  of the existing TLS API within the CPython interpreter, while deprecating
  the existing API. PEP written by Erik M. Bray, patch by Masayuki Yamamoto.


What's New in Python 3.7.0 alpha 1?
===================================

*Release date: 2017-09-19*

Security
--------

- bpo-29781: SSLObject.version() now correctly returns None when handshake
  over BIO has not been performed yet.

- bpo-29505: Add fuzz tests for float(str), int(str), unicode(str); for
  oss-fuzz.

- bpo-30947: Upgrade libexpat embedded copy from version 2.2.1 to 2.2.3 to
  get security fixes.

- bpo-30730: Prevent environment variables injection in subprocess on
  Windows.  Prevent passing other environment variables and command
  arguments.

- bpo-30694: Upgrade expat copy from 2.2.0 to 2.2.1 to get fixes of multiple
  security vulnerabilities including: CVE-2017-9233 (External entity
  infinite loop DoS), CVE-2016-9063 (Integer overflow, re-fix),
  CVE-2016-0718 (Fix regression bugs from 2.2.0's fix to CVE-2016-0718) and
  CVE-2012-0876 (Counter hash flooding with SipHash). Note: the
  CVE-2016-5300 (Use os-specific entropy sources like getrandom) doesn't
  impact Python, since Python already gets entropy from the OS to set the
  expat secret using ``XML_SetHashSalt()``.

- bpo-30500: Fix urllib.parse.splithost() to correctly parse fragments. For
  example, ``splithost('//127.0.0.1#@evil.com/')`` now correctly returns the
  ``127.0.0.1`` host, instead of treating ``@evil.com`` as the host in an
  authentication (``login@host``).

- bpo-29591: Update expat copy from 2.1.1 to 2.2.0 to get fixes of
  CVE-2016-0718 and CVE-2016-4472. See
  https://sourceforge.net/p/expat/bugs/537/ for more information.

Core and Builtins
-----------------

- bpo-31490: Fix an assertion failure in `ctypes` class definition, in case
  the class has an attribute whose name is specified in ``_anonymous_`` but
  not in ``_fields_``. Patch by Oren Milman.

- bpo-31471: Fix an assertion failure in `subprocess.Popen()` on Windows, in
  case the env argument has a bad keys() method. Patch by Oren Milman.

- bpo-31418: Fix an assertion failure in `PyErr_WriteUnraisable()` in case
  of an exception with a bad ``__module__`` attribute. Patch by Oren Milman.

- bpo-31416: Fix assertion failures in case of a bad warnings.filters or
  warnings.defaultaction. Patch by Oren Milman.

- bpo-28411: Change direct usage of PyInterpreterState.modules to
  PyImport_GetModuleDict(). Also introduce more uniformity in other code
  that deals with sys.modules. This helps reduce complications when working
  on sys.modules.

- bpo-28411: Switch to the abstract API when dealing with
  ``PyInterpreterState.modules``. This allows later support for all dict
  subclasses and other Mapping implementations.  Also add a
  ``PyImport_GetModule()`` function to reduce a bunch of duplicated code.

- bpo-31411: Raise a TypeError instead of SystemError in case
  warnings.onceregistry is not a dictionary. Patch by Oren Milman.

- bpo-31344: For finer control of tracing behaviour when testing the
  interpreter, two new frame attributes have been added to control the
  emission of particular trace events: ``f_trace_lines`` (``True`` by
  default) to turn off per-line trace events; and ``f_trace_opcodes``
  (``False`` by default) to turn on per-opcode trace events.

- bpo-31373: Fix several possible instances of undefined behavior due to
  floating-point demotions.

- bpo-30465: Location information (``lineno`` and ``col_offset``) in
  f-strings is now (mostly) correct.  This fixes tools like flake8 from
  showing warnings on the wrong line (typically the first line of the file).

- bpo-30860: Consolidate CPython's global runtime state under a single
  struct.  This improves discoverability of the runtime state.

- bpo-31347: Fix possible undefined behavior in _PyObject_FastCall_Prepend.

- bpo-31343: Include sys/sysmacros.h for major(), minor(), and makedev().
  GNU C libray plans to remove the functions from sys/types.h.

- bpo-31291: Fix an assertion failure in `zipimport.zipimporter.get_data` on
  Windows, when the return value of ``pathname.replace('/','\\')`` isn't a
  string. Patch by Oren Milman.

- bpo-31271: Fix an assertion failure in the write() method of
  `io.TextIOWrapper`, when the encoder doesn't return a bytes object. Patch
  by Oren Milman.

- bpo-31243: Fix a crash in some methods of `io.TextIOWrapper`, when the
  decoder's state is invalid. Patch by Oren Milman.

- bpo-30721: ``print`` now shows correct usage hint for using Python 2
  redirection syntax.  Patch by Sanyam Khurana.

- bpo-31070: Fix a race condition in importlib _get_module_lock().

- bpo-30747: Add a non-dummy implementation of _Py_atomic_store and
  _Py_atomic_load on MSVC.

- bpo-31095: Fix potential crash during GC caused by ``tp_dealloc`` which
  doesn't call ``PyObject_GC_UnTrack()``.

- bpo-31071: Avoid masking original TypeError in call with * unpacking when
  other arguments are passed.

- bpo-30978: str.format_map() now passes key lookup exceptions through.
  Previously any exception was replaced with a KeyError exception.

- bpo-30808: Use _Py_atomic API for concurrency-sensitive signal state.

- bpo-30876: Relative import from unloaded package now reimports the package
  instead of failing with SystemError.  Relative import from non-package now
  fails with ImportError rather than SystemError.

- bpo-30703: Improve signal delivery.

  Avoid using Py_AddPendingCall from signal handler, to avoid calling
  signal-unsafe functions. The tests I'm adding here fail without the rest
  of the patch, on Linux and OS X. This means our signal delivery logic had
  defects (some signals could be lost).

- bpo-30765: Avoid blocking in pthread_mutex_lock() when
  PyThread_acquire_lock() is asked not to block.

- bpo-31161: Make sure the 'Missing parentheses' syntax error message is
  only applied to SyntaxError, not to subclasses. Patch by Martijn Pieters.

- bpo-30814: Fixed a race condition when import a submodule from a package.

- bpo-30736: The internal unicodedata database has been upgraded to Unicode
  10.0.

- bpo-30604: Move co_extra_freefuncs from per-thread to per-interpreter to
  avoid crashes.

- bpo-30597: ``print`` now shows expected input in custom error message when
  used as a Python 2 statement. Patch by Sanyam Khurana.

- bpo-30682: Removed a too-strict assertion that failed for certain
  f-strings, such as eval("f'\\\n'") and eval("f'\\\r'").

- bpo-30501: The compiler now produces more optimal code for complex
  condition expressions in the "if", "while" and "assert" statement, the
  "if" expression, and generator expressions and comprehensions.

- bpo-28180: Implement PEP 538 (legacy C locale coercion). This means that
  when a suitable coercion target locale is available, both the core
  interpreter and locale-aware C extensions will assume the use of UTF-8 as
  the default text encoding, rather than ASCII.

- bpo-30486: Allows setting cell values for __closure__. Patch by Lisa
  Roach.

- bpo-30537: itertools.islice now accepts integer-like objects (having an
  __index__ method) as start, stop, and slice arguments

- bpo-25324: Tokens needed for parsing in Python moved to C. ``COMMENT``,
  ``NL`` and ``ENCODING``. This way the tokens and tok_names in the token
  module don't get changed when you import the tokenize module.

- bpo-29104: Fixed parsing backslashes in f-strings.

- bpo-27945: Fixed various segfaults with dict when input collections are
  mutated during searching, inserting or comparing.  Based on patches by
  Duane Griffin and Tim Mitchell.

- bpo-25794: Fixed type.__setattr__() and type.__delattr__() for
  non-interned attribute names.  Based on patch by Eryk Sun.

- bpo-30039: If a KeyboardInterrupt happens when the interpreter is in the
  middle of resuming a chain of nested 'yield from' or 'await' calls, it's
  now correctly delivered to the innermost frame.

- bpo-28974: ``object.__format__(x, '')`` is now equivalent to ``str(x)``
  rather than ``format(str(self), '')``.

- bpo-30024: Circular imports involving absolute imports with binding a
  submodule to a name are now supported.

- bpo-12414: sys.getsizeof() on a code object now returns the sizes which
  includes the code struct and sizes of objects which it references. Patch
  by Dong-hee Na.

- bpo-29839: len() now raises ValueError rather than OverflowError if
  __len__() returned a large negative integer.

- bpo-11913: README.rst is now included in the list of distutils standard
  READMEs and therefore included in source distributions.

- bpo-29914: Fixed default implementations of __reduce__ and
  __reduce_ex__(). object.__reduce__() no longer takes arguments,
  object.__reduce_ex__() now requires one argument.

- bpo-29949: Fix memory usage regression of set and frozenset object.

- bpo-29935: Fixed error messages in the index() method of tuple, list and
  deque when pass indices of wrong type.

- bpo-29816: Shift operation now has less opportunity to raise
  OverflowError. ValueError always is raised rather than OverflowError for
  negative counts. Shifting zero with non-negative count always returns
  zero.

- bpo-24821: Fixed the slowing down to 25 times in the searching of some
  unlucky Unicode characters.

- bpo-29102: Add a unique ID to PyInterpreterState.  This makes it easier to
  identify each subinterpreter.

- bpo-29894: The deprecation warning is emitted if __complex__ returns an
  instance of a strict subclass of complex.  In a future versions of Python
  this can be an error.

- bpo-29859: Show correct error messages when any of the pthread_* calls in
  thread_pthread.h fails.

- bpo-29849: Fix a memory leak when an ImportError is raised during from
  import.

- bpo-28856: Fix an oversight that %b format for bytes should support
  objects follow the buffer protocol.

- bpo-29723: The ``sys.path[0]`` initialization change for bpo-29139 caused
  a regression by revealing an inconsistency in how sys.path is initialized
  when executing ``__main__`` from a zipfile, directory, or other import
  location. The interpreter now consistently avoids ever adding the import
  location's parent directory to ``sys.path``, and ensures no other
  ``sys.path`` entries are inadvertently modified when inserting the import
  location named on the command line.

- bpo-29568: Escaped percent "%%" in the format string for classic string
  formatting no longer allows any characters between two percents.

- bpo-29714: Fix a regression that bytes format may fail when containing
  zero bytes inside.

- bpo-29695: bool(), float(), list() and tuple() no longer take keyword
  arguments. The first argument of int() can now be passes only as
  positional argument.

- bpo-28893: Set correct __cause__ for errors about invalid awaitables
  returned from __aiter__ and __anext__.

- bpo-28876: ``bool(range)`` works even if ``len(range)`` raises
  :exc:`OverflowError`.

- bpo-29683: Fixes to memory allocation in _PyCode_SetExtra.  Patch by Brian
  Coleman.

- bpo-29684: Fix minor regression of PyEval_CallObjectWithKeywords. It
  should raise TypeError when kwargs is not a dict.  But it might cause segv
  when args=NULL and kwargs is not a dict.

- bpo-28598: Support __rmod__ for subclasses of str being called before
  str.__mod__. Patch by Martijn Pieters.

- bpo-29607: Fix stack_effect computation for CALL_FUNCTION_EX. Patch by
  Matthieu Dartiailh.

- bpo-29602: Fix incorrect handling of signed zeros in complex constructor
  for complex subclasses and for inputs having a __complex__ method. Patch
  by Serhiy Storchaka.

- bpo-29347: Fixed possibly dereferencing undefined pointers when creating
  weakref objects.

- bpo-29463: Add ``docstring`` field to Module, ClassDef, FunctionDef, and
  AsyncFunctionDef ast nodes.  docstring is not first stmt in their body
  anymore.  It affects ``co_firstlineno`` and ``co_lnotab`` of code object
  for module and class. (Reverted in :issue:`32911`.)

- bpo-29438: Fixed use-after-free problem in key sharing dict.

- bpo-29546: Set the 'path' and 'name' attribute on ImportError for ``from
  ... import ...``.

- bpo-29546: Improve from-import error message with location

- bpo-29478: If max_line_length=None is specified while using the Compat32
  policy, it is no longer ignored.  Patch by Mircea Cosbuc.

- bpo-29319: Prevent RunMainFromImporter overwriting sys.path[0].

- bpo-29337: Fixed possible BytesWarning when compare the code objects.
  Warnings could be emitted at compile time.

- bpo-29327: Fixed a crash when pass the iterable keyword argument to
  sorted().

- bpo-29034: Fix memory leak and use-after-free in os module
  (path_converter).

- bpo-29159: Fix regression in bytes(x) when x.__index__() raises Exception.

- bpo-29049: Call _PyObject_GC_TRACK() lazily when calling Python function.
  Calling function is up to 5% faster.

- bpo-28927: bytes.fromhex() and bytearray.fromhex() now ignore all ASCII
  whitespace, not only spaces.  Patch by Robert Xiao.

- bpo-28932: Do not include <sys/random.h> if it does not exist.

- bpo-25677: Correct the positioning of the syntax error caret for indented
  blocks. Based on patch by Michael Layzell.

- bpo-29000: Fixed bytes formatting of octals with zero padding in alternate
  form.

- bpo-18896: Python function can now have more than 255 parameters.
  collections.namedtuple() now supports tuples with more than 255 elements.

- bpo-28596: The preferred encoding is UTF-8 on Android. Patch written by
  Chi Hsuan Yen.

- bpo-22257: Clean up interpreter startup (see PEP 432).

- bpo-26919: On Android, operating system data is now always encoded/decoded
  to/from UTF-8, instead of the locale encoding to avoid inconsistencies
  with os.fsencode() and os.fsdecode() which are already using UTF-8.

- bpo-28991: functools.lru_cache() was susceptible to an obscure reentrancy
  bug triggerable by a monkey-patched len() function.

- bpo-28147: Fix a memory leak in split-table dictionaries: setattr() must
  not convert combined table into split table. Patch written by INADA Naoki.

- bpo-28739: f-string expressions are no longer accepted as docstrings and
  by ast.literal_eval() even if they do not include expressions.

- bpo-28512: Fixed setting the offset attribute of SyntaxError by
  PyErr_SyntaxLocationEx() and PyErr_SyntaxLocationObject().

- bpo-28918: Fix the cross compilation of xxlimited when Python has been
  built with Py_DEBUG defined.

- bpo-23722: Rather than silently producing a class that doesn't support
  zero-argument ``super()`` in methods, failing to pass the new
  ``__classcell__`` namespace entry up to ``type.__new__`` now results in a
  ``DeprecationWarning`` and a class that supports zero-argument
  ``super()``.

- bpo-28797: Modifying the class __dict__ inside the __set_name__ method of
  a descriptor that is used inside that class no longer prevents calling the
  __set_name__ method of other descriptors.

- bpo-28799: Remove the ``PyEval_GetCallStats()`` function and deprecate the
  untested and undocumented ``sys.callstats()`` function. Remove the
  ``CALL_PROFILE`` special build: use the :func:`sys.setprofile` function,
  :mod:`cProfile` or :mod:`profile` to profile function calls.

- bpo-12844: More than 255 arguments can now be passed to a function.

- bpo-28782: Fix a bug in the implementation ``yield from`` when checking if
  the next instruction is YIELD_FROM. Regression introduced by WORDCODE
  (issue #26647).

- bpo-28774: Fix error position of the unicode error in ASCII and Latin1
  encoders when a string returned by the error handler contains multiple
  non-encodable characters (non-ASCII for the ASCII codec, characters out of
  the U+0000-U+00FF range for Latin1).

- bpo-28731: Optimize _PyDict_NewPresized() to create correct size dict.
  Improve speed of dict literal with constant keys up to 30%.

- bpo-28532: Show sys.version when -V option is supplied twice.

- bpo-27100: The with-statement now checks for __enter__ before it checks
  for __exit__. This gives less confusing error messages when both methods
  are missing. Patch by Jonathan Ellington.

- bpo-28746: Fix the set_inheritable() file descriptor method on platforms
  that do not have the ioctl FIOCLEX and FIONCLEX commands.

- bpo-26920: Fix not getting the locale's charset upon initializing the
  interpreter, on platforms that do not have langinfo.

- bpo-28648: Fixed crash in Py_DecodeLocale() in debug build on Mac OS X
  when decode astral characters.  Patch by Xiang Zhang.

- bpo-28665: Improve speed of the STORE_DEREF opcode by 40%.

- bpo-19398: Extra slash no longer added to sys.path components in case of
  empty compile-time PYTHONPATH components.

- bpo-28621: Sped up converting int to float by reusing faster bits counting
  implementation.  Patch by Adrian Wielgosik.

- bpo-28580: Optimize iterating split table values. Patch by Xiang Zhang.

- bpo-28583: PyDict_SetDefault didn't combine split table when needed. Patch
  by Xiang Zhang.

- bpo-28128: Deprecation warning for invalid str and byte escape sequences
  now prints better information about where the error occurs. Patch by
  Serhiy Storchaka and Eric Smith.

- bpo-28509: dict.update() no longer allocate unnecessary large memory.

- bpo-28426: Fixed potential crash in PyUnicode_AsDecodedObject() in debug
  build.

- bpo-28517: Fixed of-by-one error in the peephole optimizer that caused
  keeping unreachable code.

- bpo-28214: Improved exception reporting for problematic __set_name__
  attributes.

- bpo-23782: Fixed possible memory leak in _PyTraceback_Add() and exception
  loss in PyTraceBack_Here().

- bpo-28183: Optimize and cleanup dict iteration.

- bpo-26081: Added C implementation of asyncio.Future. Original patch by
  Yury Selivanov.

- bpo-28379: Added sanity checks and tests for PyUnicode_CopyCharacters().
  Patch by Xiang Zhang.

- bpo-28376: The type of long range iterator is now registered as Iterator.
  Patch by Oren Milman.

- bpo-28376: Creating instances of range_iterator by calling range_iterator
  type now is disallowed.  Calling iter() on range instance is the only way.
  Patch by Oren Milman.

- bpo-26906: Resolving special methods of uninitialized type now causes
  implicit initialization of the type instead of a fail.

- bpo-18287: PyType_Ready() now checks that tp_name is not NULL. Original
  patch by Niklas Koep.

- bpo-24098: Fixed possible crash when AST is changed in process of
  compiling it.

- bpo-28201: Dict reduces possibility of 2nd conflict in hash table when
  hashes have same lower bits.

- bpo-28350: String constants with null character no longer interned.

- bpo-26617: Fix crash when GC runs during weakref callbacks.

- bpo-27942: String constants now interned recursively in tuples and
  frozensets.

- bpo-28289: ImportError.__init__ now resets not specified attributes.

- bpo-21578: Fixed misleading error message when ImportError called with
  invalid keyword args.

- bpo-28203: Fix incorrect type in complex(1.0, {2:3}) error message. Patch
  by Soumya Sharma.

- bpo-28086: Single var-positional argument of tuple subtype was passed
  unscathed to the C-defined function.  Now it is converted to exact tuple.

- bpo-28214: Now __set_name__ is looked up on the class instead of the
  instance.

- bpo-27955: Fallback on reading /dev/urandom device when the getrandom()
  syscall fails with EPERM, for example when blocked by SECCOMP.

- bpo-28192: Don't import readline in isolated mode.

- bpo-27441: Remove some redundant assignments to ob_size in longobject.c.
  Thanks Oren Milman.

- bpo-27222: Clean up redundant code in long_rshift function. Thanks Oren
  Milman.

- Upgrade internal unicode databases to Unicode version 9.0.0.

- bpo-28131: Fix a regression in zipimport's compile_source().  zipimport
  should use the same optimization level as the interpreter.

- bpo-28126: Replace Py_MEMCPY with memcpy(). Visual Studio can properly
  optimize memcpy().

- bpo-28120: Fix dict.pop() for splitted dictionary when trying to remove a
  "pending key" (Not yet inserted in split-table). Patch by Xiang Zhang.

- bpo-26182: Raise DeprecationWarning when async and await keywords are used
  as variable/attribute/class/function name.

- bpo-26182: Fix a refleak in code that raises DeprecationWarning.

- bpo-28721: Fix asynchronous generators aclose() and athrow() to handle
  StopAsyncIteration propagation properly.

- bpo-26110: Speed-up method calls: add LOAD_METHOD and CALL_METHOD opcodes.

Library
-------

- bpo-31499: xml.etree: Fix a crash when a parser is part of a reference
  cycle.

- bpo-31482: ``random.seed()`` now works with bytes in version=1

- bpo-28556: typing.get_type_hints now finds the right globalns for classes
  and modules by default (when no ``globalns`` was specified by the caller).

- bpo-28556: Speed improvements to the ``typing`` module.  Original PRs by
  Ivan Levkivskyi and Mitar.

- bpo-31544: The C accelerator module of ElementTree ignored exceptions
  raised when looking up TreeBuilder target methods in XMLParser().

- bpo-31234: socket.create_connection() now fixes manually a reference
  cycle: clear the variable storing the last exception on success.

- bpo-31457: LoggerAdapter objects can now be nested.

- bpo-31431: SSLContext.check_hostname now automatically sets
  SSLContext.verify_mode to ssl.CERT_REQUIRED instead of failing with a
  ValueError.

- bpo-31233: socketserver.ThreadingMixIn now keeps a list of non-daemonic
  threads to wait until all these threads complete in server_close().

- bpo-28638: Changed the implementation strategy for
  collections.namedtuple() to substantially reduce the use of exec() in
  favor of precomputed methods. As a result, the *verbose* parameter and
  *_source* attribute are no longer supported.  The benefits include 1)
  having a smaller memory footprint for applications using multiple named
  tuples, 2) faster creation of the named tuple class (approx 4x to 6x
  depending on how it is measured), and 3) minor speed-ups for instance
  creation using __new__, _make, and _replace.  (The primary patch
  contributor is Jelle Zijlstra with further improvements by INADA Naoki,
  Serhiy Storchaka, and Raymond Hettinger.)

- bpo-31400: Improves SSL error handling to avoid losing error numbers.

- bpo-27629: Make return types of SSLContext.wrap_bio() and
  SSLContext.wrap_socket() customizable.

- bpo-28958: ssl.SSLContext() now uses OpenSSL error information when a
  context cannot be instantiated.

- bpo-28182: The SSL module now raises SSLCertVerificationError when OpenSSL
  fails to verify the peer's certificate. The exception contains more
  information about the error.

- bpo-27340: SSLSocket.sendall() now uses memoryview to create slices of
  data. This fixes support for all bytes-like object. It is also more
  efficient and avoids costly copies.

- bpo-14191: A new function
  ``argparse.ArgumentParser.parse_intermixed_args`` provides the ability to
  parse command lines where there user intermixes options and positional
  arguments.

- bpo-31178: Fix string concatenation bug in rare error path in the
  subprocess module

- bpo-31350: Micro-optimize :func:`asyncio._get_running_loop` to become up
  to 10% faster.

- bpo-31170: expat: Update libexpat from 2.2.3 to 2.2.4. Fix copying of
  partial characters for UTF-8 input (libexpat bug 115):
  https://github.com/libexpat/libexpat/issues/115

- bpo-29136: Add TLS 1.3 cipher suites and OP_NO_TLSv1_3.

- bpo-1198569: ``string.Template`` subclasses can optionally define
  ``braceidpattern`` if they want to specify different placeholder patterns
  inside and outside the braces.  If None (the default) it falls back to
  ``idpattern``.

- bpo-31326: concurrent.futures.ProcessPoolExecutor.shutdown() now
  explicitly closes the call queue. Moreover, shutdown(wait=True) now also
  join the call queue thread, to prevent leaking a dangling thread.

- bpo-27144: The ``map()`` and ``as_completed()`` iterators in
  ``concurrent.futures`` now avoid keeping a reference to yielded objects.

- bpo-31281: Fix ``fileinput.FileInput(files, inplace=True)`` when ``files``
  contain ``pathlib.Path`` objects.

- bpo-10746: Fix ctypes producing wrong PEP 3118 type codes for integer
  types.

- bpo-27584: ``AF_VSOCK`` has been added to the socket interface which
  allows communication between virtual machines and their host.

- bpo-22536: The subprocess module now sets the filename when
  FileNotFoundError is raised on POSIX systems due to the executable or cwd
  not being found.

- bpo-29741: Update some methods in the _pyio module to also accept integer
  types. Patch by Oren Milman.

- bpo-31249: concurrent.futures: WorkItem.run() used by ThreadPoolExecutor
  now breaks a reference cycle between an exception object and the WorkItem
  object.

- bpo-31247: xmlrpc.server now explicitly breaks reference cycles when using
  sys.exc_info() in code handling exceptions.

- bpo-23835: configparser: reading defaults in the ``ConfigParser()``
  constructor is now using ``read_dict()``, making its behavior consistent
  with the rest of the parser.  Non-string keys and values in the defaults
  dictionary are now being implicitly converted to strings.  Patch by James
  Tocknell.

- bpo-31238: pydoc: the stop() method of the private ServerThread class now
  waits until DocServer.serve_until_quit() completes and then explicitly
  sets its docserver attribute to None to break a reference cycle.

- bpo-5001: Many asserts in `multiprocessing` are now more informative, and
  some error types have been changed to more specific ones.

- bpo-31109: Convert zipimport to use Argument Clinic.

- bpo-30102: The ssl and hashlib modules now call
  OPENSSL_add_all_algorithms_noconf() on OpenSSL < 1.1.0. The function
  detects CPU features and enables optimizations on some CPU architectures
  such as POWER8. Patch is based on research from Gustavo Serra Scalet.

- bpo-18966: Non-daemonic threads created by a multiprocessing.Process are
  now joined on child exit.

- bpo-31183: `dis` now works with asynchronous generator and coroutine
  objects. Patch by George Collins based on diagnosis by Luciano Ramalho.

- bpo-5001: There are a number of uninformative asserts in the
  `multiprocessing` module, as noted in issue 5001. This change fixes two of
  the most potentially problematic ones, since they are in error-reporting
  code, in the `multiprocessing.managers.convert_to_error` function. (It
  also makes more informative a ValueError message.) The only potentially
  problematic change is that the AssertionError is now a TypeError; however,
  this should also help distinguish it from an AssertionError being
  *reported* by the function/its caller (such as in issue 31169). - Patch by
  Allen W. Smith (drallensmith on github).

- bpo-31185: Fixed miscellaneous errors in asyncio speedup module.

- bpo-31151: socketserver.ForkingMixIn.server_close() now waits until all
  child processes completed to prevent leaking zombie processes.

- bpo-31072: Add an ``include_file`` parameter to
  ``zipapp.create_archive()``

- bpo-24700: Optimize array.array comparison. It is now from 10x up to 70x
  faster when comparing arrays holding values of the same integer type.

- bpo-31135: ttk: fix the destroy() method of LabeledScale and OptionMenu
  classes. Call the parent destroy() method even if the used attribute
  doesn't exist. The LabeledScale.destroy() method now also explicitly
  clears label and scale attributes to help the garbage collector to destroy
  all widgets.

- bpo-31107: Fix `copyreg._slotnames()` mangled attribute calculation for
  classes whose name begins with an underscore. Patch by Shane Harvey.

- bpo-31080: Allow `logging.config.fileConfig` to accept kwargs and/or args.

- bpo-30897: ``pathlib.Path`` objects now include an ``is_mount()`` method
  (only implemented on POSIX).  This is similar to ``os.path.ismount(p)``.
  Patch by Cooper Ry Lees.

- bpo-31061: Fixed a crash when using asyncio and threads.

- bpo-30987: Added support for CAN ISO-TP protocol in the socket module.

- bpo-30522: Added a ``setStream`` method to ``logging.StreamHandler`` to
  allow the stream to be set after creation.

- bpo-30502: Fix handling of long oids in ssl.  Based on patch by Christian
  Heimes.

- bpo-5288: Support tzinfo objects with sub-minute offsets.

- bpo-30919: Fix shared memory performance regression in multiprocessing in
  3.x.

  Shared memory used anonymous memory mappings in 2.x, while 3.x mmaps
  actual files. Try to be careful to do as little disk I/O as possible.

- bpo-26732: Fix too many fds in processes started with the "forkserver"
  method.

  A child process would inherit as many fds as the number of still-running
  children.

- bpo-29403: Fix ``unittest.mock``'s autospec to not fail on method-bound
  builtin functions.  Patch by Aaron Gallagher.

- bpo-30961: Fix decrementing a borrowed reference in tracemalloc.

- bpo-19896: Fix multiprocessing.sharedctypes to recognize typecodes ``'q'``
  and ``'Q'``.

- bpo-30946: Remove obsolete code in readline module for platforms where GNU
  readline is older than 2.1 or where select() is not available.

- bpo-25684: Change ``ttk.OptionMenu`` radiobuttons to be unique across
  instances of ``OptionMenu``.

- bpo-30886: Fix multiprocessing.Queue.join_thread(): it now waits until the
  thread completes, even if the thread was started by the same process which
  created the queue.

- bpo-29854: Fix segfault in readline when using readline's history-size
  option.  Patch by Nir Soffer.

- bpo-30794: Added multiprocessing.Process.kill method to terminate using
  the SIGKILL signal on Unix.

- bpo-30319: socket.close() now ignores ECONNRESET error.

- bpo-30828: Fix out of bounds write in
  `asyncio.CFuture.remove_done_callback()`.

- bpo-30302: Use keywords in the ``repr`` of ``datetime.timedelta``.

- bpo-30807: signal.setitimer() may disable the timer when passed a tiny
  value.

  Tiny values (such as 1e-6) are valid non-zero values for setitimer(),
  which is specified as taking microsecond-resolution intervals. However, on
  some platform, our conversion routine could convert 1e-6 into a zero
  interval, therefore disabling the timer instead of (re-)scheduling it.

- bpo-30441: Fix bug when modifying os.environ while iterating over it

- bpo-29585: Avoid importing ``sysconfig`` from ``site`` to improve startup
  speed. Python startup is about 5% faster on Linux and 30% faster on macOS.

- bpo-29293: Add missing parameter "n" on
  multiprocessing.Condition.notify().

  The doc claims multiprocessing.Condition behaves like threading.Condition,
  but its notify() method lacked the optional "n" argument (to specify the
  number of sleepers to wake up) that threading.Condition.notify() accepts.

- bpo-30532: Fix email header value parser dropping folding white space in
  certain cases.

- bpo-30596: Add a ``close()`` method to ``multiprocessing.Process``.

- bpo-9146: Fix a segmentation fault in _hashopenssl when standard hash
  functions such as md5 are not available in the linked OpenSSL library.  As
  in some special FIPS-140 build environments.

- bpo-29169: Update zlib to 1.2.11.

- bpo-30119: ftplib.FTP.putline() now throws ValueError on commands that
  contains CR or LF. Patch by Dong-hee Na.

- bpo-30879: os.listdir() and os.scandir() now emit bytes names when called
  with bytes-like argument.

- bpo-30746: Prohibited the '=' character in environment variable names in
  ``os.putenv()`` and ``os.spawn*()``.

- bpo-30664: The description of a unittest subtest now preserves the order
  of keyword arguments of TestCase.subTest().

- bpo-21071: struct.Struct.format type is now :class:`str` instead of
  :class:`bytes`.

- bpo-29212: Fix concurrent.futures.thread.ThreadPoolExecutor threads to
  have a non repr() based thread name by default when no thread_name_prefix
  is supplied. They will now identify themselves as
  "ThreadPoolExecutor-y_n".

- bpo-29755: Fixed the lgettext() family of functions in the gettext module.
  They now always return bytes.

- bpo-30616: Functional API of enum allows to create empty enums. Patched by
  Dong-hee Na

- bpo-30038: Fix race condition between signal delivery and wakeup file
  descriptor. Patch by Nathaniel Smith.

- bpo-23894: lib2to3 now recognizes ``rb'...'`` and ``f'...'`` strings.

- bpo-24744: pkgutil.walk_packages function now raises ValueError if *path*
  is a string. Patch by Sanyam Khurana.

- bpo-24484: Avoid race condition in multiprocessing cleanup.

- bpo-30589: Fix multiprocessing.Process.exitcode to return the opposite of
  the signal number when the process is killed by a signal (instead of 255)
  when using the "forkserver" method.

- bpo-28994: The traceback no longer displayed for SystemExit raised in a
  callback registered by atexit.

- bpo-30508: Don't log exceptions if Task/Future "cancel()" method was
  called.

- bpo-30645: Fix path calculation in `imp.load_package()`, fixing it for
  cases when a package is only shipped with bytecodes. Patch by Alexandru
  Ardelean.

- bpo-11822: The dis.dis() function now is able to disassemble nested code
  objects.

- bpo-30624: selectors does not take KeyboardInterrupt and SystemExit into
  account, leaving a fd in a bad state in case of error. Patch by Giampaolo
  Rodola'.

- bpo-30595: multiprocessing.Queue.get() with a timeout now polls its reader
  in non-blocking mode if it succeeded to acquire the lock but the acquire
  took longer than the timeout.

- bpo-28556: Updates to typing module: Add generic AsyncContextManager, add
  support for ContextManager on all versions. Original PRs by Jelle Zijlstra
  and Ivan Levkivskyi

- bpo-30605: re.compile() no longer raises a BytesWarning when compiling a
  bytes instance with misplaced inline modifier.  Patch by Roy Williams.

- bpo-29870: Fix ssl sockets leaks when connection is aborted in asyncio/ssl
  implementation. Patch by Michaël Sghaïer.

- bpo-29743: Closing transport during handshake process leaks open socket.
  Patch by Nikolay Kim

- bpo-27585: Fix waiter cancellation in asyncio.Lock. Patch by Mathieu
  Sornay.

- bpo-30014: modify() method of poll(), epoll() and devpoll() based classes
  of selectors module is around 10% faster.  Patch by Giampaolo Rodola'.

- bpo-30418: On Windows, subprocess.Popen.communicate() now also ignore
  EINVAL on stdin.write() if the child process is still running but closed
  the pipe.

- bpo-30463: Addded empty __slots__ to abc.ABC.  This allows subclassers to
  deny __dict__ and __weakref__ creation.  Patch by Aaron Hall.

- bpo-30520: Loggers are now pickleable.

- bpo-30557: faulthandler now correctly filters and displays exception codes
  on Windows

- bpo-30526: Add TextIOWrapper.reconfigure() and a
  TextIOWrapper.write_through attribute.

- bpo-30245: Fix possible overflow when organize struct.pack_into error
  message.  Patch by Yuan Liu.

- bpo-30378: Fix the problem that logging.handlers.SysLogHandler cannot
  handle IPv6 addresses.

- bpo-16500: Allow registering at-fork handlers.

- bpo-30470: Deprecate invalid ctypes call protection on Windows.  Patch by
  Mariatta Wijaya.

- bpo-30414: multiprocessing.Queue._feed background running thread do not
  break from main loop on exception.

- bpo-30003: Fix handling escape characters in HZ codec.  Based on patch by
  Ma Lin.

- bpo-30149: inspect.signature() now supports callables with
  variable-argument parameters wrapped with partialmethod. Patch by Dong-hee
  Na.

- bpo-30436: importlib.find_spec() raises ModuleNotFoundError instead of
  AttributeError if the specified parent module is not a package (i.e. lacks
  a __path__ attribute).

- bpo-30301: Fix AttributeError when using SimpleQueue.empty() under *spawn*
  and *forkserver* start methods.

- bpo-30375: Warnings emitted when compile a regular expression now always
  point to the line in the user code.  Previously they could point into
  inners of the re module if emitted from inside of groups or conditionals.

- bpo-30329: imaplib and poplib now catch the Windows socket WSAEINVAL error
  (code 10022) on shutdown(SHUT_RDWR): An invalid operation was attempted.
  This error occurs sometimes on SSL connections.

- bpo-29196: Removed previously deprecated in Python 2.4 classes Plist, Dict
  and _InternalDict in the plistlib module.  Dict values in the result of
  functions readPlist() and readPlistFromBytes() are now normal dicts.  You
  no longer can use attribute access to access items of these dictionaries.

- bpo-9850: The :mod:`macpath` is now deprecated and will be removed in
  Python 3.8.

- bpo-30299: Compiling regular expression in debug mode on CPython now
  displays the compiled bytecode in human readable form.

- bpo-30048: Fixed ``Task.cancel()`` can be ignored when the task is running
  coroutine and the coroutine returned without any more ``await``.

- bpo-30266: contextlib.AbstractContextManager now supports
  anti-registration by setting __enter__ = None or __exit__ = None,
  following the pattern introduced in bpo-25958. Patch by Jelle Zijlstra.

- bpo-30340: Enhanced regular expressions optimization. This increased the
  performance of matching some patterns up to 25 times.

- bpo-30298: Weaken the condition of deprecation warnings for inline
  modifiers. Now allowed several subsequential inline modifiers at the start
  of the pattern (e.g. ``'(?i)(?s)...'``).  In verbose mode whitespaces and
  comments now are allowed before and between inline modifiers (e.g. ``'(?x)
  (?i) (?s)...'``).

- bpo-30285: Optimized case-insensitive matching and searching of regular
  expressions.

- bpo-29990: Fix range checking in GB18030 decoder.  Original patch by Ma
  Lin.

- bpo-29979: rewrite cgi.parse_multipart, reusing the FieldStorage class and
  making its results consistent with those of FieldStorage for
  multipart/form-data requests. Patch by Pierre Quentel.

- bpo-30243: Removed the __init__ methods of _json's scanner and encoder.
  Misusing them could cause memory leaks or crashes.  Now scanner and
  encoder objects are completely initialized in the __new__ methods.

- bpo-30215: Compiled regular expression objects with the re.LOCALE flag no
  longer depend on the locale at compile time.  Only the locale at matching
  time affects the result of matching.

- bpo-30185: Avoid KeyboardInterrupt tracebacks in forkserver helper process
  when Ctrl-C is received.

- bpo-30103: binascii.b2a_uu() and uu.encode() now support using ``'`'`` as
  zero instead of space.

- bpo-28556: Various updates to typing module: add typing.NoReturn type, use
  WrapperDescriptorType, minor bug-fixes.  Original PRs by Jim
  Fasarakis-Hilliard and Ivan Levkivskyi.

- bpo-30205: Fix getsockname() for unbound AF_UNIX sockets on Linux.

- bpo-30228: The seek() and tell() methods of io.FileIO now set the internal
  seekable attribute to avoid one syscall on open() (in buffered or text
  mode).

- bpo-30190: unittest's assertAlmostEqual and assertNotAlmostEqual provide a
  better message in case of failure which includes the difference between
  left and right arguments.  (patch by Giampaolo Rodola')

- bpo-30101: Add support for curses.A_ITALIC.

- bpo-29822: inspect.isabstract() now works during __init_subclass__.  Patch
  by Nate Soares.

- bpo-29960: Preserve generator state when _random.Random.setstate() raises
  an exception. Patch by Bryan Olson.

- bpo-30070: Fixed leaks and crashes in errors handling in the parser
  module.

- bpo-22352: Column widths in the output of dis.dis() are now adjusted for
  large line numbers and instruction offsets.

- bpo-30061: Fixed crashes in IOBase methods __next__() and readlines() when
  readline() or __next__() respectively return non-sizeable object. Fixed
  possible other errors caused by not checking results of PyObject_Size(),
  PySequence_Size(), or PyMapping_Size().

- bpo-30218: Fix PathLike support for shutil.unpack_archive. Patch by Jelle
  Zijlstra.

- bpo-10076: Compiled regular expression and match objects in the re module
  now support copy.copy() and copy.deepcopy() (they are considered atomic).

- bpo-30068: _io._IOBase.readlines will check if it's closed first when hint
  is present.

- bpo-29694: Fixed race condition in pathlib mkdir with flags parents=True.
  Patch by Armin Rigo.

- bpo-29692: Fixed arbitrary unchaining of RuntimeError exceptions in
  contextlib.contextmanager.  Patch by Siddharth Velankar.

- bpo-26187: Test that sqlite3 trace callback is not called multiple times
  when schema is changing.  Indirectly fixed by switching to use
  sqlite3_prepare_v2() in bpo-9303.  Patch by Aviv Palivoda.

- bpo-30017: Allowed calling the close() method of the zip entry writer
  object multiple times.  Writing to a closed writer now always produces a
  ValueError.

- bpo-29998: Pickling and copying ImportError now preserves name and path
  attributes.

- bpo-29995: re.escape() now escapes only regex special characters.

- bpo-29962: Add math.remainder operation, implementing remainder as
  specified in IEEE 754.

- bpo-29649: Improve struct.pack_into() exception messages for problems with
  the buffer size and offset.  Patch by Andrew Nester.

- bpo-29654: Support If-Modified-Since HTTP header (browser cache).  Patch
  by Pierre Quentel.

- bpo-29931: Fixed comparison check for ipaddress.ip_interface objects.
  Patch by Sanjay Sundaresan.

- bpo-29953: Fixed memory leaks in the replace() method of datetime and time
  objects when pass out of bound fold argument.

- bpo-29942: Fix a crash in itertools.chain.from_iterable when encountering
  long runs of empty iterables.

- bpo-10030: Sped up reading encrypted ZIP files by 2 times.

- bpo-29204: Element.getiterator() and the html parameter of XMLParser()
  were deprecated only in the documentation (since Python 3.2 and 3.4
  correspondintly). Now using them emits a deprecation warning.

- bpo-27863: Fixed multiple crashes in ElementTree caused by race conditions
  and wrong types.

- bpo-25996: Added support of file descriptors in os.scandir() on Unix.
  os.fwalk() is sped up by 2 times by using os.scandir().

- bpo-28699: Fixed a bug in pools in multiprocessing.pool that raising an
  exception at the very first of an iterable may swallow the exception or
  make the program hang. Patch by Davin Potts and Xiang Zhang.

- bpo-23890: unittest.TestCase.assertRaises() now manually breaks a
  reference cycle to not keep objects alive longer than expected.

- bpo-29901: The zipapp module now supports general path-like objects, not
  just pathlib.Path.

- bpo-25803: Avoid incorrect errors raised by Path.mkdir(exist_ok=True) when
  the OS gives priority to errors such as EACCES over EEXIST.

- bpo-29861: Release references to tasks, their arguments and their results
  as soon as they are finished in multiprocessing.Pool.

- bpo-19930: The mode argument of os.makedirs() no longer affects the file
  permission bits of newly-created intermediate-level directories.

- bpo-29884: faulthandler: Restore the old sigaltstack during teardown.
  Patch by Christophe Zeitouny.

- bpo-25455: Fixed crashes in repr of recursive buffered file-like objects.

- bpo-29800: Fix crashes in partial.__repr__ if the keys of partial.keywords
  are not strings.  Patch by Michael Seifert.

- bpo-8256: Fixed possible failing or crashing input() if attributes
  "encoding" or "errors" of sys.stdin or sys.stdout are not set or are not
  strings.

- bpo-28692: Using non-integer value for selecting a plural form in gettext
  is now deprecated.

- bpo-26121: Use C library implementation for math functions erf() and
  erfc().

- bpo-29619: os.stat() and os.DirEntry.inode() now convert inode (st_ino)
  using unsigned integers.

- bpo-28298: Fix a bug that prevented array 'Q', 'L' and 'I' from accepting
  big intables (objects that have __int__) as elements.

- bpo-29645: Speed up importing the webbrowser module.
  webbrowser.register() is now thread-safe.

- bpo-28231: The zipfile module now accepts path-like objects for external
  paths.

- bpo-26915: index() and count() methods of collections.abc.Sequence now
  check identity before checking equality when do comparisons.

- bpo-28682: Added support for bytes paths in os.fwalk().

- bpo-29728: Add new :data:`socket.TCP_NOTSENT_LOWAT` (Linux 3.12) constant.
  Patch by Nathaniel J. Smith.

- bpo-29623: Allow use of path-like object as a single argument in
  ConfigParser.read(). Patch by David Ellis.

- bpo-9303: Migrate sqlite3 module to _v2 API.  Patch by Aviv Palivoda.

- bpo-28963: Fix out of bound iteration in
  asyncio.Future.remove_done_callback implemented in C.

- bpo-29704: asyncio.subprocess.SubprocessStreamProtocol no longer closes
  before all pipes are closed.

- bpo-29271: Fix Task.current_task and Task.all_tasks implemented in C to
  accept None argument as their pure Python implementation.

- bpo-29703: Fix asyncio to support instantiation of new event loops in
  child processes.

- bpo-29615: SimpleXMLRPCDispatcher no longer chains KeyError (or any other
  exception) to exception(s) raised in the dispatched methods. Patch by Petr
  Motejlek.

- bpo-7769: Method register_function() of
  xmlrpc.server.SimpleXMLRPCDispatcher and its subclasses can now be used as
  a decorator.

- bpo-29376: Fix assertion error in threading._DummyThread.is_alive().

- bpo-28624: Add a test that checks that cwd parameter of Popen() accepts
  PathLike objects.  Patch by Sayan Chowdhury.

- bpo-28518: Start a transaction implicitly before a DML statement. Patch by
  Aviv Palivoda.

- bpo-29742: get_extra_info() raises exception if get called on closed ssl
  transport. Patch by Nikolay Kim.

- bpo-16285: urllib.parse.quote is now based on RFC 3986 and hence includes
  '~' in the set of characters that is not quoted by default. Patch by
  Christian Theune and Ratnadeep Debnath.

- bpo-29532: Altering a kwarg dictionary passed to functools.partial() no
  longer affects a partial object after creation.

- bpo-29110: Fix file object leak in aifc.open() when file is given as a
  filesystem path and is not in valid AIFF format. Patch by Anthony Zhang.

- bpo-22807: Add uuid.SafeUUID and uuid.UUID.is_safe to relay information
  from the platform about whether generated UUIDs are generated with a
  multiprocessing safe method.

- bpo-29576: Improve some deprecations in importlib. Some deprecated methods
  now emit DeprecationWarnings and have better descriptive messages.

- bpo-29534: Fixed different behaviour of Decimal.from_float() for _decimal
  and _pydecimal. Thanks Andrew Nester.

- bpo-10379: locale.format_string now supports the 'monetary' keyword
  argument, and locale.format is deprecated.

- bpo-29851: importlib.reload() now raises ModuleNotFoundError if the module
  lacks a spec.

- bpo-28556: Various updates to typing module: typing.Counter,
  typing.ChainMap, improved ABC caching, etc. Original PRs by Jelle
  Zijlstra, Ivan Levkivskyi, Manuel Krebber, and Łukasz Langa.

- bpo-29100: Fix datetime.fromtimestamp() regression introduced in Python
  3.6.0: check minimum and maximum years.

- bpo-29416: Prevent infinite loop in pathlib.Path.mkdir

- bpo-29444: Fixed out-of-bounds buffer access in the group() method of the
  match object. Based on patch by WGH.

- bpo-29377: Add WrapperDescriptorType, MethodWrapperType, and
  MethodDescriptorType built-in types to types module. Original patch by
  Manuel Krebber.

- bpo-29218: Unused install_misc command is now removed.  It has been
  documented as unused since 2000.  Patch by Eric N. Vander Weele.

- bpo-29368: The extend() method is now called instead of the append()
  method when unpickle collections.deque and other list-like objects. This
  can speed up unpickling to 2 times.

- bpo-29338: The help of a builtin or extension class now includes the
  constructor signature if __text_signature__ is provided for the class.

- bpo-29335: Fix subprocess.Popen.wait() when the child process has exited
  to a stopped instead of terminated state (ex: when under ptrace).

- bpo-29290: Fix a regression in argparse that help messages would wrap at
  non-breaking spaces.

- bpo-28735: Fixed the comparison of mock.MagickMock with mock.ANY.

- bpo-29197: Removed deprecated function ntpath.splitunc().

- bpo-29210: Removed support of deprecated argument "exclude" in
  tarfile.TarFile.add().

- bpo-29219: Fixed infinite recursion in the repr of uninitialized
  ctypes.CDLL instances.

- bpo-29192: Removed deprecated features in the http.cookies module.

- bpo-29193: A format string argument for string.Formatter.format() is now
  positional-only.

- bpo-29195: Removed support of deprecated undocumented keyword arguments in
  methods of regular expression objects.

- bpo-28969: Fixed race condition in C implementation of
  functools.lru_cache. KeyError could be raised when cached function with
  full cache was simultaneously called from differen threads with the same
  uncached arguments.

- bpo-20804: The unittest.mock.sentinel attributes now preserve their
  identity when they are copied or pickled.

- bpo-29142: In urllib.request, suffixes in no_proxy environment variable
  with leading dots could match related hostnames again (e.g. .b.c matches
  a.b.c). Patch by Milan Oberkirch.

- bpo-28961: Fix unittest.mock._Call helper: don't ignore the name parameter
  anymore. Patch written by Jiajun Huang.

- bpo-15812: inspect.getframeinfo() now correctly shows the first line of a
  context. Patch by Sam Breese.

- bpo-28985: Update authorizer constants in sqlite3 module. Patch by
  Dingyuan Wang.

- bpo-29079: Prevent infinite loop in pathlib.resolve() on Windows

- bpo-13051: Fixed recursion errors in large or resized
  curses.textpad.Textbox.  Based on patch by Tycho Andersen.

- bpo-9770: curses.ascii predicates now work correctly with negative
  integers.

- bpo-28427: old keys should not remove new values from WeakValueDictionary
  when collecting from another thread.

- bpo-28923: Remove editor artifacts from Tix.py.

- bpo-28871: Fixed a crash when deallocate deep ElementTree.

- bpo-19542: Fix bugs in WeakValueDictionary.setdefault() and
  WeakValueDictionary.pop() when a GC collection happens in another thread.

- bpo-20191: Fixed a crash in resource.prlimit() when passing a sequence
  that doesn't own its elements as limits.

- bpo-16255: subprocess.Popen uses /system/bin/sh on Android as the shell,
  instead of /bin/sh.

- bpo-28779: multiprocessing.set_forkserver_preload() would crash the
  forkserver process if a preloaded module instantiated some multiprocessing
  objects such as locks.

- bpo-26937: The chown() method of the tarfile.TarFile class does not fail
  now when the grp module cannot be imported, as for example on Android
  platforms.

- bpo-28847: dbm.dumb now supports reading read-only files and no longer
  writes the index file when it is not changed.  A deprecation warning is
  now emitted if the index file is missed and recreated in the 'r' and 'w'
  modes (will be an error in future Python releases).

- bpo-27030: Unknown escapes consisting of ``'\'`` and an ASCII letter in
  re.sub() replacement templates regular expressions now are errors.

- bpo-28835: Fix a regression introduced in warnings.catch_warnings(): call
  warnings.showwarning() if it was overridden inside the context manager.

- bpo-27172: To assist with upgrades from 2.7, the previously documented
  deprecation of ``inspect.getfullargspec()`` has been reversed. This
  decision may be revisited again after the Python 2.7 branch is no longer
  officially supported.

- bpo-28740: Add sys.getandroidapilevel(): return the build time API version
  of Android as an integer. Function only available on Android.

- bpo-26273: Add new :data:`socket.TCP_CONGESTION` (Linux 2.6.13) and
  :data:`socket.TCP_USER_TIMEOUT` (Linux 2.6.37) constants. Patch written by
  Omar Sandoval.

- bpo-28752: Restored the __reduce__() methods of datetime objects.

- bpo-28727: Regular expression patterns, _sre.SRE_Pattern objects created
  by re.compile(), become comparable (only x==y and x!=y operators). This
  change should fix the issue #18383: don't duplicate warning filters when
  the warnings module is reloaded (thing usually only done in unit tests).

- bpo-20572: Remove the subprocess.Popen.wait endtime parameter.  It was
  deprecated in 3.4 and undocumented prior to that.

- bpo-25659: In ctypes, prevent a crash calling the from_buffer() and
  from_buffer_copy() methods on abstract classes like Array.

- bpo-28548: In the "http.server" module, parse the protocol version if
  possible, to avoid using HTTP 0.9 in some error responses.

- bpo-19717: Makes Path.resolve() succeed on paths that do not exist. Patch
  by Vajrasky Kok

- bpo-28563: Fixed possible DoS and arbitrary code execution when handle
  plural form selections in the gettext module.  The expression parser now
  supports exact syntax supported by GNU gettext.

- bpo-28387: Fixed possible crash in _io.TextIOWrapper deallocator when the
  garbage collector is invoked in other thread.  Based on patch by Sebastian
  Cufre.

- bpo-27517: LZMA compressor and decompressor no longer raise exceptions if
  given empty data twice.  Patch by Benjamin Fogle.

- bpo-28549: Fixed segfault in curses's addch() with ncurses6.

- bpo-28449: tarfile.open() with mode "r" or "r:" now tries to open a tar
  file with compression before trying to open it without compression.
  Otherwise it had 50% chance failed with ignore_zeros=True.

- bpo-23262: The webbrowser module now supports Firefox 36+ and derived
  browsers.  Based on patch by Oleg Broytman.

- bpo-24241: The webbrowser in an X environment now prefers using the
  default browser directly. Also, the webbrowser register() function now has
  a documented 'preferred' argument, to specify browsers to be returned by
  get() with no arguments. Patch by David Steele

- bpo-27939: Fixed bugs in tkinter.ttk.LabeledScale and tkinter.Scale caused
  by representing the scale as float value internally in Tk.  tkinter.IntVar
  now works if float value is set to underlying Tk variable.

- bpo-28255: calendar.TextCalendar.prweek() no longer prints a space after a
  weeks's calendar.  calendar.TextCalendar.pryear() no longer prints
  redundant newline after a year's calendar.  Based on patch by Xiang Zhang.

- bpo-28255: calendar.TextCalendar.prmonth() no longer prints a space at the
  start of new line after printing a month's calendar.  Patch by Xiang
  Zhang.

- bpo-20491: The textwrap.TextWrapper class now honors non-breaking spaces.
  Based on patch by Kaarle Ritvanen.

- bpo-28353: os.fwalk() no longer fails on broken links.

- bpo-28430: Fix iterator of C implemented asyncio.Future doesn't accept
  non-None value is passed to it.send(val).

- bpo-27025: Generated names for Tkinter widgets now start by the "!" prefix
  for readability.

- bpo-25464: Fixed HList.header_exists() in tkinter.tix module by addin a
  workaround to Tix library bug.

- bpo-28488: shutil.make_archive() no longer adds entry "./" to ZIP archive.

- bpo-25953: re.sub() now raises an error for invalid numerical group
  reference in replacement template even if the pattern is not found in the
  string.  Error message for invalid group reference now includes the group
  index and the position of the reference. Based on patch by SilentGhost.

- bpo-28469: timeit now uses the sequence 1, 2, 5, 10, 20, 50,... instead of
  1, 10, 100,... for autoranging.

- bpo-28115: Command-line interface of the zipfile module now uses argparse.
  Added support of long options.

- bpo-18219: Optimize csv.DictWriter for large number of columns. Patch by
  Mariatta Wijaya.

- bpo-28448: Fix C implemented asyncio.Future didn't work on Windows.

- bpo-23214: In the "io" module, the argument to BufferedReader and
  BytesIO's read1() methods is now optional and can be -1, matching the
  BufferedIOBase specification.

- bpo-28480: Fix error building socket module when multithreading is
  disabled.

- bpo-28240: timeit: remove ``-c/--clock`` and ``-t/--time`` command line
  options which were deprecated since Python 3.3.

- bpo-28240: timeit now repeats the benchmarks 5 times instead of only 3 to
  make benchmarks more reliable.

- bpo-28240: timeit autorange now uses a single loop iteration if the
  benchmark takes less than 10 seconds, instead of 10 iterations. "python3
  -m timeit -s 'import time' 'time.sleep(1)'" now takes 4 seconds instead of
  40 seconds.

- Distutils.sdist now looks for README and setup.py files with case
  sensitivity. This behavior matches that found in Setuptools 6.0 and later.
  See `setuptools 100 <https://github.com/pypa/setuptools/issues/100>`_ for
  rationale.

- bpo-24452: Make webbrowser support Chrome on Mac OS X. Patch by Ned
  Batchelder.

- bpo-20766: Fix references leaked by pdb in the handling of SIGINT
  handlers.

- bpo-27998: Fixed bytes path support in os.scandir() on Windows. Patch by
  Eryk Sun.

- bpo-28317: The disassembler now decodes FORMAT_VALUE argument.

- bpo-28380: unittest.mock Mock autospec functions now properly support
  assert_called, assert_not_called, and assert_called_once.

- bpo-28229: lzma module now supports pathlib.

- bpo-28321: Fixed writing non-BMP characters with binary format in
  plistlib.

- bpo-28225: bz2 module now supports pathlib.  Initial patch by Ethan
  Furman.

- bpo-28227: gzip now supports pathlib.  Patch by Ethan Furman.

- bpo-28332: Deprecated silent truncations in socket.htons and socket.ntohs.
  Original patch by Oren Milman.

- bpo-27358: Optimized merging var-keyword arguments and improved error
  message when passing a non-mapping as a var-keyword argument.

- bpo-28257: Improved error message when passing a non-iterable as a
  var-positional argument.  Added opcode BUILD_TUPLE_UNPACK_WITH_CALL.

- bpo-28322: Fixed possible crashes when unpickle itertools objects from
  incorrect pickle data.  Based on patch by John Leitch.

- bpo-28228: imghdr now supports pathlib.

- bpo-28226: compileall now supports pathlib.

- bpo-28314: Fix function declaration (C flags) for the getiterator() method
  of xml.etree.ElementTree.Element.

- bpo-28148: Stop using localtime() and gmtime() in the time module.

  Introduced platform independent _PyTime_localtime API that is similar to
  POSIX localtime_r, but available on all platforms.  Patch by Ed Schouten.

- bpo-28253: Fixed calendar functions for extreme months: 0001-01 and
  9999-12.

  Methods itermonthdays() and itermonthdays2() are reimplemented so that
  they don't call itermonthdates() which can cause datetime.date
  under/overflow.

- bpo-28275: Fixed possible use after free in the decompress() methods of
  the LZMADecompressor and BZ2Decompressor classes. Original patch by John
  Leitch.

- bpo-27897: Fixed possible crash in sqlite3.Connection.create_collation()
  if pass invalid string-like object as a name.  Patch by Xiang Zhang.

- bpo-18844: random.choices() now has k as a keyword-only argument to
  improve the readability of common cases and come into line with the
  signature used in other languages.

- bpo-18893: Fix invalid exception handling in Lib/ctypes/macholib/dyld.py.
  Patch by Madison May.

- bpo-27611: Fixed support of default root window in the tkinter.tix module.
  Added the master parameter in the DisplayStyle constructor.

- bpo-27348: In the traceback module, restore the formatting of exception
  messages like "Exception: None".  This fixes a regression introduced in
  3.5a2.

- bpo-25651: Allow falsy values to be used for msg parameter of subTest().

- bpo-27778: Fix a memory leak in os.getrandom() when the getrandom() is
  interrupted by a signal and a signal handler raises a Python exception.

- bpo-28200: Fix memory leak on Windows in the os module (fix
  path_converter() function).

- bpo-25400: RobotFileParser now correctly returns default values for
  crawl_delay and request_rate.  Initial patch by Peter Wirtz.

- bpo-27932: Prevent memory leak in win32_ver().

- Fix UnboundLocalError in socket._sendfile_use_sendfile.

- bpo-28075: Check for ERROR_ACCESS_DENIED in Windows implementation of
  os.stat().  Patch by Eryk Sun.

- bpo-22493: Warning message emitted by using inline flags in the middle of
  regular expression now contains a (truncated) regex pattern. Patch by Tim
  Graham.

- bpo-25270: Prevent codecs.escape_encode() from raising SystemError when an
  empty bytestring is passed.

- bpo-28181: Get antigravity over HTTPS. Patch by Kaartic Sivaraam.

- bpo-25895: Enable WebSocket URL schemes in urllib.parse.urljoin. Patch by
  Gergely Imreh and Markus Holtermann.

- bpo-28114: Fix a crash in parse_envlist() when env contains byte strings.
  Patch by Eryk Sun.

- bpo-27599: Fixed buffer overrun in binascii.b2a_qp() and
  binascii.a2b_qp().

- bpo-27906: Fix socket accept exhaustion during high TCP traffic. Patch by
  Kevin Conway.

- bpo-28174: Handle when SO_REUSEPORT isn't properly supported. Patch by
  Seth Michael Larson.

- bpo-26654: Inspect functools.partial in asyncio.Handle.__repr__. Patch by
  iceboy.

- bpo-26909: Fix slow pipes IO in asyncio. Patch by INADA Naoki.

- bpo-28176: Fix callbacks race in asyncio.SelectorLoop.sock_connect.

- bpo-27759: Fix selectors incorrectly retain invalid file descriptors.
  Patch by Mark Williams.

- bpo-28325: Remove vestigial MacOS 9 macurl2path module and its tests.

- bpo-28368: Refuse monitoring processes if the child watcher has no loop
  attached. Patch by Vincent Michel.

- bpo-28369: Raise RuntimeError when transport's FD is used with add_reader,
  add_writer, etc.

- bpo-28370: Speedup asyncio.StreamReader.readexactly. Patch by Коренберг
  Марк.

- bpo-28371: Deprecate passing asyncio.Handles to run_in_executor.

- bpo-28372: Fix asyncio to support formatting of non-python coroutines.

- bpo-28399: Remove UNIX socket from FS before binding. Patch by Коренберг
  Марк.

- bpo-27972: Prohibit Tasks to await on themselves.

- bpo-24142: Reading a corrupt config file left configparser in an invalid
  state. Original patch by Florian Höch.

- bpo-29581: ABCMeta.__new__ now accepts ``**kwargs``, allowing abstract
  base classes to use keyword parameters in __init_subclass__. Patch by Nate
  Soares.

- bpo-25532: inspect.unwrap() will now only try to unwrap an object
  sys.getrecursionlimit() times, to protect against objects which create a
  new object on every attribute access.

- bpo-30177: path.resolve(strict=False) no longer cuts the path after the
  first element not present in the filesystem.  Patch by Antoine Pietri.

Documentation
-------------

- bpo-31294: Fix incomplete code snippet in the ZeroMQSocketListener and
  ZeroMQSocketHandler examples and adapt them to Python 3.

- bpo-21649: Add RFC 7525 and Mozilla server side TLS links to SSL
  documentation.

- bpo-31128: Allow the pydoc server to bind to arbitrary hostnames.

- bpo-30803: Clarify doc on truth value testing. Original patch by Peter
  Thomassen.

- bpo-30176: Add missing attribute related constants in curses
  documentation.

- bpo-30052: the link targets for :func:`bytes` and :func:`bytearray` are
  now their respective type definitions, rather than the corresponding
  builtin function entries. Use :ref:`bytes <func-bytes>` and
  :ref:`bytearray <func-bytearray>` to reference the latter.

  In order to ensure this and future cross-reference updates are applied
  automatically, the daily documentation builds now disable the default
  output caching features in Sphinx.

- bpo-26985: Add missing info of code object in inspect documentation.

- bpo-19824: Improve the documentation for, and links to, template strings
  by emphasizing their utility for internationalization, and by clarifying
  some usage constraints. (See also: bpo-20314, bpo-12518)

- bpo-28929: Link the documentation to its source file on GitHub.

- bpo-25008: Document smtpd.py as effectively deprecated and add a pointer
  to aiosmtpd, a third-party asyncio-based replacement.

- bpo-26355: Add canonical header link on each page to corresponding major
  version of the documentation. Patch by Matthias Bussonnier.

- bpo-29349: Fix Python 2 syntax in code for building the documentation.

- bpo-23722: The data model reference and the porting section in the 3.6
  What's New guide now cover the additional ``__classcell__`` handling
  needed for custom metaclasses to fully support PEP 487 and zero-argument
  ``super()``.

- bpo-28513: Documented command-line interface of zipfile.

Tests
-----

- bpo-29639: test.support.HOST is now "localhost", a new HOSTv4 constant has
  been added for your ``127.0.0.1`` needs, similar to the existing HOSTv6
  constant.

- bpo-31320: Silence traceback in test_ssl

- bpo-31346: Prefer PROTOCOL_TLS_CLIENT and PROTOCOL_TLS_SERVER protocols
  for SSLContext.

- bpo-25674: Remove sha256.tbs-internet.com ssl test

- bpo-30715: Address ALPN callback changes for OpenSSL 1.1.0f. The latest
  version behaves like OpenSSL 1.0.2 and no longer aborts handshake.

- bpo-30822: regrtest: Exclude tzdata from regrtest --all. When running the
  test suite using --use=all / -u all, exclude tzdata since it makes
  test_datetime too slow (15-20 min on some buildbots) which then times out
  on some buildbots. Fix also regrtest command line parser to allow passing
  -u extralargefile to run test_zipfile64.

- bpo-30695: Add the `set_nomemory(start, stop)` and `remove_mem_hooks()`
  functions to the _testcapi module.

- bpo-30357: test_thread: setUp() now uses support.threading_setup() and
  support.threading_cleanup() to wait until threads complete to avoid random
  side effects on following tests. Initial patch written by Grzegorz
  Grzywacz.

- bpo-30197: Enhanced functions swap_attr() and swap_item() in the
  test.support module. They now work when delete replaced attribute or item
  inside the with statement.  The old value of the attribute or item (or
  None if it doesn't exist) now will be assigned to the target of the "as"
  clause, if there is one.

- bpo-24932: Use proper command line parsing in _testembed

- bpo-28950: Disallow -j0 to be combined with -T/-l in regrtest command line
  arguments.

- bpo-28683: Fix the tests that bind() a unix socket and raise
  PermissionError on Android for a non-root user.

- bpo-26936: Fix the test_socket failures on Android - getservbyname(),
  getservbyport() and getaddrinfo() are broken on some Android API levels.

- bpo-28666: Now test.support.rmtree is able to remove unwritable or
  unreadable directories.

- bpo-23839: Various caches now are cleared before running every test file.

- bpo-26944: Fix test_posix for Android where 'id -G' is entirely wrong or
  missing the effective gid.

- bpo-28409: regrtest: fix the parser of command line arguments.

- bpo-28217: Adds _testconsole module to test console input.

- bpo-26939: Add the support.setswitchinterval() function to fix
  test_functools hanging on the Android armv7 qemu emulator.

Build
-----

- bpo-31354: Allow --with-lto to be used on all builds, not just `make
  profile-opt`.

- bpo-31370: Remove support for building --without-threads.

  This option is not really useful anymore in the 21st century. Removing
  lots of conditional paths allows us to simplify the code base, including
  in difficult to maintain low-level internal code.

- bpo-31341: Per PEP 11, support for the IRIX operating system was removed.

- bpo-30854: Fix compile error when compiling --without-threads. Patch by
  Masayuki Yamamoto.

- bpo-30687: Locate msbuild.exe on Windows when building rather than
  vcvarsall.bat

- bpo-20210: Support the *disabled* marker in Setup files. Extension modules
  listed after this marker are not built at all, neither by the Makefile nor
  by setup.py.

- bpo-29941: Add ``--with-assertions`` configure flag to explicitly enable C
  ``assert()`` checks. Defaults to off. ``--with-pydebug`` implies
  ``--with-assertions``.

- bpo-28787: Fix out-of-tree builds of Python when configured with
  ``--with--dtrace``.

- bpo-29243: Prevent unnecessary rebuilding of Python during ``make test``,
  ``make install`` and some other make targets when configured with
  ``--enable-optimizations``.

- bpo-23404: Don't regenerate generated files based on file modification
  time anymore: the action is now explicit. Replace ``make touch`` with
  ``make regen-all``.

- bpo-29643: Fix ``--enable-optimization`` didn't work.

- bpo-27593: sys.version and the platform module python_build(),
  python_branch(), and python_revision() functions now use git information
  rather than hg when building from a repo.

- bpo-29572: Update Windows build and OS X installers to use OpenSSL 1.0.2k.

- bpo-27659: Prohibit implicit C function declarations: use
  ``-Werror=implicit-function-declaration`` when possible (GCC and Clang,
  but it depends on the compiler version). Patch written by Chi Hsuan Yen.

- bpo-29384: Remove old Be OS helper scripts.

- bpo-26851: Set Android compilation and link flags.

- bpo-28768: Fix implicit declaration of function _setmode. Patch by
  Masayuki Yamamoto

- bpo-29080: Removes hard dependency on hg.exe from PCBuild/build.bat

- bpo-23903: Added missed names to PC/python3.def.

- bpo-28762: lockf() is available on Android API level 24, but the F_LOCK
  macro is not defined in android-ndk-r13.

- bpo-28538: Fix the compilation error that occurs because if_nameindex() is
  available on Android API level 24, but the if_nameindex structure is not
  defined.

- bpo-20211: Do not add the directory for installing C header files and the
  directory for installing object code libraries to the cross compilation
  search paths. Original patch by Thomas Petazzoni.

- bpo-28849: Do not define sys.implementation._multiarch on Android.

- bpo-10656: Fix out-of-tree building on AIX.  Patch by Tristan Carel and
  Michael Haubenwallner.

- bpo-26359: Rename --with-optimiations to --enable-optimizations.

- bpo-28444: Fix missing extensions modules when cross compiling.

- bpo-28208: Update Windows build and OS X installers to use SQLite 3.14.2.

- bpo-28248: Update Windows build and OS X installers to use OpenSSL 1.0.2j.

- bpo-21124: Fix building the _struct module on Cygwin by passing ``NULL``
  instead of ``&PyType_Type`` to PyVarObject_HEAD_INIT.  Patch by Masayuki
  Yamamoto.

- bpo-13756: Fix building extensions modules on Cygwin.  Patch by Roumen
  Petrov, based on original patch by Jason Tishler.

- bpo-21085: Add configure check for siginfo_t.si_band, which Cygwin does
  not provide. Patch by Masayuki Yamamoto with review and rebase by Erik
  Bray.

- bpo-28258: Fixed build with Estonian locale (python-config and distclean
  targets in Makefile).  Patch by Arfrever Frehtes Taifersar Arahesis.

- bpo-26661: setup.py now detects system libffi with multiarch wrapper.

- bpo-27979: A full copy of libffi is no longer bundled for use when
  building _ctypes on non-OSX UNIX platforms.  An installed copy of libffi
  is now required when building _ctypes on such platforms.

- bpo-15819: Remove redundant include search directory option for building
  outside the source tree.

- bpo-28676: Prevent missing 'getentropy' declaration warning on macOS.
  Patch by Gareth Rees.

Windows
-------

- bpo-31392: Update Windows build to use OpenSSL 1.1.0f

- bpo-30389: Adds detection of Visual Studio 2017 to distutils on Windows.

- bpo-31358: zlib is no longer bundled in the CPython source, instead it is
  downloaded on demand just like bz2, lzma, OpenSSL, Tcl/Tk, and SQLite.

- bpo-31340: Change to building with MSVC v141 (included with Visual Studio
  2017)

- bpo-30581: os.cpu_count() now returns the correct number of processors on
  Windows when the number of logical processors is greater than 64.

- bpo-30916: Pre-build OpenSSL, Tcl and Tk and include the binaries in the
  build.

- bpo-30731: Add a missing xmlns to python.manifest so that it matches the
  schema.

- bpo-30291: Allow requiring 64-bit interpreters from py.exe using -64
  suffix. Contributed by Steve (Gadget) Barnes.

- bpo-30362: Adds list options (-0, -0p) to py.exe launcher. Contributed by
  Steve Barnes.

- bpo-23451: Fix socket deprecation warnings in socketmodule.c. Patch by
  Segev Finer.

- bpo-30450: The build process on Windows no longer depends on Subversion,
  instead pulling external code from GitHub via a Python script.  If Python
  3.6 is not found on the system (via ``py -3.6``), NuGet is used to
  download a copy of 32-bit Python.

- bpo-29579: Removes readme.txt from the installer.

- bpo-25778: winreg does not truncate string correctly (Patch by Eryk Sun)

- bpo-28896: Deprecate WindowsRegistryFinder and disable it by default

- bpo-28522: Fixes mishandled buffer reallocation in getpathp.c

- bpo-28402: Adds signed catalog files for stdlib on Windows.

- bpo-28333: Enables Unicode for ps1/ps2 and input() prompts. (Patch by Eryk
  Sun)

- bpo-28251: Improvements to help manuals on Windows.

- bpo-28110: launcher.msi has different product codes between 32-bit and
  64-bit

- bpo-28161: Opening CON for write access fails

- bpo-28162: WindowsConsoleIO readall() fails if first line starts with
  Ctrl+Z

- bpo-28163: WindowsConsoleIO fileno() passes wrong flags to _open_osfhandle

- bpo-28164: _PyIO_get_console_type fails for various paths

- bpo-28137: Renames Windows path file to ._pth

- bpo-28138: Windows ._pth file should allow import site

IDLE
----

- bpo-31493: IDLE code context -- fix code update and font update timers.

  Canceling timers prevents a warning message when test_idle completes.

- bpo-31488: IDLE - Update non-key options in former extension classes. When
  applying configdialog changes, call .reload for each feature class. Change
  ParenMatch so updated options affect existing instances attached to
  existing editor windows.

- bpo-31477: IDLE - Improve rstrip entry in doc. Strip trailing whitespace
  strips more than blank spaces.  Multiline string literals are not skipped.

- bpo-31480: IDLE - make tests pass with zzdummy extension disabled by
  default.

- bpo-31421: Document how IDLE runs tkinter programs. IDLE calls tcl/tk
  update in the background in order to make live

  interaction and experimentation with tkinter applications much easier.

- bpo-31414: IDLE -- fix tk entry box tests by deleting first. Adding to an
  int entry is not the same as deleting and inserting because int('') will
  fail.

- bpo-31051: Rearrange IDLE configdialog GenPage into Window, Editor, and
  Help sections.

- bpo-30617: IDLE - Add docstrings and tests for outwin subclass of editor.

  Move some data and functions from the class to module level. Patch by
  Cheryl Sabella.

- bpo-31287: IDLE - Do not modify tkinter.message in test_configdialog.

- bpo-27099: Convert IDLE's built-in 'extensions' to regular features.

  About 10 IDLE features were implemented as supposedly optional extensions.
  Their different behavior could be confusing or worse for users and not
  good for maintenance.  Hence the conversion.

  The main difference for users is that user configurable key bindings for
  builtin features are now handled uniformly.  Now, editing a binding in a
  keyset only affects its value in the keyset.  All bindings are defined
  together in the system-specific default keysets in config-extensions.def.
  All custom keysets are saved as a whole in config-extension.cfg.  All take
  effect as soon as one clicks Apply or Ok.

  The affected events are '<<force-open-completions>>', '<<expand-word>>',
  '<<force-open-calltip>>', '<<flash-paren>>', '<<format-paragraph>>',
  '<<run-module>>', '<<check-module>>', and '<<zoom-height>>'.  Any (global)
  customizations made before 3.6.3 will not affect their keyset-specific
  customization after 3.6.3. and vice versa.

  Initial patch by Charles Wohlganger.

- bpo-31206: IDLE: Factor HighPage(Frame) class from ConfigDialog. Patch by
  Cheryl Sabella.

- bpo-31001: Add tests for configdialog highlight tab.  Patch by Cheryl
  Sabella.

- bpo-31205: IDLE: Factor KeysPage(Frame) class from ConfigDialog.  The
  slightly modified tests continue to pass.  Patch by Cheryl Sabella.

- bpo-31130: IDLE -- stop leaks in test_configdialog. Initial patch by
  Victor Stinner.

- bpo-31002: Add tests for configdialog keys tab. Patch by Cheryl Sabella.

- bpo-19903: IDLE: Calltips use `inspect.signature` instead of
  `inspect.getfullargspec`. This improves calltips for builtins converted to
  use Argument Clinic. Patch by Louie Lu.

- bpo-31083: IDLE - Add an outline of a TabPage class in configdialog.
  Update existing classes to match outline. Initial patch by Cheryl Sabella.

- bpo-31050: Factor GenPage(Frame) class from ConfigDialog. The slightly
  modified tests continue to pass. Patch by Cheryl Sabella.

- bpo-31004: IDLE - Factor FontPage(Frame) class from ConfigDialog.

  Slightly modified tests continue to pass. Fix General tests. Patch mostly
  by Cheryl Sabella.

- bpo-30781: IDLE - Use ttk widgets in ConfigDialog. Patches by Terry Jan
  Reedy and Cheryl Sabella.

- bpo-31060: IDLE - Finish rearranging methods of ConfigDialog Grouping
  methods pertaining to each tab and the buttons will aid writing tests and
  improving the tabs and will enable splitting the groups into classes.

- bpo-30853: IDLE -- Factor a VarTrace class out of ConfigDialog.

  Instance tracers manages pairs consisting of a tk variable and a callback
  function.  When tracing is turned on, setting the variable calls the
  function.  Test coverage for the new class is 100%.

- bpo-31003: IDLE: Add more tests for General tab.

- bpo-30993: IDLE - Improve configdialog font page and tests.

  In configdialog: Document causal pathways in create_font_tab docstring.
  Simplify some attribute names. Move set_samples calls to var_changed_font
  (idea from Cheryl Sabella).  Move related functions to positions after the
  create widgets function.

  In test_configdialog: Fix test_font_set so not order dependent.  Fix
  renamed test_indent_scale so it tests the widget.  Adjust tests for
  movement of set_samples call.  Add tests for load functions.  Put all font
  tests in one class and tab indent tests in another.  Except for two lines,
  these tests completely cover the related functions.

- bpo-30981: IDLE -- Add more configdialog font page tests.

- bpo-28523: IDLE: replace 'colour' with 'color' in configdialog.

- bpo-30917: Add tests for idlelib.config.IdleConf. Increase coverage from
  46% to 96%. Patch by Louie Lu.

- bpo-30934: Document coverage details for idlelib tests.

  * Add section to idlelib/idle-test/README.txt.

  * Include check that branches are taken both ways.

  * Exclude IDLE-specific code that does not run during unit tests.

- bpo-30913: IDLE: Document ConfigDialog tk Vars, methods, and widgets in
  docstrings This will facilitate improving the dialog and splitting up the
  class. Original patch by Cheryl Sabella.

- bpo-30899: IDLE: Add tests for ConfigParser subclasses in config. Patch by
  Louie Lu.

- bpo-30881: IDLE: Add docstrings to browser.py. Patch by Cheryl Sabella.

- bpo-30851: IDLE: Remove unused variables in configdialog.  One is a
  duplicate, one is set but cannot be altered by users. Patch by Cheryl
  Sabella.

- bpo-30870: IDLE: In Settings dialog, select font with Up, Down keys as
  well as mouse. Initial patch by Louie Lu.

- bpo-8231: IDLE: call config.IdleConf.GetUserCfgDir only once.

- bpo-30779: IDLE: Factor ConfigChanges class from configdialog, put in
  config; test. * In config, put dump test code in a function; run it and
  unittest in   'if __name__ == '__main__'. * Add class config.ConfigChanges
  based on changes_class_v4.py on bpo issue. * Add class
  test_config.ChangesTest, partly using configdialog_tests_v1.py. * Revise
  configdialog to use ConfigChanges; see tracker msg297804. * Revise
  test_configdialog to match configdialog changes. * Remove configdialog
  functions unused or moved to ConfigChanges. Cheryl Sabella contributed
  parts of the patch.

- bpo-30777: IDLE: configdialog - Add docstrings and fix comments. Patch by
  Cheryl Sabella.

- bpo-30495: IDLE: Improve textview with docstrings, PEP8 names, and more
  tests. Patch by Cheryl Sabella.

- bpo-30723: IDLE: Make several improvements to parenmatch. Add 'parens'
  style to highlight both opener and closer. Make 'default' style, which is
  not default, a synonym for 'opener'. Make time-delay work the same with
  all styles. Add help for config dialog extensions tab, including help for
  parenmatch. Add new tests.  Original patch by Charles Wohlganger.

- bpo-30674: IDLE: add docstrings to grep module. Patch by Cheryl Sabella

- bpo-21519: IDLE's basic custom key entry dialog now detects duplicates
  properly. Original patch by Saimadhav Heblikar.

- bpo-29910: IDLE no longer deletes a character after commenting out a
  region by a key shortcut.  Add ``return 'break'`` for this and other
  potential conflicts between IDLE and default key bindings.

- bpo-30728: Review and change idlelib.configdialog names. Lowercase method
  and attribute names. Replace 'colour' with 'color', expand overly cryptic
  names, delete unneeded underscores. Replace ``import *`` with specific
  imports. Patches by Cheryl Sabella.

- bpo-6739: IDLE: Verify user-entered key sequences by trying to bind them
  with tk. Add tests for all 3 validation functions. Original patch by G
  Polo.  Tests added by Cheryl Sabella.

- bpo-15786: Fix several problems with IDLE's autocompletion box. The
  following should now work: clicking on selection box items; using the
  scrollbar; selecting an item by hitting Return. Hangs on MacOSX should no
  longer happen. Patch by Louie Lu.

- bpo-25514: Add doc subsubsection about IDLE failure to start. Popup
  no-connection message directs users to this section.

- bpo-30642: Fix reference leaks in IDLE tests. Patches by Louie Lu and
  Terry Jan Reedy.

- bpo-30495: Add docstrings for textview.py and use PEP8 names. Patches by
  Cheryl Sabella and Terry Jan Reedy.

- bpo-30290: Help-about: use pep8 names and add tests. Increase coverage to
  100%. Patches by Louie Lu, Cheryl Sabella, and Terry Jan Reedy.

- bpo-30303: Add _utest option to textview; add new tests. Increase coverage
  to 100%. Patches by Louie Lu and Terry Jan Reedy.

- bpo-29071: IDLE colors f-string prefixes (but not invalid ur prefixes).

- bpo-28572: Add 10% to coverage of IDLE's test_configdialog. Update and
  augment description of the configuration system.

Tools/Demos
-----------

- bpo-30983: gdb integration commands (py-bt, etc.) work on optimized shared
  builds now, too.  PEP 523 introduced _PyEval_EvalFrameDefault which
  inlines PyEval_EvalFrameEx on non-debug shared builds.  This broke the
  ability to use py-bt, py-up, and a few other Python-specific gdb
  integrations. The problem is fixed by only looking for
  _PyEval_EvalFrameDefault frames in python-gdb.py.  Original patch by Bruno
  "Polaco" Penteado.

- bpo-29748: Added the slice index converter in Argument Clinic.

- bpo-24037: Argument Clinic now uses the converter `bool(accept={int})`
  rather than `int` for semantical booleans.  This avoids repeating the
  default value for Python and C and will help in converting to `bool` in
  future.

- bpo-29367: python-gdb.py now supports also ``method-wrapper``
  (``wrapperobject``) objects.

- bpo-28023: Fix python-gdb.py didn't support new dict implementation.

- bpo-15369: The pybench and pystone microbenchmark have been removed from
  Tools. Please use the new Python benchmark suite
  https://github.com/python/performance which is more reliable and includes
  a portable version of pybench working on Python 2 and Python 3.

- bpo-28102: The zipfile module CLI now prints usage to stderr. Patch by
  Stephen J. Turnbull.

C API
-----

- bpo-31338: Added the ``Py_UNREACHABLE()`` macro for code paths which are
  never expected to be reached.  This and a few other useful macros are now
  documented in the C API manual.

- bpo-30832: Remove own implementation for thread-local storage.

  CPython has provided the own implementation for thread-local storage (TLS)
  on Python/thread.c, it's used in the case which a platform has not
  supplied native TLS.  However, currently all supported platforms (Windows
  and pthreads) have provided native TLS and defined the Py_HAVE_NATIVE_TLS
  macro with unconditional in any case.

- bpo-30708: PyUnicode_AsWideCharString() now raises a ValueError if the
  second argument is NULL and the wchar_t\* string contains null characters.

- bpo-16500: Deprecate PyOS_AfterFork() and add PyOS_BeforeFork(),
  PyOS_AfterFork_Parent() and PyOS_AfterFork_Child().

- bpo-6532: The type of results of PyThread_start_new_thread() and
  PyThread_get_thread_ident(), and the id parameter of
  PyThreadState_SetAsyncExc() changed from "long" to "unsigned long".

- bpo-27867: Function PySlice_GetIndicesEx() is deprecated and replaced with
  a macro if Py_LIMITED_API is not set or set to the value between
  0x03050400 and 0x03060000 (not including) or 0x03060100 or higher.  Added
  functions PySlice_Unpack() and PySlice_AdjustIndices().

- bpo-29083: Fixed the declaration of some public API functions.
  PyArg_VaParse() and PyArg_VaParseTupleAndKeywords() were not available in
  limited API. PyArg_ValidateKeywordArguments(), PyArg_UnpackTuple() and
  Py_BuildValue() were not available in limited API of version < 3.3 when
  PY_SSIZE_T_CLEAN is defined.

- bpo-28769: The result of PyUnicode_AsUTF8AndSize() and PyUnicode_AsUTF8()
  is now of type ``const char *`` rather of ``char *``.

- bpo-29058: All stable API extensions added after Python 3.2 are now
  available only when Py_LIMITED_API is set to the PY_VERSION_HEX value of
  the minimum Python version supporting this API.

- bpo-28822: The index parameters *start* and *end* of PyUnicode_FindChar()
  are now adjusted to behave like ``str[start:end]``.

- bpo-28808: PyUnicode_CompareWithASCIIString() now never raises exceptions.

- bpo-28761: The fields name and doc of structures PyMemberDef, PyGetSetDef,
  PyStructSequence_Field, PyStructSequence_Desc, and wrapperbase are now of
  type ``const char *`` rather of ``char *``.

- bpo-28748: Private variable _Py_PackageContext is now of type ``const char
  *`` rather of ``char *``.

- bpo-19569: Compiler warnings are now emitted if use most of deprecated
  functions.

- bpo-28426: Deprecated undocumented functions PyUnicode_AsEncodedObject(),
  PyUnicode_AsDecodedObject(), PyUnicode_AsDecodedUnicode() and
  PyUnicode_AsEncodedUnicode().


What's New in Python 3.6.6 final?
=================================

*Release date: 2018-06-27*

There were no new changes in version 3.6.6.



What's New in Python 3.6.6 release candidate 1?
===============================================

*Release date: 2018-06-11*

Core and Builtins
-----------------

- bpo-33786: Fix asynchronous generators to handle GeneratorExit in athrow()
  correctly

- bpo-30654: Fixed reset of the SIGINT handler to SIG_DFL on interpreter
  shutdown even when there was a custom handler set previously. Patch by
  Philipp Kerling.

- bpo-33622: Fixed a leak when the garbage collector fails to add an object
  with the ``__del__`` method or referenced by it into the
  :data:`gc.garbage` list. :c:func:`PyGC_Collect` can now be called when an
  exception is set and preserves it.

- bpo-31849: Fix signed/unsigned comparison warning in pyhash.c.

- bpo-33391: Fix a leak in set_symmetric_difference().

- bpo-28055: Fix unaligned accesses in siphash24(). Patch by Rolf Eike Beer.

- bpo-33231: Fix potential memory leak in ``normalizestring()``.

- bpo-29922: Improved error messages in 'async with' when ``__aenter__()``
  or ``__aexit__()`` return non-awaitable object.

- bpo-33199: Fix ``ma_version_tag`` in dict implementation is uninitialized
  when copying from key-sharing dict.

- bpo-33041: Fixed jumping when the function contains an ``async for`` loop.

- bpo-32282: Fix an unnecessary ifdef in the include of VersionHelpers.h in
  socketmodule on Windows.

- bpo-21983: Fix a crash in `ctypes.cast()` in case the type argument is a
  ctypes structured data type. Patch by Eryk Sun and Oren Milman.

Library
-------

- bpo-30167: Prevent site.main() exception if PYTHONSTARTUP is set. Patch by
  Steve Weber.

- bpo-33812: Datetime instance d with non-None tzinfo, but with
  d.tzinfo.utcoffset(d) returning None is now treated as naive by the
  astimezone() method.

- bpo-30805: Avoid race condition with debug logging

- bpo-33767: The concatenation (``+``) and repetition (``*``) sequence
  operations now raise :exc:`TypeError` instead of :exc:`SystemError` when
  performed on :class:`mmap.mmap` objects.  Patch by Zackery Spytz.

- bpo-32684: Fix gather to propagate cancellation of itself even with
  return_exceptions.

- bpo-33674: Fix a race condition in SSLProtocol.connection_made() of
  asyncio.sslproto: start immediately the handshake instead of using
  call_soon(). Previously, data_received() could be called before the
  handshake started, causing the handshake to hang or fail.

- bpo-31647: Fixed bug where calling write_eof() on a
  _SelectorSocketTransport after it's already closed raises AttributeError.

- bpo-33672: Fix Task.__repr__ crash with Cython's bogus coroutines

- bpo-33469: Fix RuntimeError after closing loop that used run_in_executor

- bpo-11874: Use a better regex when breaking usage into wrappable parts.
  Avoids bogus assertion errors from custom metavar strings.

- bpo-30877: Fixed a bug in the Python implementation of the JSON decoder
  that prevented the cache of parsed strings from clearing after finishing
  the decoding. Based on patch by c-fos.

- bpo-33548: tempfile._candidate_tempdir_list should consider common TEMP
  locations

- bpo-33542: Prevent ``uuid.get_node`` from using a DUID instead of a MAC on
  Windows. Patch by Zvi Effron

- bpo-26819: Fix race condition with `ReadTransport.resume_reading` in
  Windows proactor event loop.

- bpo-28556: Minor fixes in typing module: add annotations to
  ``NamedTuple.__new__``, pass ``*args`` and ``**kwds`` in
  ``Generic.__new__``.  Original PRs by Paulius Šarka and Chad Dombrova.

- bpo-20087: Updated alias mapping with glibc 2.27 supported locales.

- bpo-33422: Fix trailing quotation marks getting deleted when looking up
  byte/string literals on pydoc. Patch by Andrés Delfino.

- bpo-33197: Update error message when constructing invalid
  inspect.Parameters Patch by Dong-hee Na.

- bpo-33383: Fixed crash in the get() method of the :mod:`dbm.ndbm` database
  object when it is called with a single argument.

- bpo-33329: Fix multiprocessing regression on newer glibcs

- bpo-991266: Fix quoting of the ``Comment`` attribute of
  :class:`http.cookies.SimpleCookie`.

- bpo-33131: Upgrade bundled version of pip to 10.0.1.

- bpo-33308: Fixed a crash in the :mod:`parser` module when converting an ST
  object to a tree of tuples or lists with ``line_info=False`` and
  ``col_info=True``.

- bpo-33263: Fix FD leak in `_SelectorSocketTransport`  Patch by Vlad
  Starostin.

- bpo-33256: Fix display of ``<module>`` call in the html produced by
  ``cgitb.html()``. Patch by Stéphane Blondon.

- bpo-33203: ``random.Random.choice()`` now raises ``IndexError`` for empty
  sequences consistently even when called from subclasses without a
  ``getrandbits()`` implementation.

- bpo-33224: Update difflib.mdiff() for PEP 479.  Convert an uncaught
  StopIteration in a generator into a return-statement.

- bpo-33209: End framing at the end of C implementation of
  :func:`pickle.Pickler.dump`.

- bpo-32861: The urllib.robotparser's ``__str__`` representation now
  includes wildcard entries and the "Crawl-delay" and "Request-rate" fields.
  Patch by Michael Lazar.

- bpo-33096: Allow ttk.Treeview.insert to insert iid that has a false
  boolean value. Note iid=0 and iid=False would be same. Patch by Garvit
  Khatri.

- bpo-33127: The ssl module now compiles with LibreSSL 2.7.1.

- bpo-33021: Release the GIL during fstat() calls, avoiding hang of all
  threads when calling mmap.mmap(), os.urandom(), and random.seed().  Patch
  by Nir Soffer.

- bpo-27683: Fix a regression in :mod:`ipaddress` that result of
  :meth:`hosts` is empty when the network is constructed by a tuple
  containing an integer mask and only 1 bit left for addresses.

- bpo-32844: Fix wrong redirection of a low descriptor (0 or 1) to stderr in
  subprocess if another low descriptor is closed.

- bpo-31908: Fix output of cover files for ``trace`` module command-line
  tool. Previously emitted cover files only when ``--missing`` option was
  used. Patch by Michael Selik.

- bpo-31457: If nested log adapters are used, the inner ``process()``
  methods are no longer omitted.

- bpo-16865: Support arrays >=2GiB in :mod:`ctypes`.  Patch by Segev Finer.

- bpo-31238: pydoc: the stop() method of the private ServerThread class now
  waits until DocServer.serve_until_quit() completes and then explicitly
  sets its docserver attribute to None to break a reference cycle.

Documentation
-------------

- bpo-33503: Fix broken pypi link

- bpo-33421: Add missing documentation for ``typing.AsyncContextManager``.

- bpo-33378: Add Korean language switcher for https://docs.python.org/3/

- bpo-33276: Clarify that the ``__path__`` attribute on modules cannot be
  just any value.

- bpo-33201: Modernize documentation for writing C extension types.

- bpo-33195: Deprecate ``Py_UNICODE`` usage in ``c-api/arg`` document.
  ``Py_UNICODE`` related APIs are deprecated since Python 3.3, but it is
  missed in the document.

- bpo-33126: Document PyBuffer_ToContiguous().

- bpo-27212: Modify documentation for the :func:`islice` recipe to consume
  initial values up to the start index.

- bpo-28247: Update :mod:`zipapp` documentation to describe how to make
  standalone applications.

- bpo-18802: Documentation changes for ipaddress.  Patch by Jon Foster and
  Berker Peksag.

- bpo-27428: Update documentation to clarify that ``WindowsRegistryFinder``
  implements ``MetaPathFinder``. (Patch by Himanshu Lakhara)

- bpo-8243: Add a note about curses.addch and curses.addstr exception
  behavior when writing outside a window, or pad.

- bpo-31432: Clarify meaning of CERT_NONE, CERT_OPTIONAL, and CERT_REQUIRED
  flags for ssl.SSLContext.verify_mode.

Tests
-----

- bpo-33655: Ignore test_posix_fallocate failures on BSD platforms that
  might be due to running on ZFS.

- bpo-19417: Add test_bdb.py.

Build
-----

- bpo-5755: Move ``-Wstrict-prototypes`` option to ``CFLAGS_NODIST`` from
  ``OPT``. This option emitted annoying warnings when building extension
  modules written in C++.

- bpo-33614: Ensures module definition files for the stable ABI on Windows
  are correctly regenerated.

- bpo-33522: Enable CI builds on Visual Studio Team Services at
  https://python.visualstudio.com/cpython

- bpo-33012: Add ``-Wno-cast-function-type`` for gcc 8 for silencing
  warnings about function casts like casting to PyCFunction in method
  definition lists.

- bpo-33394: Enable the verbose build for extension modules, when GNU make
  is passed macros on the command line.

Windows
-------

- bpo-33184: Update Windows installer to OpenSSL 1.0.2o.

macOS
-----

- bpo-33184: Update macOS installer build to use OpenSSL 1.0.2o.

IDLE
----

- bpo-33656: On Windows, add API call saying that tk scales for DPI. On
  Windows 8.1+ or 10, with DPI compatibility properties of the Python binary
  unchanged, and a monitor resolution greater than 96 DPI, this should make
  text and lines sharper.  It should otherwise have no effect.

- bpo-33768: Clicking on a context line moves that line to the top of the
  editor window.

- bpo-33763: IDLE: Use read-only text widget for code context instead of
  label widget.

- bpo-33664: Scroll IDLE editor text by lines. Previously, the mouse wheel
  and scrollbar slider moved text by a fixed number of pixels, resulting in
  partial lines at the top of the editor box.  The change also applies to
  the shell and grep output windows, but not to read-only text views.

- bpo-33679: Enable theme-specific color configuration for Code Context. Use
  the Highlights tab to see the setting for built-in themes or add settings
  to custom themes.

- bpo-33642: Display up to maxlines non-blank lines for Code Context. If
  there is no current context, show a single blank line.

- bpo-33628: IDLE: Cleanup codecontext.py and its test.

- bpo-33564: IDLE's code context now recognizes async as a block opener.

- bpo-29706: IDLE now colors async and await as keywords in 3.6. They become
  full keywords in 3.7.

- bpo-21474: Update word/identifier definition from ascii to unicode. In
  text and entry boxes, this affects selection by double-click, movement
  left/right by control-left/right, and deletion left/right by
  control-BACKSPACE/DEL.

- bpo-33204: IDLE: consistently color invalid string prefixes. A 'u' string
  prefix cannot be paired with either 'r' or 'f'. Consistently color as much
  of the prefix, starting at the right, as is valid. Revise and extend
  colorizer test.

- bpo-32831: Add docstrings and tests for codecontext.

Tools/Demos
-----------

- bpo-33189: :program:`pygettext.py` now recognizes only literal strings as
  docstrings and translatable strings, and rejects bytes literals and
  f-string expressions.

- bpo-31920: Fixed handling directories as arguments in the ``pygettext``
  script. Based on patch by Oleg Krasnikov.

- bpo-29673: Fix pystackv and pystack gdbinit macros.

- bpo-32885: Add an ``-n`` flag for ``Tools/scripts/pathfix.py`` to disable
  automatic backup creation (files with ``~`` suffix).

- bpo-31583: Fix 2to3 for using with --add-suffix option but without
  --output-dir option for relative path to files in current directory.

C API
-----

- bpo-32374: Document that m_traverse for multi-phase initialized modules
  can be called with m_state=NULL, and add a sanity check


What's New in Python 3.6.5 final?
=================================

*Release date: 2018-03-28*

Tests
-----

- bpo-32872: Avoid regrtest compatibility issue with namespace packages.

Build
-----

- bpo-33163: Upgrade pip to 9.0.3 and setuptools to v39.0.1.


What's New in Python 3.6.5 release candidate 1?
===============================================

*Release date: 2018-03-13*

Security
--------

- bpo-33001: Minimal fix to prevent buffer overrun in os.symlink on Windows

- bpo-32981: Regexes in difflib and poplib were vulnerable to catastrophic
  backtracking. These regexes formed potential DOS vectors (REDOS). They
  have been refactored. This resolves CVE-2018-1060 and CVE-2018-1061. Patch
  by Jamie Davis.

Core and Builtins
-----------------

- bpo-33026: Fixed jumping out of "with" block by setting f_lineno.

- bpo-17288: Prevent jumps from 'return' and 'exception' trace events.

- bpo-32889: Update Valgrind suppression list to account for the rename of
  ``Py_ADDRESS_IN_RANG`` to ``address_in_range``.

- bpo-32650: Pdb and other debuggers dependent on bdb.py will correctly step
  over (next command) native coroutines. Patch by Pablo Galindo.

- bpo-32685: Improve suggestion when the Python 2 form of print statement is
  either present on the same line as the header of a compound statement or
  else terminated by a semi-colon instead of a newline. Patch by Nitish
  Chandra.

- bpo-32583: Fix possible crashing in builtin Unicode decoders caused by
  write out-of-bound errors when using customized decode error handlers.

- bpo-26163: Improved frozenset() hash to create more distinct hash values
  when faced with datasets containing many similar values.

- bpo-27169: The ``__debug__`` constant is now optimized out at compile
  time. This fixes also bpo-22091.

- bpo-32329: ``sys.flags.hash_randomization`` is now properly set to 0 when
  hash randomization is turned off by ``PYTHONHASHSEED=0``.

- bpo-30416: The optimizer is now protected from spending much time doing
  complex calculations and consuming much memory for creating large
  constants in constant folding.

- bpo-18533: ``repr()`` on a dict containing its own ``values()`` or
  ``items()`` no longer raises ``RecursionError``; OrderedDict similarly.
  Instead, use ``...``, as for other recursive structures.  Patch by Ben
  North.

- bpo-32028: Leading whitespace is now correctly ignored when generating
  suggestions for converting Py2 print statements to Py3 builtin print
  function calls. Patch by Sanyam Khurana.

- bpo-32137: The repr of deeply nested dict now raises a RecursionError
  instead of crashing due to a stack overflow.

Library
-------

- bpo-33064: lib2to3 now properly supports trailing commas after ``*args``
  and ``**kwargs`` in function signatures.

- bpo-31804: Avoid failing in multiprocessing.Process if the standard
  streams are closed or None at exit.

- bpo-33037: Skip sending/receiving data after SSL transport closing.

- bpo-30353: Fix ctypes pass-by-value for structs on 64-bit Cygwin/MinGW.

- bpo-33009: Fix inspect.signature() for single-parameter partialmethods.

- bpo-32969: Expose several missing constants in zlib and fix corresponding
  documentation.

- bpo-32713: Fixed tarfile.itn handling of out-of-bounds float values. Patch
  by Joffrey Fuhrer.

- bpo-30622: The ssl module now detects missing NPN support in LibreSSL.

- bpo-32922: dbm.open() now encodes filename with the filesystem encoding
  rather than default encoding.

- bpo-32859: In ``os.dup2``, don't check every call whether the ``dup3``
  syscall exists or not.

- bpo-21060: Rewrite confusing message from setup.py upload from "No dist
  file created in earlier command" to the more helpful "Must create and
  upload files in one command".

- bpo-32857: In :mod:`tkinter`, ``after_cancel(None)`` now raises a
  :exc:`ValueError` instead of canceling the first scheduled function.
  Patch by Cheryl Sabella.

- bpo-32852: Make sure sys.argv remains as a list when running trace.

- bpo-32841: Fixed `asyncio.Condition` issue which silently ignored
  cancellation after notifying and cancelling a conditional lock. Patch by
  Bar Harel.

- bpo-31787: Fixed refleaks of ``__init__()`` methods in various modules.
  (Contributed by Oren Milman)

- bpo-30157: Fixed guessing quote and delimiter in csv.Sniffer.sniff() when
  only the last field is quoted.  Patch by Jake Davis.

- bpo-32394: socket: Remove TCP_FASTOPEN, TCP_KEEPCNT flags on older version
  Windows during run-time.

- bpo-32777: Fix a rare but potential pre-exec child process deadlock in
  subprocess on POSIX systems when marking file descriptors inheritable on
  exec in the child process.  This bug appears to have been introduced in
  3.4.

- bpo-32647: The ctypes module used to depend on indirect linking for
  dlopen. The shared extension is now explicitly linked against libdl on
  platforms with dl.

- bpo-32734: Fixed ``asyncio.Lock()`` safety issue which allowed acquiring
  and locking the same lock multiple times, without it being free. Patch by
  Bar Harel.

- bpo-32727: Do not include name field in SMTP envelope from address. Patch
  by Stéphane Wirtel

- bpo-27931: Fix email address header parsing error when the username is an
  empty quoted string. Patch by Xiang Zhang.

- bpo-32304: distutils' upload command no longer corrupts tar files ending
  with a CR byte, and no longer tries to convert CR to CRLF in any of the
  upload text fields.

- bpo-32502: uuid.uuid1 no longer raises an exception if a 64-bit hardware
  address is encountered.

- bpo-31848: Fix the error handling in Aifc_read.initfp() when the SSND
  chunk is not found. Patch by Zackery Spytz.

- bpo-32555: On FreeBSD and Solaris, os.strerror() now always decode the
  byte string from the current locale encoding, rather than using
  ASCII/surrogateescape in some cases.

- bpo-32521: The nis module is now compatible with new libnsl and headers
  location.

- bpo-32473: Improve ABCMeta._dump_registry() output readability

- bpo-32521: glibc has removed Sun RPC. Use replacement libtirpc headers and
  library in nis module.

- bpo-32228: Ensure that ``truncate()`` preserves the file position (as
  reported by ``tell()``) after writes longer than the buffer size.

- bpo-26133: Don't unsubscribe signals in asyncio UNIX event loop on
  interpreter shutdown.

- bpo-32185: The SSL module no longer sends IP addresses in SNI TLS
  extension on platforms with OpenSSL 1.0.2+ or inet_pton.

- bpo-32323: :func:`urllib.parse.urlsplit()` does not convert zone-id
  (scope) to lower case for scoped IPv6 addresses in hostnames now.

- bpo-32302: Fix bdist_wininst of distutils for CRT v142: it binary
  compatible with CRT v140.

- bpo-32255: A single empty field is now always quoted when written into a
  CSV file. This allows to distinguish an empty row from a row consisting of
  a single empty field. Patch by Licht Takeuchi.

- bpo-32277: Raise ``NotImplementedError`` instead of ``SystemError`` on
  platforms where ``chmod(..., follow_symlinks=False)`` is not supported.
  Patch by Anthony Sottile.

- bpo-32199: The getnode() ip getter now uses 'ip link' instead of 'ip link
  list'.

- bpo-27456: Ensure TCP_NODELAY is set on Linux. Tests by Victor Stinner.

- bpo-31900: The :func:`locale.localeconv` function now sets temporarily the
  ``LC_CTYPE`` locale to the ``LC_NUMERIC`` locale to decode
  ``decimal_point`` and ``thousands_sep`` byte strings if they are non-ASCII
  or longer than 1 byte, and the ``LC_NUMERIC`` locale is different than the
  ``LC_CTYPE`` locale. This temporary change affects other threads.

  Same change for the :meth:`str.format` method when formatting a number
  (:class:`int`, :class:`float`, :class:`float` and subclasses) with the
  ``n`` type (ex: ``'{:n}'.format(1234)``).

- bpo-31802: Importing native path module (``posixpath``, ``ntpath``) now
  works even if the ``os`` module still is not imported.

Documentation
-------------

- bpo-17232: Clarify docs for -O and -OO.  Patch by Terry Reedy.

- bpo-32800: Update link to w3c doc for xml default namespaces.

- bpo-8722: Document :meth:`__getattr__` behavior when property :meth:`get`
  method raises :exc:`AttributeError`.

- bpo-32614: Modify RE examples in documentation to use raw strings to
  prevent :exc:`DeprecationWarning` and add text to REGEX HOWTO to highlight
  the deprecation.

- bpo-31972: Improve docstrings for `pathlib.PurePath` subclasses.

- bpo-17799: Explain real behaviour of sys.settrace and sys.setprofile and
  their C-API counterparts regarding which type of events are received in
  each function. Patch by Pablo Galindo Salgado.

Tests
-----

- bpo-32517: Fix failing ``test_asyncio`` on macOS 10.12.2+ due to transport
  of ``KqueueSelector`` loop was not being closed.

- bpo-32721: Fix test_hashlib to not fail if the _md5 module is not built.

- bpo-32252: Fix faulthandler_suppress_crash_report() used to prevent core
  dump files when testing crashes. getrlimit() returns zero on success.

- bpo-31518: Debian Unstable has disabled TLS 1.0 and 1.1 for
  SSLv23_METHOD(). Change TLS/SSL protocol of some tests to PROTOCOL_TLS or
  PROTOCOL_TLSv1_2 to make them pass on Debian.

Build
-----

- bpo-32635: Fix segfault of the crypt module when libxcrypt is provided
  instead of libcrypt at the system.

Windows
-------

- bpo-33016: Fix potential use of uninitialized memory in
  nt._getfinalpathname

- bpo-32903: Fix a memory leak in os.chdir() on Windows if the current
  directory is set to a UNC path.

- bpo-31966: Fixed WindowsConsoleIO.write() for writing empty data.

- bpo-32409: Ensures activate.bat can handle Unicode contents.

- bpo-32457: Improves handling of denormalized executable path when
  launching Python.

- bpo-32370: Use the correct encoding for ipconfig output in the uuid
  module. Patch by Segev Finer.

- bpo-29248: Fix :func:`os.readlink` on Windows, which was mistakenly
  treating the ``PrintNameOffset`` field of the reparse data buffer as a
  number of characters instead of bytes. Patch by Craig Holmquist and SSE4.

- bpo-32588: Create standalone _distutils_findvs module.

macOS
-----

- bpo-32726: Provide an additional, more modern macOS installer variant that
  supports macOS 10.9+ systems in 64-bit mode only. Upgrade the supplied
  third-party libraries to OpenSSL 1.0.2n, XZ 5.2.3, and SQLite 3.22.0. The
  10.9+ installer now links with and supplies its own copy of Tcl/Tk 8.6.8.

IDLE
----

- bpo-32984: Set ``__file__`` while running a startup file.  Like Python,
  IDLE optionally runs one startup file in the Shell window before
  presenting the first interactive input prompt.  For IDLE, ``-s`` runs a
  file named in environmental variable  :envvar:`IDLESTARTUP` or
  :envvar:`PYTHONSTARTUP`; ``-r file`` runs ``file``.  Python sets
  ``__file__`` to the startup file name before running the file and unsets
  it before the first prompt.  IDLE now does the same when run normally,
  without the ``-n`` option.

- bpo-32940: Simplify and rename StringTranslatePseudoMapping in pyparse.

- bpo-32916: Change ``str`` to ``code`` in pyparse.

- bpo-32905: Remove unused code in pyparse module.

- bpo-32874: Add tests for pyparse.

- bpo-32837: Using the system and place-dependent default encoding for
  open() is a bad idea for IDLE's system and location-independent files.

- bpo-32826: Add "encoding=utf-8" to open() in IDLE's test_help_about. GUI
  test test_file_buttons() only looks at initial ascii-only lines, but
  failed on systems where open() defaults to 'ascii' because readline()
  internally reads and decodes far enough ahead to encounter a non-ascii
  character in CREDITS.txt.

- bpo-32765: Update configdialog General tab docstring to add new widgets to
  the widget list.

Tools/Demos
-----------

- bpo-24960: 2to3 and lib2to3 can now read pickled grammar files using
  pkgutil.get_data() rather than probing the filesystem. This lets 2to3 and
  lib2to3 work when run from a zipfile.

- bpo-32222: Fix pygettext not extracting docstrings for functions with type
  annotated arguments. Patch by Toby Harradine.

C API
-----

- bpo-29084: Undocumented C API for OrderedDict has been excluded from the
  limited C API. It was added by mistake and actually never worked in the
  limited C API.


What's New in Python 3.6.4 final?
=================================

*Release date: 2017-12-18*

There were no new code changes in version 3.6.4 since v3.6.4rc1.



What's New in Python 3.6.4 release candidate 1?
===============================================

*Release date: 2017-12-05*

Core and Builtins
-----------------

- bpo-32176: co_flags.CO_NOFREE is now always set correctly by the code
  object constructor based on freevars and cellvars, rather than needing to
  be set correctly by the caller. This ensures it will be cleared
  automatically when additional cell references are injected into a modified
  code object and function.

- bpo-31949: Fixed several issues in printing tracebacks
  (PyTraceBack_Print()).

  * Setting sys.tracebacklimit to 0 or less now suppresses printing tracebacks.
  * Setting sys.tracebacklimit to None now causes using the default limit.
  * Setting sys.tracebacklimit to an integer larger than LONG_MAX now means using
    the limit LONG_MAX rather than the default limit.
  * Fixed integer overflows in the case of more than 2**31 traceback items on
    Windows.
  * Fixed output errors handling.

- bpo-30696: Fix the interactive interpreter looping endlessly when no
  memory.

- bpo-20047: Bytearray methods partition() and rpartition() now accept only
  bytes-like objects as separator, as documented.  In particular they now
  raise TypeError rather of returning a bogus result when an integer is
  passed as a separator.

- bpo-31852: Fix a segmentation fault caused by a combination of the async
  soft keyword and continuation lines.

- bpo-21720: BytesWarning no longer emitted when the *fromlist* argument of
  ``__import__()`` or the ``__all__`` attribute of the module contain bytes
  instances.

- bpo-31825: Fixed OverflowError in the 'unicode-escape' codec and in
  codecs.escape_decode() when decode an escaped non-ascii byte.

- bpo-28603: Print the full context/cause chain of exceptions on interpreter
  exit, even if an exception in the chain is unhashable or compares equal to
  later ones. Patch by Zane Bitter.

- bpo-31786: Fix timeout rounding in the select module to round correctly
  negative timeouts between -1.0 and 0.0. The functions now block waiting
  for events as expected. Previously, the call was incorrectly non-blocking.
  Patch by Pablo Galindo.

- bpo-31642: Restored blocking "from package import module" by setting
  sys.modules["package.module"] to None.

- bpo-31626: Fixed a bug in debug memory allocator.  There was a write to
  freed memory after shrinking a memory block.

- bpo-31619: Fixed a ValueError when convert a string with large number of
  underscores to integer with binary base.

- bpo-31592: Fixed an assertion failure in Python parser in case of a bad
  `unicodedata.normalize()`. Patch by Oren Milman.

- bpo-31588: Raise a `TypeError` with a helpful error message when class
  creation fails due to a metaclass with a bad ``__prepare__()`` method.
  Patch by Oren Milman.

- bpo-31566: Fix an assertion failure in `_warnings.warn()` in case of a bad
  ``__name__`` global. Patch by Oren Milman.

- bpo-31505: Fix an assertion failure in `json`, in case
  `_json.make_encoder()` received a bad `encoder()` argument. Patch by Oren
  Milman.

- bpo-31492: Fix assertion failures in case of failing to import from a
  module with a bad ``__name__`` attribute, and in case of failing to access
  an attribute of such a module. Patch by Oren Milman.

- bpo-31490: Fix an assertion failure in `ctypes` class definition, in case
  the class has an attribute whose name is specified in ``_anonymous_`` but
  not in ``_fields_``. Patch by Oren Milman.

- bpo-31478: Fix an assertion failure in `_random.Random.seed()` in case the
  argument has a bad ``__abs__()`` method. Patch by Oren Milman.

- bpo-31315: Fix an assertion failure in imp.create_dynamic(), when
  spec.name is not a string. Patch by Oren Milman.

- bpo-31311: Fix a crash in the ``__setstate__()`` method of
  `ctypes._CData`, in case of a bad ``__dict__``. Patch by Oren Milman.

- bpo-31293: Fix crashes in true division and multiplication of a timedelta
  object by a float with a bad as_integer_ratio() method. Patch by Oren
  Milman.

- bpo-31285: Fix an assertion failure in `warnings.warn_explicit`, when the
  return value of the received loader's get_source() has a bad splitlines()
  method. Patch by Oren Milman.

- bpo-30817: `PyErr_PrintEx()` clears now the ignored exception that may be
  raised by `_PySys_SetObjectId()`, for example when no memory.

Library
-------

- bpo-28556: Two minor fixes for ``typing`` module: allow shallow copying
  instances of generic classes, improve interaction of ``__init_subclass__``
  with generics. Original PRs by Ivan Levkivskyi.

- bpo-27240: The header folding algorithm for the new email policies has
  been rewritten, which also fixes bpo-30788, bpo-31831, and bpo-32182.  In
  particular, RFC2231 folding is now done correctly.

- bpo-32186: io.FileIO.readall() and io.FileIO.read() now release the GIL
  when getting the file size. Fixed hang of all threads with inaccessible
  NFS server. Patch by Nir Soffer.

- bpo-12239: Make :meth:`msilib.SummaryInformation.GetProperty` return
  ``None`` when the value of property is ``VT_EMPTY``.  Initial patch by
  Mark Mc Mahon.

- bpo-31325: Fix wrong usage of :func:`collections.namedtuple` in the
  :meth:`RobotFileParser.parse() <urllib.robotparser.RobotFileParser.parse>`
  method.

  Initial patch by Robin Wellner.

- bpo-12382: :func:`msilib.OpenDatabase` now raises a better exception
  message when it couldn't open or create an MSI file.  Initial patch by
  William Tisäter.

- bpo-32110: ``codecs.StreamReader.read(n)`` now returns not more than *n*
  characters/bytes for non-negative *n*. This makes it compatible with
  ``read()`` methods of other file-like objects.

- bpo-32072: Fixed issues with binary plists:

  * Fixed saving bytearrays.
  * Identical objects will be saved only once.
  * Equal references will be load as identical objects.
  * Added support for saving and loading recursive data structures.

- bpo-32034: Make asyncio.IncompleteReadError and LimitOverrunError
  pickleable.

- bpo-32015: Fixed the looping of asyncio in the case of reconnection the
  socket during waiting async read/write from/to the socket.

- bpo-32011: Restored support of loading marshal files with the TYPE_INT64
  code. These files can be produced in Python 2.7.

- bpo-31970: Reduce performance overhead of asyncio debug mode.

- bpo-9678: Fixed determining the MAC address in the uuid module:

  * Using ifconfig on NetBSD and OpenBSD.
  * Using arp on Linux, FreeBSD, NetBSD and OpenBSD.

  Based on patch by Takayuki Shimizukawa.

- bpo-30057: Fix potential missed signal in signal.signal().

- bpo-31933: Fix Blake2 params leaf_size and node_offset on big endian
